<?php
class CarsGroup
{
    public $cargroupid;
    public $code;
    public $title;
    public $title_lang;
    public $description;
    public $description_lang;
    public $description2;
    public $description2_lang;
    public $sort;
    public $typ;
    public $category = array();
    public $group_image;
    public $ext_image;
    public $rate;
    public $available = true;
    public $availability_plan = array();
    public $kategorie_text;
    public $characteristics = array();
    public $date_time_prev = array('0', '0');
    public $date_time_next = array('0', '0');
    public $groupImageHardlink = false;
    public $group_slider_images = array();
    public $offer = false;
    public $firstGroup = false;

    public function __construct($group_code = '', $offer = false, $firstGroup = false)
    {
        if (!empty($group_code)) {
            $DBCarGroup = new DBCarGroup();
            $dbObj = $DBCarGroup->getGroupByCode($group_code);
            if (!empty($dbObj->gruppe)) {
                $this->cargroupid = $dbObj->gruppe;
                $this->code = $dbObj->gruppe;
                $this->title = $dbObj->Beschreibung_WEB;
                $this->description = $dbObj->text_web;
                $this->description2 = $dbObj->KFZ_KATEGORIE_TEXT;
                $this->typ = $dbObj->kfzart;
                $this->category = explode(';', $dbObj->kfzkategorie);
                $this->kategorie_text = $dbObj->KFZ_KATEGORIE_TEXT;

                $this->characteristics = $DBCarGroup->getGroupCharacteristics($this->cargroupid);

                $this->offer = $offer;
                $this->firstGroup = $firstGroup;

                $dbTranslate = new DBTranslate();
                $translate = $dbTranslate->loadTranslations('GRUPPE', Session::getLang());
                if (!empty($translate['TITLE'][md5($this->code)])) {
                    $this->title_lang = $translate['TITLE'][md5($this->code)];
                } else {
                    $this->title_lang = $this->title;
                }

                if (!empty($translate['DESCRIPTION'][md5($this->code)])) {
                    $this->description_lang = $translate['DESCRIPTION'][md5($this->code)];
                } else {
                    $this->description_lang = $this->description;
                }

                if (!empty($translate['DESCRIPTION2'][md5($this->code)])) {
                    $this->description2_lang = $translate['DESCRIPTION2'][md5($this->code)];
                } else {
                    $this->description2_lang = $this->description2;
                }

                $this->group_image = SITEURL . 'images/groups/' . $this->code . '/group/440/';

                $this->group_slider_images = $DBCarGroup->getImageGroupURIs($this->cargroupid, 'image_name', '/group_image/440/');

                # Hardlinks für die Bilder ziehen
                if (count($this->group_slider_images) > 0) {
                    foreach ($this->group_slider_images as $indexKey => $dataArray) {
                        $this->group_slider_images[$indexKey]['hardLink'] = $this->generateGroupImages($dataArray['image_name']);
                    }
                }
            }
        }
    }

    public function generateGroupImages($imgControllerString = '')
    {
        if (strlen($imgControllerString) > 0) {
            $arguments = explode('/', $imgControllerString);

            if (count($arguments) != 4) {
                return false;
            }
        } else {
            return false;
        }

        if (isset($arguments[0]) && trim($arguments[0]) != '') {
            if (isset($arguments[1]) && ($arguments[1] == 'group' || $arguments[1] == 'group_image' || $arguments[1] == 'ext')) {
                $image_type = $arguments[1];
                $image_pk = isset($arguments[3]) ? trim($arguments[3]) : 0;
                $group_code = trim($arguments[0]);
                $images_path = 'images/groups/' . $group_code . '/';
                $groupFolder = MODUL_PATH . $images_path;
                $img_width = (int) $arguments[2] > 0 ? (int) $arguments[2] : 0;
                $image_data = false;

                $DBCarGroup = new DBCarGroup();
                if ($arguments[1] !== 'group_image') {
                    $image_data = $DBCarGroup->getImage($group_code, $image_type);
                } elseif ($arguments[1] === 'group_image') {
                    $image_ident = $DBCarGroup->getImageGroup($group_code, $image_pk, $image_type, true);
                }

                $imageFileName = $groupFolder . $image_ident . '_' . $img_width . '_' . '.jpg';
                if (!file_exists($imageFileName)) {
                    $image_data = $DBCarGroup->getImageGroup($group_code, $image_pk, $image_type);
                    $ControllerImages = new ControllerImages();

                    if (isset($image_data) && $image_data !== false) {
                        $params = array(
                            'imgData' => $image_data,
                            'width' => $img_width,
                            'uri' => $imageFileName,
                        );
                        if ($ControllerImages->createImgFile($params)) {
                            return $imageFileName;
                        } else {
                            return false;
                        }
                    } else {
                        return false;
                    }
                } else {
                    $image_data = file_get_contents($imageFileName);
                }

                $hardFileName = SITEURL . $images_path . $image_ident . '_' . $img_width . '_' . '.jpg';
                $this->expandCarGroupWithImageFileName($hardFileName);

                return $hardFileName;
            }
            return false;
        }
        return false;
    }

    /**
     *   Fügt den Dateinamen des Bildes ins CarGroup-Objekt hinzu,
     *   damit dieses dann in den eMails als Hardlink verwendet werden kann.
     **/
    private function expandCarGroupWithImageFileName($imageFileName)
    {
        if (!$this->groupImageHardlink) {
            $this->groupImageHardlink = $imageFileName;
        }
    }
} // Class CarsGroup.php
