<?php
class ConCardis
{
    private $PSPID;
    private $MODE;
    private $BGCOLOR;
    private $TXTCOLOR;
    private $TBLBGCOLOR;
    private $TBLTXTCOLOR;
    private $BUTTONBGCOLOR;
    private $BUTTONTXTCOLOR;
    private $FONTTYPE;
    private $LOGO;
    private $ACCEPTURL;
    private $DECLINEURL;
    private $EXCEPTIONURL;
    private $CANCELURL;
    private $BACKURL;

    public $HOMEURL;
    public $SIGNATUR;
    public $ORDERID;
    public $AMOUNT;
    public $CURRENCY;
    public $LANGUAGE;
    public $TITLE;
    public $CN;
    public $EMAIL;
    public $OWNERZIP;
    public $OWNERADDRESS;
    public $OWNERTOWN;
    public $OWNERCTY;
    public $OWNERTELNO;

    public function __construct()
    {
        $params = new Params();

        $this->PSPID = $params->getValue('CONCARDIS_PSPID');
        $this->SIGNATUR = $params->getValue('CONCARDIS_SIGNATUR_IN');
        $this->MODE = $params->getValue('CONCARDIS_MODE') == 1 ? "prod" : "test";
        $this->BGCOLOR = $params->getValue('CONCARDIS_BGCOLOR');
        $this->TXTCOLOR = $params->getValue('CONCARDIS_TXTCOLOR');
        $this->TBLBGCOLOR = $params->getValue('CONCARDIS_TBLBGCOLOR');
        $this->TBLTXTCOLOR = $params->getValue('CONCARDIS_TBLTXTCOLOR');
        $this->BUTTONBGCOLOR = $params->getValue('CONCARDIS_BUTTONBGCOLOR');
        $this->BUTTONTXTCOLOR = $params->getValue('CONCARDIS_BUTTONTXTCOLOR');
        $this->FONTTYPE = $params->getValue('CONCARDIS_FONTTYPE');
        $this->LOGO = $params->getValue('CONCARDIS_LOGO');

        $this->ACCEPTURL = SITEURL . 'payprocess/concardis';
        $this->DECLINEURL = SITEURL . 'step5';
        $this->EXCEPTIONURL = SITEURL . 'step5';
        $this->CANCELURL = SITEURL . 'step5';
        $this->BACKURL = SITEURL . 'step5';
    }

    public function sendRequest()
    {
        if (!empty($this->PSPID) &&
            !empty($this->SIGNATUR) &&
            !empty($this->ORDERID) &&
            !empty($this->AMOUNT) &&
            !empty($this->CURRENCY) &&
            !empty($this->LANGUAGE) &&
            !empty($this->TITLE) &&
            !empty($this->CN) &&
            !empty($this->EMAIL) &&
            !empty($this->OWNERZIP) &&
            !empty($this->OWNERADDRESS) &&
            !empty($this->OWNERTOWN) &&
            !empty($this->OWNERCTY) &&
            !empty($this->OWNERTELNO)
        ) {
            $param = array();
            $param["PSPID"] = $this->PSPID;
            $param["ORDERID"] = $this->ORDERID;
            $param["AMOUNT"] = $this->AMOUNT;
            $param["CURRENCY"] = $this->CURRENCY;
            $param["LANGUAGE"] = $this->LANGUAGE;
            $param["TITLE"] = iconv('UTF-8', 'iso-8859-1', $this->TITLE);
            $param["BGCOLOR"] = $this->BGCOLOR;
            $param["TXTCOLOR"] = $this->TXTCOLOR;
            $param["TBLBGCOLOR"] = $this->TBLBGCOLOR;
            $param["TBLTXTCOLOR"] = $this->TBLTXTCOLOR;
            $param["BUTTONBGCOLOR"] = $this->BUTTONBGCOLOR;
            $param["BUTTONTXTCOLOR"] = $this->BUTTONTXTCOLOR;
            $param["FONTTYPE"] = $this->FONTTYPE;
            $param["LOGO"] = $this->LOGO;
            $param["ACCEPTURL"] = $this->ACCEPTURL;
            $param["DECLINEURL"] = $this->DECLINEURL;
            $param["EXCEPTIONURL"] = $this->EXCEPTIONURL;
            $param["CANCELURL"] = $this->CANCELURL;
            $param["BACKURL"] = $this->BACKURL;
            $param["HOMEURL"] = $this->HOMEURL;
            $param["CN"] = $this->CN;
            $param["EMAIL"] = $this->EMAIL;
            $param["OWNERZIP"] = $this->OWNERZIP;
            $param["OWNERADDRESS"] = $this->OWNERADDRESS;
            $param["OWNERTOWN"] = $this->OWNERTOWN;
            $param["OWNERCTY"] = $this->OWNERCTY;
            $param["OWNERTELNO"] = $this->OWNERTELNO;

            ksort($param);

            $data = '';
            $sha1 = '';
            foreach ($param as $key => $val) {
                $data .= '&' . $key . '=' . urlencode($val);
                $sha1 .= strtoupper($key) . '=' . $val . $this->SIGNATUR;
            }

            $data = trim($data, '&');
            $data .= '&SHASIGN=' . strtoupper(sha1($sha1));

            header('location: https://secure.payengine.de/ncol/' . $this->MODE . '/orderstandard.asp?' . $data);
            exit;
        } else {
            return false;
        }
    }
} // ConCardis
