<?php

class NextPK extends DBBase
{
    private $default_pks = ['TMP_KUNDE' => 900000000, 'INET_RES_NO' => 2000000000];

    public function getCurrent($table)
    {
        $this->getDatabase()->prepare('SELECT TOP 1 PK FROM dbo.next_pks WHERE Tablename = :tablename');
        $this->getDatabase()->bindValue(':tablename', $table);
        $this->getDatabase()->execute();
        $row = $this->getDatabase()->fetch_assoc();

        return !empty($row) ? $row['PK'] : null;
    } // getCurrent()

    public function setDefault($table)
    {
        $next_pk = $this->getCurrent($table);
        if (is_null($next_pk)) {
            if (key_exists(strtoupper($table), $this->default_pks)) {
                $next_pk = $this->default_pks[strtoupper($table)];
            } else {
                $next_pk = 1;
            }
            $this->db->prepare('INSERT INTO dbo.next_pks ( Tablename, PK ) VALUES  ( :tablename, ' . (int) $next_pk . ')');
            $this->db->bindValue(':tablename', strtoupper($table));
            $this->db->execute();
        }

        return $next_pk;
    } // setDefault()

    public function getNext($table)
    {
        $next_pk = $this->getCurrent($table);
        if (is_null($next_pk)) {
            $next_pk = $this->setDefault($table);
        } else {
            $next_pk++;
            $this->db->prepare('UPDATE dbo.next_pks SET PK = ' . (int) $next_pk . ' WHERE Tablename = :tablename))');
            $this->db->bindValue(':tablename', strtoupper($table));
            $this->db->execute();
        }

        return $next_pk;
    } //getNext()
}
