<?php
class DBAngebote extends DBBase
{
    public function getAngebote($kat)
    {
        $angebote = array();

        $sql = 'EXEC INET_GET_ANG_DATA @kat = :kat';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':kat', $kat);
        $this->getDatabase()->execute();

        $i = 0;
        $rows = $this->getDatabase()->fetch_all();
        $Format = new Format();
        $ControllerImages = new ControllerImages();
        $ControllerLibs = new ControllerLibs();

        $step = Params::getValue('ORM_OPENTIMES_INTERVALBETWEEN_HOURS');

        $actualTime = new DateTime();

        $actualMinutes = $actualTime->format('i');

        $modifiedTime = (ceil($actualMinutes / $step) * $step) % 60;

        $translate = $ControllerImages->loadTranslations(array(
            'crent.ratedata',
        ));

        foreach ($rows as $row) {
            //$angebote[$i]['BILD'] = $row['BILD'];
            $angebote[$i]['PRICE'] = $Format->currencyFormat($row['PRICE']); // AK 13.04.2018 Aufgabe 94249: Preisformatierung nicht mehr im template sondern über die Formatklasse
            $angebote[$i]['BESCH3'] = $row['BESCH3'];
            $angebote[$i]['BUCHUNG_VON'] = $row['BUCHUNG_VON'];
            $angebote[$i]['BUCHUNG_BIS'] = $row['BUCHUNG_BIS'];
            $angebote[$i]['PKRATE'] = $row['PKRATE'];
            $angebote[$i]['Einheit'] = $row['Einheit'];
            $angebote[$i]['FREIKM'] = $row['FREIKM'];
            $angebote[$i]['STATIONS'] = $this->getStations($row['PKRATE']);
            $angebote[$i]['ENDDATE'] = null;
            $angebote[$i]['STARTDATE'] = null;
            $angebote[$i]['GRUPPE'] = $row['Gruppe'];
            $angebote[$i]['RATE'] = $row['RatenCode'];

            $angebote[$i]['HEADER'] = isset($translate['crent.ratedata']['' . $row['RatenCode'] . '.' . $row['Gruppe'] . '.offer_caption']) ? $translate['crent.ratedata']['' . $row['RatenCode'] . '.' . $row['Gruppe'] . '.offer_caption'] : $row['HEADER'];
            $angebote[$i]['BESCH2'] = isset($translate['crent.ratedata']['' . $row['RatenCode'] . '.' . $row['Gruppe'] . '.offer_description']) ? $translate['crent.ratedata']['' . $row['RatenCode'] . '.' . $row['Gruppe'] . '.offer_description'] : $row['BESCH2'];

            $angebote[$i]['IMAGE'] = $ControllerImages->angebot($row['PKRATE']);

            $sql = 'SELECT * FROM RECH_EINHEITEN WHERE Einheit = :unit';
            $this->db->prepare($sql);
            $this->db->bindValue(':unit', $angebote[$i]['Einheit']);
            $this->db->execute();

            $unit = $this->db->fetch_assoc();

            if ($row['GUEL_START_ZEITRAUM'] != null && $row['GUEL_END_ZEITRAUM'] != null) {
                $angebote[$i]['GUEL_START_ZEITRAUM'] = new DateTime($row['GUEL_START_ZEITRAUM']);

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['STARTDATE'] = $angebote[$i]['GUEL_START_ZEITRAUM']->getTimestamp();

                $angebote[$i]['GUEL_END_ZEITRAUM'] = new DateTime($row['GUEL_END_ZEITRAUM']);
                $angebote[$i]['GUEL_END_ZEITRAUM']->modify("+" . $row['GUEL_MIN_MIETZEIT'] . "days");

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['ENDDATE'] = $angebote[$i]['GUEL_END_ZEITRAUM']->getTimestamp();

                //gültig zwischen 2 tagen
            } elseif ($row['GUEL_MIN_START_TAG'] != null) {
                if ($row['GUEL_MIN_START_ZEIT'] == null) {
                    $row['GUEL_MIN_START_ZEIT'] = '00' . $modifiedTime;
                }

                $starttime = substr($row['GUEL_MIN_START_ZEIT'], 0, 2) . ":" . substr($row['GUEL_MIN_START_ZEIT'], 2, 2);
                $endtime = $starttime; //substr($row['GUEL_MIN_END_ZEIT'], 0, 2) . ":" . substr($row['GUEL_MIN_END_ZEIT'], 2, 2);

                switch ($row['GUEL_MIN_START_TAG']) {
                    case 'Mo':
                        $weekday = 'next monday';
                        break;
                    case 'Di':
                        $weekday = 'next tuesday';
                        break;
                    case 'Mi':
                        $weekday = 'next wednesday';
                        break;
                    case 'Do':
                        $weekday = 'next thursday';
                        break;
                    case 'Fr':
                        $weekday = 'next friday';
                        break;
                    case 'Sa':
                        $weekday = 'next saturday';
                        break;
                    case 'So':
                        $weekday = 'next sunday';
                        break;
                    default:
                        $weekday = 'next monday';
                        break;
                }

                switch ($row['GUEL_MAX_START_TAG']) {
                    case 'Mo':
                        $weekdayEnd = 'next monday';
                        break;
                    case 'Di':
                        $weekdayEnd = 'next tuesday';
                        break;
                    case 'Mi':
                        $weekdayEnd = 'next wednesday';
                        break;
                    case 'Do':
                        $weekdayEnd = 'next thursday';
                        break;
                    case 'Fr':
                        $weekdayEnd = 'next friday';
                        break;
                    case 'Sa':
                        $weekdayEnd = 'next saturday';
                        break;
                    case 'So':
                        $weekdayEnd = 'next sunday';
                        break;
                    default:
                        $weekdayEnd = 'next monday';
                        break;
                }

                $tmpEndDate = new DateTime(date('Y-m-d', strtotime($weekdayEnd)) . $endtime);

                $angebote[$i]['STARTDATE'] = new DateTime(date('Y-m-d', strtotime($weekday)) . $starttime);

                if ($angebote[$i]['STARTDATE'] > $tmpEndDate) {
                    $angebote[$i]['STARTDATE'] = new DateTime(date_format(new DateTime(), "Y-m-d H:" . $modifiedTime));
                }

                $angebote[$i]['ENDDATE'] = clone $angebote[$i]['STARTDATE'];

                $angebote[$i]['ENDDATE']->modify('+' . (int) (1 / $unit['Umrechnungsfaktor'] * 24) . 'hours');

                $oeffnungsZeitenResult = $ControllerLibs->getOpeningTimesForPHP($angebote[$i]['STATIONS'][0], $angebote[$i]['STATIONS'][0], $angebote[$i]['STARTDATE']->getTimestamp(), $angebote[$i]['ENDDATE']->getTimestamp());

                $angebote[$i]['STARTDATE'] = strtotime($oeffnungsZeitenResult[0]['selected_start_date']);
                $angebote[$i]['ENDDATE'] = strtotime($oeffnungsZeitenResult[0]['selected_end_date']);
            } else {
                $angebote[$i]['STARTDATE'] = new DateTime(date_format(new DateTime(), "Y-m-d H:" . $modifiedTime));

                $angebote[$i]['ENDDATE'] = clone $angebote[$i]['STARTDATE'];
                $angebote[$i]['ENDDATE']->modify('+' . (int) (1 / $unit['Umrechnungsfaktor'] * 24) . 'hours');

                $oeffnungsZeitenResult = $ControllerLibs->getOpeningTimesForPHP($angebote[$i]['STATIONS'][0], $angebote[$i]['STATIONS'][0], $angebote[$i]['STARTDATE']->getTimestamp(), $angebote[$i]['ENDDATE']->getTimestamp());

                $angebote[$i]['STARTDATE'] = strtotime($oeffnungsZeitenResult[0]['selected_start_date']);
                $angebote[$i]['ENDDATE'] = strtotime($oeffnungsZeitenResult[0]['selected_end_date']);
            }

            $i++;
        }

        return $angebote;
    } //getAngebote($kat)

    public function getStations($angpk)
    {
        $stations = array();
        $sql = "SELECT * FROM dbo.GET_ANGEBOTE_STATIONS(:ANGEBOTPK)";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':ANGEBOTPK', $angpk);
        $this->getDatabase()->execute();

        while ($row = $this->getDatabase()->fetch_assoc()) {
            $stations[] = $row['PKStation'];
        }
        return $stations;
    } // getStations()

    public function getBild($pk)
    {
        $this->getDatabase()->query("EXEC dbo.INET_GET_ANG_DATA_BY_PK @PKRATE = " . intval($pk));
        $row = $this->getDatabase()->fetch_assoc();
        return (!empty($row['BILD']) ? $row['BILD'] : null);
    } //getBild($pk)
}
