<?php
class DBHolidays extends DBBase
{
    public function getAll($region)
    {
        $holidays = array();
        if (!empty($region)) {
            $sql = 'SELECT *
                    FROM Feiertage
                    WHERE blk = :blk AND Datum >= convert(date, GETDATE())
                    ORDER BY Datum';
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':blk', $region);
            $result = $this->getDatabase()->execute();

            if ($result !== false) {
                while ($row = $this->getDatabase()->fetch_assoc()) {
                    $holidays[] = array('date' => date('d.m.Y', strtotime($row['Datum'])), 'name' => $row['Feiertag']);
                }
            }
        }
        return $holidays;
    } // getAll($region)
} // Class DBHolidays
