<?php

class ControllerConfirm extends ControllerBase
{
    public function index()
    {
        $_SESSION['STEP'] = 6;

        $confirm_content_cache = Cache::getConfirmContent();
        if (!empty($confirm_content_cache)) {
            echo $confirm_content_cache;
            exit;
        }

        $translate = $this->loadTranslations(array('USERDATA', 'CONFIRM', 'FZG', 'RATE', 'RENTAL', 'Wochentage', 'Wochentage_kurz', 'Monate_kurz', 'RESERVATE', 'GLOBAL', 'LOGIN_BAR', 'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'STEP6', 'STATION_BLOCK', 'STATION', 'STATION_DETAILS', 'EXTRAS', 'TARIF'));

        $car_group = Session::getCarGroup();
        $start_date_time = new DateTime;
        $start_date_time->setTimestamp(Session::getStartDateTime());
        $end_date_time = new DateTime;
        $end_date_time->setTimestamp(Session::getEndDateTime());
        $user = Session::getCustomer();
        $start_station = Session::getStartStation();
        $end_station = Session::getEndStation();

        $js_array = array('iframeResizer.contentWindow.js');
        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        $template = $this->template;
        $template->assign('JS_FILES', $js_array);

        $pay = (isset($_SESSION['DATA']['pay']) && is_a(unserialize($_SESSION['DATA']['pay']), 'PayArts')) ?
        unserialize($_SESSION['DATA']['pay']) : '';

        $resnummer = isset($_SESSION['DATA']['reservnummer']) ? $_SESSION['DATA']['reservnummer'] : '';

        $cacheCurrency = Cache::getCurrency();
        $currency = new Currency();
        $currency->decodeFromDb($cacheCurrency);

        $total_price = isset($_SESSION['DATA']['total_price']) ? $_SESSION['DATA']['total_price'] : '';

        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $total_price_netto = isset($_SESSION['DATA']['total_price_netto']) ? $_SESSION['DATA']['total_price_netto'] : '';

        $rate_primary = isset($_SESSION['DATA']['rates']['primary']) ?
        unserialize($_SESSION['DATA']['rates']['primary']) : array();

        $rate_options = isset($_SESSION['DATA']['rates']['subrates']['options']) ?
        unserialize($_SESSION['DATA']['rates']['subrates']['options']) : array();
        if (isset($rate_options[0]) && !is_a($rate_options[0], 'Rate')) {
            $rate_options = array();
        }
        $name_template = $user->firstname . '&nbsp;' . $user->lastname;

        $dateTimeFormat = new DateTimeFormat();
        foreach ($start_station->shedules as &$val) {
            $val->btime = $dateTimeFormat->getTime($val->btime);
            $val->etime = $dateTimeFormat->getTime($val->etime);
            $val->mbtime = $dateTimeFormat->getTime($val->mbtime);
            $val->metime = $dateTimeFormat->getTime($val->metime);
        }
        unset($val);
        foreach ($end_station->shedules as &$val) {
            $val->btime = $dateTimeFormat->getTime($val->btime);
            $val->etime = $dateTimeFormat->getTime($val->etime);
            $val->mbtime = $dateTimeFormat->getTime($val->mbtime);
            $val->metime = $dateTimeFormat->getTime($val->metime);
        }
        unset($val);

        $dateTimeFormat = new DateTimeFormat();
        $date = array('date_dep' => $start_date_time->format($dateTimeFormat->getDateFormat()),
            'date_arr' => $end_date_time->format($dateTimeFormat->getDateFormat()),
            'time_dep' => $start_date_time->format($dateTimeFormat->getTimeFormat()),
            'time_arr' => $end_date_time->format($dateTimeFormat->getTimeFormat()),
        );
        $template->assign('DATE', $date);
        $module = new Module();

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $inet_suz_text = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP5');
        $inet_info = $dbText->getTextByStation($station->code, 'INET_INFO');
        $inet_info2 = $dbText->getTextByStation($station->code, 'INET_INFO2');

        $inet_suz_text->mem = isset($inet_suz_text->mem) ? $inet_suz_text->mem : 'INET_ZUS_TEXT_STEP5';
        $inet_info->mem = isset($inet_info->mem) ? $inet_info->mem : 'INET_INFO';
        $inet_info2->mem = isset($inet_info2->mem) ? $inet_info2->mem : 'INET_INFO2';

        $template->assign('MESSAGES', !empty($_SESSION['MESSAGES']) ? $_SESSION['MESSAGES'] : array());
        $template->assign('ERROR', $this->error);
        $template->assign('TRANSLATE', $translate);
        $template->assign('TITLE', isset($translate['STEP6']['SITETITLE']) ? $translate['STEP6']['SITETITLE'] : 'STEP6.SITETITLE');
        $template->assign('FIRST_PAGE', FIRST_PAGE);
        $template->assign('STARTSTATION', $start_station);
        $template->assign('ENDSTATION', $end_station);
        $template->assign('STARTDATE', $start_date_time->format($dateTimeFormat->getDateFormat()));
        $template->assign('ENDDATE', $end_date_time->format($dateTimeFormat->getDateFormat()));
        $template->assign('STARTTIME', $start_date_time->format($dateTimeFormat->getTimeFormat()));
        $template->assign('ENDTIME', $end_date_time->format($dateTimeFormat->getTimeFormat()));
        $template->assign('USER', $user);
        $template->assign('RESERVNUMMER', $resnummer);
        $template->assign('PAY', $pay);
        $template->assign('CAR', $car_group);
        $template->assign('TOTAL_PRICE', $total_price);
        $template->assign('LOGIN', false);

        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $template->assign('TOTAL_PRICE_NETTO', $total_price_netto);
        $template->assign('CURRENCY', $currency);
        $template->assign('RATE_PRIMARY', $rate_primary);
        $template->assign('SUBRATES_OPTIONS', $rate_options);
        // $template->assign('USER_NAME_TEMPLATE', ($user->isCompany ? $user->firma : $name_template));
        $template->assign('SID', session_id());
        $template->assign('DISCOUNT_CODE', !empty($_SESSION['DATA']['discount']['code']) ?
            $_SESSION['DATA']['discount']['code'] : '');
        // $template->assign('BEMERKUNG', $_SESSION['DATA']['bemerkung']);
        $template->assign('INET_ZUS_TEXT', $inet_suz_text->mem);
        $template->assign('INET_INFO', $inet_info->mem);
        $template->assign('INET_INFO2', $inet_info2->mem);

        $template->assign('LANG', $this->registry->lang);
        $template->assign('NAVI_STEP', 6);
        $html = $template->fetch('global_template.html');

        Cache::setConfirmContent($html);
        $this->SessionClear();

        echo $html;
    }
    // index()

    private function SessionClear()
    {
        $customer = Session::getCustomer();

        $isLoggedIn = false;
        if (isset($_SESSION['DATA']['login']['isLoggedIn']) and $_SESSION['DATA']['login']['isLoggedIn'] == true) {
            $isLoggedIn = true;
        }

        // YM : $_SESSION['DATA'] soll gelöscht sein!!!
        $clear_arr = array('POST', 'CARS', 'MESSAGES', 'PAY_PENDING', 'DATA');
        foreach ($clear_arr as $idx) {
            if (isset($_SESSION[$idx])) {
                $_SESSION[$idx] = array();
                unset($_SESSION[$idx]);
            }
        }

        if ($isLoggedIn) {
            $_SESSION['DATA']['login']['isLoggedIn'] = true;
        }

        Session::setCustomer($customer);
        $_SESSION['CACHE']['RentalHash'] = '';
        // ML Benutzer bleibt angemeldet, wenn er sich eingeloggt hat
    }
    // SessionClear()
}
// Class ControllerConfirm
