<?php
class ControllerMail extends ControllerBase
{
    public function index()
    {
    }

    public function test()
    {
        $this->httpDigestAuth();

        $template = $this->template;

        $template->assign('SMTP_SERVER', Params::getValue('SMAIL_SERVER'));
        $template->assign('SMTP_PORT', Params::getValue('SMAIL_SMTP_PORT'));
        $template->assign('SMTP_SENDER', Params::getValue('SINET_MAIL_FROM'));
        $template->assign('SMTP_SENDERNAME', Params::getValue('SINET_MAIL_FROM_NAME'));
        $template->assign('SMTP_USER', Params::getValue('SMAIL_SMTP_USER'));
        $template->assign('SMTP_PASS', Params::getValue('SMAIL_SMTP_PW'));

        $template->display('mail_test.html');
    }

    public function sendTest()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] !== 'XMLHttpRequest') {
            die('This feature ist blocked!');
        }

        $Mail = new Mail();
        $Mail->SMTPDebug = SMTP::DEBUG_CONNECTION;
        $Mail->Debugoutput = 'html';

        $result = '';

        if (strlen(trim($_GET['receiver'])) == 0 or !filter_var(trim($_GET['receiver']), FILTER_VALIDATE_EMAIL)) {
            $result .= 'No valid mail address';
        } else {
            if ($Mail->Send(trim($_GET['receiver']), 'Test mail subject', 'Test mail body')) {
                $result .= 'Test succeeded. Test mail has been sent.';
            } else {
                $result .= 'Test failed: ' . "\r\n" . $Mail->ErrorInfo();
                $result .= "\r\n" . print_r($Mail, true);
            }
        }

        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
            $this->json_headers();
            echo json_encode($result);
        } elseif (AJAX_DEBUG) {
            debug($result);
        }
    }

    private function httpDigestAuth()
    {
        if (!defined('DIGEST_US') or strlen(DIGEST_US) < 6 or !defined('DIGEST_PW') or strlen(DIGEST_PW) < 6) {
            die('This feature ist blocked!');
        }

        if (empty($_SERVER['PHP_AUTH_DIGEST'])) {
            header('HTTP/1.1 401 Unauthorized');
            header('WWW-Authenticate: Digest realm="Mail test",qop="auth",nonce="' . uniqid() . '",opaque="' . md5('Mail test') . '"');

            die('Valid authentication required! (A)');
        }

        if (!($authData = $this->httpDigestParse($_SERVER['PHP_AUTH_DIGEST'])) or $authData['username'] !== DIGEST_US) {
            die('Valid authentication required! (B)');
        }

        $response01 = md5($authData['username'] . ':Mail test:' . DIGEST_PW);
        $response02 = md5($_SERVER['REQUEST_METHOD'] . ':' . $authData['uri']);
        $response = md5($response01 . ':' . $authData['nonce'] . ':' . $authData['nc'] . ':' . $authData['cnonce'] . ':' . $authData['qop'] . ':' . $response02);

        if ($authData['response'] !== $response) {
            die('Valid authentication required! (C)');
        }
    }

    private function httpDigestParse($authArray)
    {
        $validArray = array(
            'nonce' => 1,
            'nc' => 1,
            'cnonce' => 1,
            'qop' => 1,
            'username' => 1,
            'uri' => 1,
            'response' => 1,
        );

        $returnData = array();
        $key = implode('|', array_keys($validArray));

        preg_match_all('@(' . $key . ')=(?:([\'"])([^\2]+?)\2|([^\s,]+))@', $authArray, $found, PREG_SET_ORDER);
        foreach ($found as $curFound) {
            $returnData[$curFound[1]] = $curFound[3] ? $curFound[3] : $curFound[4];
            unset($validArray[$curFound[1]]);
        }

        return $validArray ? false : $returnData;
    }
} // Class ControllerMail
