<?php

class ControllerOffers extends ControllerBase
{
    public function index()
    {
        $js_array = array();

        $translate = $this->loadTranslations(array(
            'Einheiten',
            'EinheitEinzahl', // AK 13.04.2018 Aufgabe 94249: Einheit in Einzahl als Übersetzung laden
            'CURRENCY',
            'OFFERS',
        ));

        $is_angebote = Module::isEnabled('ORM_ANGEBOTE');
        $angebote = array();
        if ($is_angebote) {
            $dbAngebote = new DBAngebote();
            $angebote = $dbAngebote->getAngebote('%');
            array_push($js_array, 'jquery.royalslider.custom.min.js', 'elementary.js');
        } else {
            error404();
        }

        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        $Currency = new Currency();
        $DBCurrency = new DBCurrency();
        if (!isset($_SESSION['CONFIG']['CURRENCY'])) {
            $dbCurrency = $DBCurrency->getBaseCurrency();
            $_SESSION['CONFIG']['CURRENCY'] = $dbCurrency->ISOCode;
            $_SESSION['CONFIG']['CURRENCY_SYMBOL'] = $dbCurrency->Symbol;
        } else {
            $dbCurrency = $DBCurrency->getCurrency();
        }
        $Currency->description = $dbCurrency->Beschreibung;
        $Currency->symbol = $dbCurrency->Symbol;
        $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
        $Currency->ISOcode = $dbCurrency->ISOCode;
        $Currency->description_lang = !empty($translate['CURRENCY'][$Currency->ISOcode]) ? $translate['CURRENCY'][$Currency->ISOcode] : $Currency->description;

        $template = $this->template;

        $template->assign('TRANSLATE', $translate);
        $template->assign('CURRENCY', $Currency);

        $template->assign('JS_FILES', $js_array);

        $template->assign('IS_ANGEBOTE', $is_angebote);
        $template->assign('ANGEBOTE', $angebote);
        $template->assign('OFFERS', 1);

        $template->assign('TITLE', isset($translate['OFFERS']['SITETITLE']) ? $translate['OFFERS']['SITETITLE'] : 'OFFERS.SITETITLE');

        $template->display('offers.html');
    } // Index
} // Class ControllerAngebote
