<?php
function __autoload($class_name)
{

    $filename = $class_name . '.php';

    if (strpos(strtolower($filename), 'db') === 0) {
        $file = MODUL_PATH . 'classes' . DIRSEP . 'dbClasses' . DIRSEP . $filename;
        if (!file_exists($file)) {
            $file = APP_PATH . 'classes' . DIRSEP . 'dbClasses' . DIRSEP . $filename;
        }
    } elseif (strpos(strtolower($filename), 'controller') === 0) {
        $filename = strtolower(str_replace('Controller', 'controller_', $filename));
        $file = APP_PATH . 'controllers' . DIRSEP . $filename;
    } else {
        $file = MODUL_PATH . 'classes' . DIRSEP . $filename;
        if (!file_exists($file)) {
            $file = APP_PATH . 'classes' . DIRSEP . $filename;
        }
    }

    if (file_exists($file) === false) {
        return false;
    }

    require_once $file;
}

function logg($data)
{
    file_put_contents(APP_PATH . "logs" . DIRSEP . "log_" . date("Ym") . ".txt", date("Y.m.d H:i:s") . ": " . $data . "\n", FILE_APPEND);
}

function paypallog($data, $title = '')
{
    if (is_array($data)) {
        foreach ($data as &$val) {
            if ($val === true) {
                $val = 'true';
            }
            if ($val === false) {
                $val = 'false';
            }
        }
        unset($val);
        $data = print_r($data, true);
    }

    $data = urldecode($data);

    $uid = date("Y.m.d H:i:s") . '  SID: ' . session_id();

    $data = str_repeat('-', 30) . 'START LOG' . str_repeat('-', 30) . "\n" . $uid . "\n" . ($title != '' ? $title . " >>\n" : '') . $data;
    $data .= "\n" . str_repeat('-', 30) . 'END LOG' . str_repeat('-', 30);
    file_put_contents(MODUL_PATH . "logs" . DIRSEP . date('Ymd') . "_paypal_log.txt", $data . "\n\n", FILE_APPEND);
}

function debug($var, $die = 1, $titel = '')
{
    if (is_bool($var)) {
        $var = $var ? 'TRUE' : 'FALSE';
    }

    if (is_null($var)) {
        $var = 'NULL';
    }

    if (!isset($var)) {
        $var = 'EMPTY';
    }

    if (is_object($var) && isset($var->registry)) {
        $registry = $var->registry;
        unset($var->registry);
    }
    if (is_array($var)) {
        foreach ($var as &$v) {
            if (is_object($v)) {
                if (isset($v->registry)) {
                    unset($v->registry);
                }
                if (isset($v->db)) {
                    unset($v->db);
                }
            }
        }
        unset($v);
    }
    $bt = debug_backtrace();
    echo "<p>-------------------------------  ";
    echo $bt[0]['file'] . "  ----- LINE " . $bt[0]['line'];
    echo "  -------------------------------</p>";
    if ($titel != '') {
        echo "<p>" . $titel . "</p>";
    }
    echo "<pre>";
    if (is_null($var)) {
        $var = 'NULL';
    }

    if ($var === false) {
        $var = 'FALSE (boolean)';
    }

    if ($var === true) {
        $var = 'TRUE (boolean)';
    }

    print_r($var);
    echo "</pre>";

    //if(isset($registry)) {$var->registry = $registry;}

    if ($die == 1) {
        die();
    }
}

function error404()
{
    header('HTTP/1.1 404 Not Found');
    header('Status: 404 Not Found');
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
    header('Cache-Control: no-cache, must-revalidate');
    header('Pragma: no-cache');

    echo '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
            <html><head>
            <title>404 Not Found</title>
            </head><body>
            <h1>Not Found</h1>
            <p>The requested URL ' . $_SERVER['REQUEST_URI'] . ' was not found on this server.</p>
            <hr>
            <address>' . $_SERVER['SERVER_SOFTWARE'] . ' Server at ' . $_SERVER['HTTP_HOST'] . ' Port ' . $_SERVER['SERVER_PORT'] . '</address>
            </body></html>';
    exit();
}

function error403()
{
    header('HTTP/1.1 403 Forbidden');
    header('Status: 403 Forbidden');
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
    header('Cache-Control: no-cache, must-revalidate');
    header('Pragma: no-cache');

    echo '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
            <html><head>
            <title>403 Forbidden</title>
            </head><body>
            <h1>Forbidden</h1>
            <p>The access to URL ' . $_SERVER['REQUEST_URI'] . ' is not allowed.</p>
            <hr>
            <address>' . $_SERVER['SERVER_SOFTWARE'] . ' Server at ' . $_SERVER['HTTP_HOST'] . ' Port ' . $_SERVER['SERVER_PORT'] . '</address>
            </body></html>';
    exit();
}

function memoryUsage($usage, $base_memory_usage)
{
    printf("Bytes diff: %d\n", $usage - $base_memory_usage);
}

function translateInit($updateFlag = false)
{
    $_SESSION['TRANSLATIONS'] = [];
    unset($_SESSION['TRANSLATIONS']);
    $registry = Registry::getInstance();
    $translate_init = $registry->translate_init;

    $db = new DBTranslate();
    foreach ($translate_init as $node_key => $node) {
        $translate_block = $db->initTranslations($node_key, $translate_init[$node_key], 'DE', $updateFlag);
    }

    $texte_init = $registry->texte_init;

    foreach ($texte_init as $node_key => $node) {
        $translate_block = $db->initTexte($node_key, $texte_init[$node_key], 'DE', $updateFlag);
    }
}

function goError($errors, $title = 'Ups. Bei Ihrer Reservierung ist ein Fehler aufgetreten')
{
    if (defined('GO_ERROR_DEBUG') && GO_ERROR_DEBUG === true) {
        echo '<h4>GO ERROR DEBUG</h4>';
        $bt = debug_backtrace();
        var_dump($errors);
        echo '<table>';
        foreach ($bt as $val) {
            echo '[file] => ' . $val['file'] . '<br>';
            echo '[line] => ' . $val['line'] . '<br>';
            if (!empty($val['class'])) {
                echo '[class] => ' . $val['class'] . '<br>';
            }
            echo '[function] => ' . $val['function'] . '<br>';
            echo str_repeat('-', 80) . '<br>';
        }
        echo '</table>';
    } else {
        $_SESSION['ERROR_TITLE'] = $title;
        $_SESSION['ERROR_LIST'] = $errors;
        header('location: ' . SITEURL . 'error&PHPSESSID=' . session_id());
    }
    exit;
} // goError()

function getToken($str = '')
{
    $token = empty($str) ?md5(microtime()) : md5($str);
    $a = $b = 0;
    while ($a >= $b) {
        $a = rand(1, strlen($token));
        $b = rand(1, strlen($token));
    }
    for ($i = $a; $i <= $b; $i++) {
        $token = md5($token . substr($token, $a, $b - $a));
    }
    $token .= md5($token);
    return $token;
} // getToken()

function getSalt()
{
    $tmp = getToken();
    return substr($tmp, 0, strlen($tmp) >= 64 ? 64 : strlen($tmp));
} // getSalt()

function getPasswordHash($password, $password_salt)
{
    $password_hash = $password;
    for ($i = 0; $i < 20; $i++) {
        $password_hash = hash('sha512', $password_hash . '/' . $password_salt);
    }

    return $password_hash;
} // getPasswordHash()

function trace($die = 1, $titel = '')
{
    $bt = debug_backtrace(false);
    echo '<table border="1">';
    echo '<tr><th colspan="3" bgcolor="#e9b96e" align="left" >CX9 Call Stack ' . $bt[0]['file'] . "  ----- LINE " . $bt[0]['line'] . '</th></tr>';
    echo '<tr>
     <th>#</th>
     <th>Function</th>
     <th>Location</th>
     </tr>';
    for ($i = 0; $i < count($bt); $i++) {
        $args = '';
        if (!empty($bt[$i]['args'])) {
            foreach ($bt[$i]['args'] as $a) {
                $a = is_object($a) ? 'Object of ' . get_class($a) : (is_array($a) ? 'Array' : $a);
            }
            $args .= "&apos;" . $a . "&apos;,";
        }
        $args = rtrim($args, ',');
        echo '<tr>';
        echo '<td style="width: 20px; padding-left: 5px;" >' . ($i + 1) . '</td>';
        echo '<td style="padding-left: 5px;">' . $bt[$i]['function'] . '(<font color="#00bb00">' . $args . '</font>)' . '</td>';
        echo '<td  style="min-width: 200px; padding-left: 5px;">../' . basename($bt[$i]['file']) . ':' . $bt[$i]['line'] . '</td>';
        echo '</tr>';
    }
    echo '</table>';
    if ($die == 1) {
        die();
    }
}

set_error_handler(function ($errno, $errstr, $errfile, $errline) {
    return basename($errfile) == 'Session.php';
}, E_WARNING | E_NOTICE);
