var Stations = {
    curentPosition: null,
    map: null,
    info: new Array(),

    getMap: function()
    {
        var icons = new Array();

        var iconStyle = new ol.style.Style({
          image: new ol.style.Icon(/** @type {olx.style.IconOptions} */ ({
            anchor: [0.5, 46],
            anchorXUnits: 'fraction',
            anchorYUnits: 'pixels',
            opacity: 0.75,
            src: cx9_marker_URL
          }))
        });

        for(i = 0; i < cx9_stations.length; i++)
        {
            var iconFeature = new ol.Feature({
              geometry: new ol.geom.Point(ol.proj.transform(
                    [parseFloat(cx9_stations[i].position.long), parseFloat(cx9_stations[i].position.lat)], 'EPSG:4326', 'EPSG:3857')),
              name: cx9_stations[i].name,
              code: cx9_stations[i].code,
              population: 4000,
              rainfall: 500
            });
            iconFeature.setStyle(iconStyle);

            var vectorSource = new ol.source.Vector({
              features: [iconFeature]
            });

            var vectorLayer = new ol.layer.Vector({
              source: vectorSource
            });

            icons.push(vectorLayer);
        }


        var layers = [
          new ol.layer.Tile({
            style: 'Road',
            source: new ol.source.MapQuest({layer: 'osm'})
          })
        ];

        for(i = 0; i < icons.length; i++)
        {
            layers.push(icons[i]);
        }

        var map = new ol.Map({
          layers: layers,
          target: 'map',
          view: new ol.View({
            center: ol.proj.transform(
                [Stations.curentPosition.longitude, Stations.curentPosition.latitude], 'EPSG:4326', 'EPSG:3857'),
            zoom: 13
          })
        });
        //Stations.map = map;

        for(i = 1; i < layers.length; i++)
        {
            layers[i].set('visible');
        }

        var element = document.getElementById('mapMarkerPopup');

        var popup = new ol.Overlay({
          element: element,
          positioning: 'top-center',
          stopEvent: false
        });
        map.addOverlay(popup);

        map.on('click', function(evt) {

          var feature = map.forEachFeatureAtPixel(evt.pixel,
              function(feature, layer) {
                return feature;
              });
          if (feature) {
            var geometry = feature.getGeometry();
            var coord = geometry.getCoordinates();
            popup.setPosition(coord);
            popup.setOffset([0, -110]);

            if( typeof(Stations.info[feature.p.code]) != 'undefined') {
                $('#mapMarkerPopup').html(Stations.info[feature.p.code]);
                $('#stations-header_start').html('<a href="'+CX9SITEURL+'rental?station='+feature.p.code+'">'+feature.p.name+'</a>');
                $('#mapMarkerPopup').show();
            } else {
                $.ajax({
                        url: CX9SITEURL + 'stations/getInfoBlock/'+feature.p.code,
                        dataType: "html",
                        async: true,
                        error: function ()
                        {
                            console.log('Stations:GetInfo Ajax Error');
                        },
                        success:  function(data)
                        {
                            Stations.info[feature.p.code] = data;
                            $('#mapMarkerPopup').html(data);
                            $('#stations-header_start').html('<a href="'+CX9SITEURL+'rental?station='+feature.p.code+'">'+feature.p.name+'</a>');
                            $('#mapMarkerPopup').show();
                        }
                    });
            }
          }
          else
          {
              $('#mapMarkerPopup').hide();
          }
        });
    }, // getMap()

    getLocation: function()
    {
//        console.log(cx9_lat);
//        console.log(cx9_long);
        System.Loading();
        navigator.geolocation.getCurrentPosition(
        function(position){
            System.Ready();
            Stations.curentPosition =  {'latitude': cx9_lat == null ? position.coords.latitude : cx9_lat,
                                        'longitude': cx9_long == null ? position.coords.longitude : cx9_long};
            console.log('Saccess');
            console.log(Stations.curentPosition);
            Stations.getMap();
        },
        function(){
        // wenn Positionsbestimmung einen Fehler erzeugt hat (z.B. weil Sie vom User ablehnt wurde).
            Stations.curentPosition = {'latitude': cx9_lat == null ? parseFloat(cx9_central.position.lat) : cx9_lat,
                                       'longitude': cx9_long == null ? parseFloat(cx9_central.position.long) : cx9_long};
            console.log('Fail');
            console.log(Stations.curentPosition);
            System.Ready()
            Stations.getMap();
        })


    }, //getLocation()


} // Stations

$(document).ready(function () {
    Stations.getLocation();
});