<?php
class DateTimeFormat extends DBBase
{
    private function getFormat()
    {
        $lang = Session::getLang();

        if (empty($_SESSION['DATA']['FORMAT'])) {
            $format = array();
            $sql = 'SELECT LanguageCountry, DateFormat, TimeFormat FROM dbo.DATE_FORMATS';
            $result = $this->getDatabase()->query($sql);
            if (!empty($result)) {
                foreach ($this->getDatabase()->fetch_all() as $row) {
                    $db_lang = substr($row['LanguageCountry'], -2);
                    $db_date = str_replace(
                        array('dd', 'mm', 'yy', 'yyyy', 'YY', 'YYYY'),
                        array('d', 'm', 'y', 'y', 'Y', 'Y'),
                        $row['DateFormat']
                    );
                    $db_time = $row['TimeFormat'] == 24 ? 'H:i' : 'h:i a';

                    $format[$db_lang] = array('date' => $db_date, 'time' => $db_time);
                }
            }

            if (!array_key_exists('DE', $format)) {
                $format['DE'] = array('date' => 'd.m.Y', 'time' => 'H:i');
            }
            $_SESSION['DATA']['FORMAT'] = $format;
        }

        $format = $_SESSION['DATA']['FORMAT'];

        return array_key_exists($lang, $format) ? $format[$lang] : $format['DE'];
    } // getFormat()

    public function getDate($iso_date)
    {
        $format = $this->getFormat();
        return (date($this->getDateFormat(), strtotime($iso_date)));
    } //getDate()

    public function getDateFormat()
    {
        $format = $this->getFormat();
        return $format['date'];
    } //getDateFormat()

    public function getTime($iso_time)
    {
        $format = $this->getFormat();
        return (date($this->getTimeFormat(), strtotime($iso_time)));
    } // getTime()

    public function getTimeFormat()
    {
        $format = $this->getFormat();
        return $format['time'];
    } // getTimeFormat()

    public function getDateTimeFormat()
    {
        $format = $this->getFormat();
        return $format['date'] . ' ' . $format['time'];
    } // getDateTimeFormat()

    public function getDateTime($iso_date_time = '')
    {
        if ($iso_date_time == '') {
            $iso_date_time = date('Y-m-d H:i');
        }
        $format = $this->getFormat();
        return (date($this->getDateTimeFormat(), strtotime($iso_date_time)));
    } //getDateTime()

    public function toGermanDate($date)
    {
        $format = $this->getFormat();
        if (strpos($format['date'], '/') !== false && strpos($date, '/') === false) {
            return $date;
        }
        $iso_date = date_create_from_format($format['date'], $date);

        return $iso_date->format('d.m.Y');
    } // toGermanDate()

    public function toGermanTime($time)
    {
        $format = $this->getFormat();
        if (strlen($time) == 5) {
            return $time;
        } else {
            $format['time'] = 'h:i a';
        }
//         debug($format, 0, '$format');
        //         debug($time);
        $iso_date = date_create_from_format($format['time'], $time);
        return $iso_date->format('H:i');
    } // toGermanTime()
} //DateTimeFormat
