<?php

class Format extends DBBase
{
    public static function CurrencyFormat($sum, $alwaysWithDecimal = true, $withSymbol = true, $wrapCent = array())
    {
        $sum = round($sum, 2);
        $currency = Session::getCurrency();

        if (empty($currency)) {
            $dbCurrency = new DBCurrency;
            $currency = new Currency;
            $currency->decodeFromDb($dbCurrency->getBaseCurrency());
            Session::setCurrency($currency);
        }
        $mantissa = $alwaysWithDecimal ? 2 : $currency->mantissa;
        $is_round = Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1;

        //$decimal = (int)round((abs($sum) - (int)abs($sum)) * 100);
        $decimal = abs($sum) * 100 % 100;
        $decimal = $decimal < 10 ? '0' . $decimal : $decimal;
        if (strlen($decimal) < $mantissa) {
            $decimal .= str_repeat('0', $mantissa - strlen($decimal));
        }

        $number = (int) $sum;
        $format = '';
        if ($number == 0) {
            $format = '0';
        } else {
            $tmp = abs($number);
            while ($tmp > 0) {
                $tmp_str = substr($tmp % 1000 + 1000, 1, 3);
                $format = $currency->separatorThousand . $tmp_str . $format;
                $tmp = ($tmp - $tmp % 1000) / 1000;
            }

            $format = ltrim($format, $currency->separatorThousand);
            while (strpos($format, '0') === 0) {
                $format = ltrim($format, '0');
            }
        }
        if ($mantissa != 0) {
            if (is_array($wrapCent) and count($wrapCent) == 2) {
                $prefix = trim($wrapCent[0]);
                $suffix = trim($wrapCent[1]);
            } else {
                $prefix = '';
                $suffix = '';
            }
            $format .= $currency->separatorDecimal . $prefix;
            $format = $mantissa == 0 ? ($format . (($_SESSION['CONFIG']['LANG'] == 'DE') ? '-' : '')) : ($format . substr((string) $decimal, 0, $mantissa));
            $format .= $suffix;
        } else {
            if (Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1) {
                $format .= $currency->separatorDecimal . '&ndash;';
            }
        }

        $sign = (($mantissa == 0 && $number == 0) || $sum >= 0) ? '' : '-';
        $format = $sign . $format;

        if ($withSymbol) {
            $format = empty($currency->positon) ? ($format . '&nbsp;' . $currency->symbol) : ($currency->symbol . '&nbsp;' . $format);
        }

        return html_entity_decode($format);
    }

    public function numericFormat($number, $withDecimal = false)
    {
        $currency = Session::getCurrency();

        if (empty($currency)) {
            $dbCurrency = new DBCurrency;
            $currency = new Currency;
            $currency->decodeFromDb($dbCurrency->getBaseCurrency());
            Session::setCurrency($currency);
        }

        $mantissa = $withDecimal ? 2 : 0;

        $decimal = abs($number) * 100 % 100;
        $decimal = $decimal < 10 ? '0' . $decimal : $decimal;
        if (strlen($decimal) < $mantissa) {
            $decimal .= str_repeat('0', $mantissa - strlen($decimal));
        }

        $number = (int) $number;
        $format = '';
        if ($number == 0) {
            $format = '0';
        } else {
            $tmp = abs($number);
            while ($tmp > 0) {
                $tmp_str = substr($tmp % 1000 + 1000, 1, 3);
                $format = $currency->separatorThousand . $tmp_str . $format;
                $tmp = ($tmp - $tmp % 1000) / 1000;
            }

            $format = ltrim($format, $currency->separatorThousand);
            while (strpos($format, '0') === 0) {
                $format = ltrim($format, '0');
            }
        }
        if ($mantissa != 0) {
            $format .= $currency->separatorDecimal;
            $format = $format . substr((string) $decimal, 0, $mantissa);
        }

        $sign = (($mantissa == 0 && $number == 0) || $number >= 0) ? '' : '-';
        $format = $sign . $format;

        return $format;
    }
}
