<?php

class Rate
{

    public $db_id = 0;
    // Raten PK
    public $rate = '';
    // Ratencode
    public $basic = '';
    // MietRate J | N
    public $tarif = '';
    // Ratencode
    public $description = '';
    // Beschreibung
    public $description_lang = '';
    // Übersetzte Beschreibung
    public $sub_description = '';
    // Beschreibung2
    public $sub_description_lang = '';
    // Übersetzte Beschreibung2
    public $count = 0;
    // Anzahl
    public $km_free = 0;
    // Frei KM
    public $basic_price = 0;
    // Einzelpreis (Brutto)
    // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
    public $basic_price_netto = 0;
    // Einzelpreis (netto)
    public $total_price = 0;
    // Gesamtpreis (Brutto) = Anzahl * Einzelpreis (Brutto)
    // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
    public $total_price_netto = 0;
    // Gesamtpreis (netto) = Anzahl * Einzelpreis (netto)
    // TODO Umbenennung int total_price_currency
    public $currency_price = 0;
    // Gesamtpreis (Brutto) mit Währungsfaktor
    public $currency_price_netto = 0;
    // Gesamtpreis (netto) mit Währungsfaktor
    public $currency_price_single = 0;
    // Gesamtpreis (Brutto) mit Währungsfaktor
    public $currency_price_single_netto = 0;
    // Gesamtpreis (netto) mit Währungsfaktor
    public $invoice_num = '';
    // PKRECHUNG
    // TODO Aufsplittung in unit und unit_lang
    public $unit = '';
    // Einheit / Übersetzte Einheit
    public $extra_unit = '';
    public $extra_price = 0;
    public $extra_price_netto = 0;
    //
    public $isTemporal = true;
    // Zeitlich? true | false
    public $discount = 0;
    // Rabatt
    public $sub_km_price = 0;
    // Preis (Brutto) je Zusatzkilometer mit Währungsfaktor
    // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
    public $sub_km_price_netto = 0;
    // Preis (netto) je Zusatzkilometer mit Währungsfaktor
    // TODO Aufsplittung in sub_km_price und sub_km_price_currency
    public $autobuch = false;
    // Obligatorisch? true | false
    public $selected = false;
    // Geählt? true | false
    public $is_stuk = false;
    // Stückrate? true | false
    public $minCount = 0;
    // Bei Zusatzraten: minimale Anzahl
    public $maxCount = 10;
    // Bei Zusatzraten: maximale Anzahl
    public $is_angebot = false;
    // Angebot? true | false
    public $memo = '';

    public $cdw = false;

    public $days = 0;

    public $category;

    public $category_lang;

    public function decodeFromDb($dbObj)
    {
        $cache_currency = Cache::getCurrency();

        $currency = new Currency();
        $currency->decodeFromDb($cache_currency);

        $dbRate = new DBRate();

        $this->db_id = $dbObj->PK;
        $this->rate = $dbObj->Rate;
        $this->basic = $dbObj->MietRate;
        $this->tarif = $dbObj->Rate;
        $this->description = nl2br($dbObj->Beschreibung);
        $this->sub_description = nl2br($dbObj->Beschreibung2);
        $this->count = intval($dbObj->Anzahl);
        $this->km_free = $dbObj->Kmfrei;
        $this->basic_price = round($dbObj->Brutto + ($dbObj->Brutto * $dbObj->rabatt / 100), 2);
        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $this->basic_price_netto = round($dbObj->Einzelpreis, 2);
        $this->total_price = round($dbObj->gesamtpreisbrutto, 2);
        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $this->total_price_netto = round($dbObj->GesamtPreis, 2);
        $this->currency_price = round($dbObj->gesamtpreisbrutto * $currency->conversion, 2);
        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $this->currency_price_netto = round($dbObj->GesamtPreis * $currency->conversion, 2);
        // AK 12.02.2016 - Aufgabe 76288: für Stückraten muss der currency_price auf den Einzelpreis berechnet werden
        $this->currency_price_single = round($dbObj->Brutto + ($dbObj->Brutto * $dbObj->rabatt / 100) * $currency->conversion, 2);
        $this->currency_price_single_netto = round($dbObj->Einzelpreis * $currency->conversion, 2);
        $this->invoice_num = $dbObj->PKRECHNUNG;
        $this->unit = $dbObj->Einheit;
        $this->extra_unit = $dbObj->ZusatzEinheit;
        $this->extra_price = round($dbObj->ZusatzPreisBrutto * $currency->conversion, 2);
        $this->extra_price_netto = round($dbObj->ZusatzPreis * $currency->conversion, 2);
        $this->isTemporal = $dbRate->isUnitTemporal($this);
        $this->discount = $dbObj->rabatt;
        $this->sub_km_price = round($dbObj->kmbrutto * $currency->conversion, 2);
        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $this->sub_km_price_netto = round($dbObj->kmZus * $currency->conversion, 2);
        $this->autobuch = isset($dbObj->autobuch) && $dbObj->autobuch;
        $this->selected = false;
        $this->is_stuk = $dbRate->isUnitStuk($this);
        $this->minCount = $dbObj->min_count;
        $this->maxCount = $dbObj->max_count;
        $this->is_angebot = !empty($dbObj->is_angebot);
        $this->SB = round($dbObj->SB * $currency->conversion, 2);
        $this->cdw = strpos(strtolower($this->rate), 'cdw') !== false;
        $this->days = !empty($dbObj->days) ? $dbObj->days : 0;
        $this->category = (!empty($dbObj->category)) ? $dbObj->category : null;

        if ($this->autobuch) {
            $this->selected = true;
        }

        $dbTranslate = new DBTranslate();
        $translate = array(
            'Einheiten' => $dbTranslate->loadTranslations('Einheiten'),
            'EinheitEinzahl' => $dbTranslate->loadTranslations('EinheitEinzahl'),
        );

        if ($this->count == 1) {
            $this->unit = isset($translate['EinheitEinzahl'][$this->unit]) ? $translate['EinheitEinzahl'][$this->unit] : (isset($translate['Einheiten'][$this->unit]) ? $translate['Einheiten'][$this->unit] : $this->unit);
        } else {
            $this->unit = isset($translate['Einheiten'][$this->unit]) ? $translate['Einheiten'][$this->unit] : $this->unit;
        }
        $this->extra_unit = isset($translate['Einheiten'][$this->extra_unit]) ? $translate['Einheiten'][$this->extra_unit] : $this->extra_unit;

        // Übersetzung der Beschreibung
        $translate = $dbTranslate->loadTranslations('RATE', Session::getLang());
        $group = Session::getCarGroup();
        if (!empty($translate['DESCRIPTION'][md5($this->rate)][md5($group->cargroupid)])) {
            $this->description_lang = $translate['DESCRIPTION'][md5($this->rate)][md5($group->cargroupid)];
        } elseif (!empty($translate['DESCRIPTION'][md5($this->rate)][md5('*')])) {
            // Wenn $group nicht vorhanden, dann auf * prüfen
            $this->description_lang = $translate['DESCRIPTION'][md5($this->rate)][md5('*')];
        } else {
            $this->description_lang = $this->description;
        }

        // Übersetzung der Beschreibung2
        if (!empty($translate['DESCRIPTION2'][md5($this->rate)][md5($group->cargroupid)])) {
            $this->sub_description_lang = $translate['DESCRIPTION2'][md5($this->rate)][md5($group->cargroupid)];
        } elseif (!empty($translate['DESCRIPTION2'][md5($this->rate)][md5('*')])) {
            // Wenn $group nicht vorhanden, dann auf * prüfen
            $this->sub_description_lang = $translate['DESCRIPTION2'][md5($this->rate)][md5('*')];
        } else {
            $this->sub_description_lang = $this->sub_description;
        }

        $searchString = 'crent.ratecategory.' . $dbObj->category_lang;
        $this->category_lang = ($dbObj->category_lang and $dbTranslate->loadTranslations($searchString)) ? $dbTranslate->loadTranslations($searchString) : $dbObj->category_lang;
    }
} //Class Rate
