<?php
class Router
{
    private $registry;

    private $path;

    private $ind = false;

    private $args = array();

    public function __construct()
    {

        $this->registry = Registry::getInstance();
    }

    public function setPath($path, $ind = false)
    {
        $path = trim($path, '/\\');

        $path .= DIRSEP;

        // if (! is_dir($path))
        // {
        // throw new Exception ('Invalid controller path: `' . $path . '`');
        // }

        $this->path = $path;
        $this->ind = $ind;
    }

    public function delegate()
    {

        // Path parsen

        $this->getController($file, $controller, $action, $args);
        //die("File: $file <br> Controller: $controller <br> Action: $action <br> Args: " . print_r($args, true));
        // Ist Datei verfÃƒÂ¼gbar?
        if (is_readable($file) === false || is_dir($file)) {
            if ($this->ind) {
                return false;
            } else {
                error404();
            }
        }

        // Datei verbinden
        include $file;

        // Controller Instanz erzeugen

        $class = $controller;

        $controller = new $class();

        // Ist Action verfÃƒÂ¼gbar?
        if (method_exists($controller, $action) === false) {
            error404();
        }

        $this->registry->args = $args;
        // Action aufrufen

        $controller->$action();
    }

    private function getController(&$file, &$controller, &$action, &$args)
    {

        $route = (empty($_GET['route']) || $_GET['route'] == 'index.php') ? (defined('FORCE_CUSTOMER_LOGIN') && FORCE_CUSTOMER_LOGIN == 1) ? 'login' : 'rental' : $_GET['route'];

        if (trim(strtolower($route), '/\\') == 'mobile') {
            $route = 'mobile/index';
        }

        // Parsen auf Teile
        $route = trim($route, '/\\');

        $parts = explode('/', $route);

        // Suchen Controller

        //die($route);
        $cmd_path = $this->path;
        $os = strtoupper(substr(PHP_OS, 0, 3)) === 'WIN' ? 'win' : 'linux';
        if ($os == 'linux') {
            $cmd_path = DIRSEP . $cmd_path;
        }

        foreach ($parts as $part) {
            $fullpath = $cmd_path . 'controller_' . strtolower($part);
            // Ist das Verzeichnis?
            if (is_dir($cmd_path . strtolower($part))) {
                $cmd_path .= $part . DIRSEP;

                array_shift($parts);

                continue;
            }

            // Datei suchen

            if (is_file($fullpath . '.php')) {
                $controller = $this->ind ? 'Controller' . $part . 'ind' : 'Controller' . $part;
                array_shift($parts);

                break;
            }
        }

        // Action erzeugen
        $action = array_shift($parts);
        if (!isset($action) || $action == '') {
            $action = 'index';
        }

        $file = $cmd_path . str_replace('controller', 'controller_', strtolower($controller)) . '.php';
        $file = str_replace('ind.php', '.php', $file);

        $args = $parts;
    }
} // Class Router
