<?php

class DBCurrency extends DBBase
{

    public function getBaseCurrency()
    {
        $result = $this->getDatabase()->proc_exec('INET_GET_BASISWAEHRUNG');
        if ($result !== false) {
            $dbObj = $this->getDatabase()->fetch_obj();
            if (empty($dbObj)) {
                $sql = "SELECT * FROM dbo.WAEHRUNGEN WHERE Basiseinheit = 1";
                $this->getDatabase()->query($sql);
                $dbObj = $this->getDatabase()->fetch_obj();
            }
            return $dbObj;
        }
    }

    public function getCurrency($iso_code = '')
    {
        // Zeit vor 8 Uhr - ist gestern
        $curDate = date('d.m.Y');

        if (CACHE == 1 && isset($_SESSION['CACHE']['CURRENCY']['OBJ'])) {
            $objCurrency = unserialize($_SESSION['CACHE']['CURRENCY']['OBJ']);
            if (isset($objCurrency->ISOCode) && $objCurrency->ISOCode == $_SESSION['CONFIG']['CURRENCY'] && (($_SESSION['CACHE']['CURRENCY']['TIME'] <= "08:00:00" && date("H:i:s") <= "08:00:00") || $_SESSION['CACHE']['CURRENCY']['TIME'] > "08:00:00")) {
                $_SESSION['CACHE']['CURRENCY']['TIME'] = date("H:i:s");
                $_SESSION['CACHE']['CURRENCY']['OBJ'] = serialize($objCurrency);
                return $objCurrency;
            }
        }

        if (date("H:i:s") < "08:00:00") {
            $date = new DateTime(date('Y-m-d'));
            $date->sub(new DateInterval('P1D'));
            $curDate = $date->format('d.m.Y');
        }

        if (!isset($_SESSION['CONFIG']['CURRENCY'])) {
            $_SESSION['CONFIG']['CURRENCY'] = '';
        }

        $iso_code = $iso_code == '' ? $_SESSION['CONFIG']['CURRENCY'] : trim($iso_code);
        $params = array(
            "isocode" => $iso_code,
            "datum" => $curDate,
        );

        $sql = "EXEC INET_GET_WAEHRUNG @isocode = :isocode, @datum = :datum";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue('isocode', $iso_code);
        $this->getDatabase()->bindValue('datum', $curDate);
        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $db_result = $this->getDatabase()->fetch_obj();
        }

        if (!$db_result) {
            $db_result = $this->getBaseCurrency();
            $_SESSION['CONFIG']['CURRENCY'] = $db_result->ISOCode;
        }

        if (CACHE == 1) {
            $_SESSION['CACHE']['CURRENCY']['TIME'] = date("H:i:s");
            $_SESSION['CACHE']['CURRENCY']['OBJ'] = serialize($db_result);
        }

        return $db_result;
    }

    public function getAllCurrencyInfo()
    {
        $currency = array();
        $dbTranslate = new DBTranslate();
        $translate = $dbTranslate->loadTranslations('CURRENCY', Session::getLang());

        if (CACHE == 0 || !isset($_SESSION['CACHE']['CURRENCY']['ALL_CURRENCY_INFO'])) {
            $sql = "EXEC INET_GET_WAEHRUNGEN @datum = :datum";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue('datum', date('d.m.Y H:i'));
            $result = $this->getDatabase()->execute();

            if ($result !== false) {
                while ($row = $this->getDatabase()->fetch_obj()) {
                    $row->Beschreibung_lang = !empty($translate[$row->ISOCode]) ? $translate[$row->ISOCode] : $row->Beschreibung;
                    $currency[] = $row;
                }
            }

            if (CACHE == 1) {
                $_SESSION['CACHE']['CURRENCY']['ALL_CURRENCY'] = serialize($currency);
            }
        } else {
            $currency = unserialize($_SESSION['CACHE']['CURRENCY']['ALL_CURRENCY']);
        }

        return $currency;
    }
}
