<?php
class DBPayart extends DBBase
{
    public function getAll($gruppe_code)
    {
        $pay_arts = array();

        $result = $this->getDatabase()->proc_exec('INET_GET_ZAHLUNGSARTEN', array('gruppe' => $gruppe_code));

        if ($result !== false) {
            foreach ($this->getDatabase()->fetch_all() as $dbArr) {
                $sql = 'SELECT Auto_KK FROM FIBU_ZAHLUNGSARTEN WHERE pk = :PK';
                $this->getDatabase()->prepare($sql);
                $this->getDatabase()->bindValue(':PK', $dbArr['pk']);
                $result2 = $this->getDatabase()->execute();

                if ($result2 !== false) {
                    $row = $this->getDatabase()->fetch_obj();
                    $dbArr['credit_card'] = isset($row->Auto_KK) && $row->Auto_KK == 'KK' ? 1 : 0;
                } else {
                    $dbArr['credit_card'] = 0;
                }

                $dbObj = new \stdClass;
                $dbObj->pk = $dbArr['pk'];
                $dbObj->Zahlungsart = $dbArr['Zahlungsart'];
                $dbObj->BEZEICHNUNG_WEB = trim($dbArr['BEZEICHNUNG_WEB']) != '' ? $dbArr['BEZEICHNUNG_WEB'] : $dbArr['Zahlungsart'];
                $dbObj->credit_card = $dbArr['credit_card'];

                $dbObj->autopay = (strtolower($dbObj->Zahlungsart) == strtolower(Params::getValue('CONCARDIS_NAME')) && Module::isEnabled('ConCardis')) ||
                (strtolower($dbObj->Zahlungsart) == strtolower(Params::getValue('PAYPAL_NAME')) && Module::isEnabled('PayPal')) ||
                (strtolower($dbObj->Zahlungsart) == strtolower(Params::getValue('PAYPAL_NAME')) && Module::isEnabled('PayPalPlus')) ? 1 : 0;

                $pay_arts[] = $dbObj;
            }
        }
        return $pay_arts;
    } // getAll()

    public function getArtById($id)
    {
        $pay = null;

        $sql = "SELECT * FROM FIBU_ZAHLUNGSARTEN WHERE PK=:id";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':id', $id);

        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $row = $this->getDatabase()->fetch_obj();
            $pay = $row;
            $pay->credit_card = isset($row->Auto_KK) && $row->Auto_KK == 'KK' ? 1 : 0;

            $pay->autopay = (strtolower($pay->Zahlungsart) == strtolower(Params::getValue('CONCARDIS_NAME')) && Module::isEnabled('ConCardis')) ||
            (strtolower($pay->Zahlungsart) == strtolower(Params::getValue('PAYPAL_NAME')) && Module::isEnabled('PayPal')) ||
            (strtolower($pay->Zahlungsart) == strtolower(Params::getValue('PAYPAL_NAME')) && Module::isEnabled('PayPalPlus')) ? 1 : 0;
        }

        return $pay;
    } // getArtById
} // Class DBPayart
