<?php

class ControllerCustomer extends ControllerBase
{

    public function index()
    {
    }

    public function createlogin()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE', $this->registry->lang),
        );

        $customer = null;
        if (!empty($_REQUEST['customerNumber'])) {
            $customerNumber = trim($_REQUEST['customerNumber']);

            $customer = Customer::getById($customerNumber);
        } elseif (!empty($_REQUEST['mail'])) {
            $mail = trim($_REQUEST['mail']);

            $customer = Customer::getByEmail($email);
        } else {
            echo json_encode(array(
                'error' => $translate['MESSAGE']['ERROR_CREATE_LOGIN'],
            ));
            exit;
        }

        if ($customer != null) {
            $dbCustomer = new DBCustomer();
            $dbCustomer->loginResetOldPassword($customer->id);

            Session::setCustomer($customer);
            $this->send_new_customer_email();
            Session::delCustomer();

            echo json_encode(array(
                'msg' => $translate['MESSAGE']['SUCCESS_CREATE_LOGIN'],
            ));
        } else {
            echo json_encode(array(
                'error' => $translate['MESSAGE']['ERROR_CREATE_LOGIN'],
            ));
        }
    }

    public function login()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE'),
            'LOGIN_BAR' => $dbTranslate->loadTranslations('LOGIN_BAR'),
            'NEW_PASSWORD' => $dbTranslate->loadTranslations('NEW_PASSWORD'),
            'NAVI' => $dbTranslate->loadTranslations('NAVI'),
        );
        $sleep = 1;
        $count = 1;

        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) && !empty($_POST['mail']) && !empty($_POST['pass'])) {
            $login_disable = false;

            if (empty($_SESSION['DATA']['login'])) {
                $_SESSION['DATA']['login']['disable']['last_time'] = time();
                $_SESSION['DATA']['login']['disable']['try'] = 1;
            } else {
                if (empty($_SESSION['DATA']['login']['disable']['try'])) {
                    $_SESSION['DATA']['login']['disable']['try'] = 0;
                }
                $count = ++$_SESSION['DATA']['login']['disable']['try'];
                if ($count > 3 && $count <= 5) {
                    $sleep = 3;
                } elseif ($count > 5 && $count <= 10) {
                    $sleep = 10;
                } elseif ($count > 10) {
                    $sleep = 3600;
                }

                if (empty($_SESSION['DATA']['login']['disable']['last_time'])) {
                    $_SESSION['DATA']['login']['disable']['last_time'] = time();
                }
                $def_time = time() - $_SESSION['DATA']['login']['disable']['last_time'];
                $_SESSION['DATA']['login']['disable']['last_time'] = time();
                if (($count <= 3 && $def_time < 1) || ($count > 3 && $count <= 5 && $def_time < 3) || ($count > 5 && $count <= 10 && $def_time < 10) || ($count > 10 && $def_time < 3600)) {
                    $login_disable = true;
                }

                if ($def_time > 3600) {
                    $sleep = 1;
                    $_SESSION['DATA']['login']['disable'] = array();
                    unset($_SESSION['DATA']['login']['disable']);
                }
            }
            if ($login_disable) {
                echo json_encode(array(
                    'error_msg' => $translate['MESSAGE']['ERROR_CUSTOMER_LOGIN'],
                    'sleep' => $sleep,
                    'count' => $count,
                ));
                exit();
            }

            $mail = trim($_POST['mail']);
            $pass = trim($_POST['pass']);
            $_SESSION['POST'] = array();
            unset($_SESSION['POST']);
            $dbCustomer = new DBCustomer();
            $dbCustomerObj = $dbCustomer->getInfoByLogin($mail, $pass);
            if ($dbCustomerObj != null) {
                if ($dbCustomer->loginIsActivate($dbCustomerObj->NUMMER)) {
                    $customer = new Customer();
                    $customer->decodeFromDb($dbCustomerObj);

                    $dbPayArt = new DBPayart();
                    $dbPayArtsObj = $dbPayArt->getAll(isset($_SESSION['DATA']['car_group']) ? $_SESSION['DATA']['car_group'] : '');
                    foreach ($dbPayArtsObj as $dbObj) {
                        $payArt = new PayArts();
                        $payArt->decodeFromDb($dbObj);

                        if ($payArt->name == $customer->payment) {
                            $customer->payment = $payArt->web_name;
                            $customer->paymentID = $payArt->id;
                            break;
                        }
                    }

                    $_SESSION['DATA']['login']['disable'] = array();
                    unset($_SESSION['DATA']['login']['disable']);

                    $login_bar = '';
                    $popups = '';
                    if (!empty($_SESSION['NAVI_MAX_STEP']) && $_SESSION['NAVI_MAX_STEP'] > 1) {
                        $module = [];
                        foreach (Module::getAll() as $v) {
                            $module[$v['Modul']] = $v;
                        }
                        $this->template->assign('CUSTOMER', $customer);
                        $this->template->assign('TRANSLATE', $translate);
                        $this->template->assign('LOGIN', true);
                        $this->template->assign('MODULE', $module);
                        $login_bar = $this->template->fetch('login_bar.html');
                        $popups = $this->template->fetch('popups.html');
                    }
                    $_SESSION['DATA']['login']['isLoggedIn'] = true;

                    // Anreden laden und cachen (könnte mal eine kleine Widget-Funktion werden)
                    $dbAnrede = new DBAnrede();
                    $dbAnredenObj = $dbAnrede->getAll(Session::getLang());
                    $anreden = array();
                    foreach ($dbAnredenObj as $dbObj) {
                        $anrede = new Anrede();
                        $anrede->decodeFromDb($dbObj);
                        $anreden[$anrede->id] = $anrede;
                    }

                    $_SESSION['CACHE']['anreden'] = serialize($anreden);
                    foreach ($anreden as $curAnrede) {
                        if ($curAnrede->anrede == $customer->anrede) {
                            $customer->anredeID = $curAnrede->id;
                        }
                    }

                    // Zahlungsart resetten
                    $customer->payart = null;
                    $customer->payartID = 0;

                    Session::setCustomer($customer);
                    $_SESSION['DATA']['DB']['FUNCTION']['ORM_GET_MV_PREISLISTE']['params'][':kdno'] = $customer->id;

                    echo json_encode(array_merge((array) $customer, array(
                        'sid' => session_id(),
                        'forceCustomerLogin' => defined('FORCE_CUSTOMER_LOGIN') && FORCE_CUSTOMER_LOGIN == 1 ? true : false,
                        'FORCE_CUSTOMER_LOGIN_STEP_AFTER_LOGIN' => defined('FORCE_CUSTOMER_LOGIN_STEP_AFTER_LOGIN') && FORCE_CUSTOMER_LOGIN_STEP_AFTER_LOGIN != '' ? FORCE_CUSTOMER_LOGIN_STEP_AFTER_LOGIN : 'rental',
                    ), array(
                        'login_bar' => $login_bar,
                        'popups' => $popups,
                    )));
                } else {
                    echo json_encode(array(
                        'error_msg' => $translate['MESSAGE']['ERROR_CUSTOMER_LOGIN_INACTIVE'],
                        'sleep' => $sleep,
                        'count' => $count,
                    ));
                }
            } else {
                echo json_encode(array(
                    'error_msg' => $translate['MESSAGE']['ERROR_CUSTOMER_LOGIN'],
                    'sleep' => $sleep,
                    'count' => $count,
                ));
            }
        } else {
            echo json_encode(array(
                'error_msg' => $translate['MESSAGE']['ERROR_CUSTOMER_LOGIN'],
                'sleep' => $sleep,
                'count' => $count,
            ));
        }
    }

    public function logout()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE'),
            'LOGIN_BAR' => $dbTranslate->loadTranslations('LOGIN_BAR'),
        );

        $user = Session::getCustomer();
        Session::delCustomer();
        $redirect = 0;
        $_SESSION['NAVI_MAX_STEP'] = 2;

        if ($_SESSION['NAVI_STEP'] == 'B') {
            $_SESSION['NAVI_MAX_STEP'] = 1;
            $redirect = 1;
        }
        $_SESSION['DATA']['login'] = null;
        unset($_SESSION['DATA']['login']);

        $login_bar = '';
        if ($_SESSION['NAVI_MAX_STEP'] > 1) {
            $module = [];
            foreach (Module::getAll() as $v) {
                $module[$v['Modul']] = $v;
            }
            $this->template->assign('TRANSLATE', $translate);
            $this->template->assign('LOGIN', false);
            $this->template->assign('MODULE', $module);
            $login_bar = $this->template->fetch('login_bar.html');
        }
        echo json_encode([
            'redirect' => $redirect,
            'login_bar' => $login_bar,
        ]);
    }

    public function resetpassword()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE', $this->registry->lang),
        );

        $customer = null;
        if (!empty($_REQUEST['mail'])) {
            $mail = trim($_REQUEST['mail']);

            $customer = Customer::getByEmail($mail);
        } else {
            echo json_encode(array(
                'error' => $translate['MESSAGE']['ERROR_FORGET_PW'],
            ));
            exit;
        }

        if (!empty($customer)) {
            $dbCustomer = new DBCustomer();
            $dbCustomer->loginResetPassword($customer->id);
            Session::setCustomer($customer);
            $this->send_new_customer_email();
            Session::delCustomer();

            echo json_encode(array(
                'msg' => $translate['MESSAGE']['SUCCESS_FORGET_PW'],
            ));
        } else {
            echo json_encode(array(
                'error' => $translate['MESSAGE']['ERROR_FORGET_PW'],
            ));
        }
    }

    // doppelt in controller_reservate
    // TODO controller email schreiben
    private function send_new_customer_email()
    {
        $dbMandant = new DBMandant();
        $mandant = new Mandant();
        $mandant->decodeFromDb($dbMandant->getInfo());

        $this->registry->mandant = $mandant;

        $dbAnrede = new DBAnrede();
        $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

        $anreden = array();
        foreach ($dbAnredenObj as $dbObj) {
            $anrede = new Anrede();

            $anrede->decodeFromDb($dbObj);
            $anreden[$anrede->anrede] = $anrede;
        }

        $translate = $this->loadTranslations(array(
            'RENTAL',
            'RESERVATE',
            'EMail',
            'WEBEMAIL',
            'EMAIL',
        ));

        // Nachbearbeitung eMail-Betreff (Marker ersetzen):
        $subject = str_replace('###MANDANTNAME###', $this->registry->mandant->name, $translate['EMAIL']['EMAIL_SUBJECT_CUSTOMER_LOGIN_DATA']);
        $translate['EMAIL']['EMAIL_SUBJECT_CUSTOMER_LOGIN_DATA'] = $subject;

        $mail = new Mail();
        $mail->is_bcc = false;

        $user = Session::getCustomer();
        if (is_a($user, 'Customer')) {
            $user->greeting = str_replace('$NAME1,', '', $anreden[$user->anrede]->greeting);
            $user->password = $this->registry->inet_password;
            $startstation = Session::getStartStation();
            if (empty($startstation)) {
                $startstation = Station::getZentrale();
            }

            $dbCustomer = new DBCustomer();
            $token = $dbCustomer->createToken($user);

            $dbText = new DBText();
            $text1 = $dbText->getTextByStation($startstation->code, 'INET_NEW_CUSTOMER_GREETING');
            $text1->mem = isset($text1->mem) ? $text1->mem : 'INET_NEW_CUSTOMER_GREETING';

            $template = $this->template;
            $template->assign('TRANSLATE', $translate);
            $template->assign('STARTSTATION', $startstation);
            $template->assign('TEXT_OBEN', $text1->mem);
            $template->assign('USER', $user);
            $template->assign('TOKEN', $token);

            $template->assign('CONFIRMATION', 0);
            $template->assign('NEW_PASSWORD', 1);

            $body = $template->fetch('email_template.html');
            if ($mail->Send($user->email, $subject, $body)) {
                $mail_status = 'E-Mail erfolgreich gesendet.';
            } else {
                $mail_status = 'Fehler beim Senden der E-Mail: ' . $mail->ErrorInfo();
            }
            $this->email_error_log($mail->getLog() . 'Status: ' . $mail_status);
            $mail->log2db($mail_status);
        }
    }

    public function setNewPassword()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE', $this->registry->lang),
        );
        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) && isset($_REQUEST['oldPassword']) && trim($_REQUEST['oldPassword']) != '' && isset($_REQUEST['newPassword']) && trim($_REQUEST['newPassword']) != '') {
            $customer = unserialize($_SESSION['DATA']['customer']);

            $newPassword = trim($_REQUEST['newPassword']);
            $oldPassword = trim($_REQUEST['oldPassword']);

            $dbCustomer = new DBCustomer();
            $dbCustomerObj = $dbCustomer->getById($customer->id);

            if ($dbCustomerObj != null) {
                $password_hash = getPasswordHash($oldPassword, $dbCustomerObj->PASSWORD_SALT);
                if ($password_hash == $dbCustomerObj->PASSWORD_HASH) {
                    $dbCustomerObj = $dbCustomer->loginUpdatePassword($customer->id, $newPassword);
                    // debug( $dbCustomerObj , 0 );
                    echo json_encode(array(
                        'msg' => $translate['MESSAGE']['SUCCESS_CHANGE_PW'],
                    ));
                } else {
                    echo json_encode(array(
                        'error' => $translate['MESSAGE']['ERROR_CHANGE_PW'],
                    ));
                }
            } else {
                echo json_encode(array(
                    'error' => $translate['MESSAGE']['ERROR_CHANGE_PW'],
                ));
            }
        } else {
            echo json_encode(array(

                'error' => $translate['MESSAGE']['ERROR_CHANGE_PW'],
            ));
        }
    }

    public function createPassword()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'MESSAGE' => $dbTranslate->loadTranslations('MESSAGE', $this->registry->lang),
        );

        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) && isset($_REQUEST['newPassword']) && trim($_REQUEST['newPassword']) != '') {
            $customer = unserialize($_SESSION['DATA']['customer']);

            $newPassword = trim($_REQUEST['newPassword']);

            $dbCustomer = new DBCustomer();
            $dbCustomerObj = $dbCustomer->getById($customer->id);

            if ($dbCustomerObj != null) {
                $dbCustomerObj = $dbCustomer->loginUpdatePassword($customer->id, $newPassword);
                echo json_encode(array(
                    'msg' => $translate['MESSAGE']['SUCCESS_CHANGE_PW'],
                ));
            } else {
                echo json_encode(array(
                    'error' => $translate['MESSAGE']['ERROR_CHANGE_PW'],
                ));
            }
        } else {
            echo json_encode(array(
                'error' => $translate['MESSAGE']['ERROR_CHANGE_PW'],
            ));
        }
    }

    public function profil()
    {
        $buchungsstatus = isset($_GET['buchungsstatus']) ? trim($_GET['buchungsstatus']) : null;

        $translate = $this->loadTranslations(array(
            'BUCHUNGSLISTE',
            'NAVI',
            'RENTAL',
            'FZG',
            'RESERVATE',
            'RATE',
            'ERROR',
            'GLOBAL',
            'LOGIN_BAR',
            'LOGIN',
            'STEP_MENU',
            'BUCHUNGSFILTER',
            'TOP_LINK',
            'STATION',
            'STATION_DETAILS',
            'CAR_GROUP',
            'TARIF',
            'EXTRAS',
            'NEW_PASSWORD',
            'Monate_kurz',
            'Wochentage_kurz',
        ));

        if ($this->registry->module['ORM_HISTORIE']['enabled'] != 'J') {
            $this->error[] = $translate['ERROR']['MODUL_NICHT_ERLAUBT'];
            goError($this->error);
        }

        if (empty($_SESSION['DATA']['customer'])) {
            $this->error[] = $translate['ERROR']['ERROR_CUSTOMER_DATA'];
            goError($this->error);
        }

        $customer = unserialize($_SESSION['DATA']['customer']);

        if (!is_a($customer, 'Customer')) {
            $this->error[] = $translate['ERROR']['ERROR_CUSTOMER_DATA'];
            goError($this->error);
        }
        $dateTimeFormat = new DateTimeFormat();
        $dbResevation = new DBReservation();
        $orders = $dbResevation->getByCustomer($customer->id, 0);

        // debug( $_SESSION['CACHE']['CURRENCY'] ,0 );
        if (array_key_exists('OBJ', $_SESSION['CACHE']['CURRENCY']) and is_string($_SESSION['CACHE']['CURRENCY']['OBJ'])) {
            $currency = unserialize($_SESSION['CACHE']['CURRENCY']['OBJ']); // 'OBJ' existierte beim testen tw. nicht -> für diesen Fall Fallback-Lösung
        } else {
            $currency = new Currency();
            $DBCurrencyObj = new DBCurrency();
            if (!isset($_SESSION['CONFIG']['CURRENCY'])) {
                $dbCurrency = $DBCurrencyObj->getBaseCurrency();
                $_SESSION['CONFIG']['CURRENCY'] = $dbCurrency->ISOCode;
                $_SESSION['CONFIG']['CURRENCY_SYMBOL'] = $dbCurrency->Symbol;
            } else {
                $dbCurrency = $DBCurrencyObj->getCurrency();
            }
            $currency->description = $dbCurrency->Beschreibung;
            $currency->symbol = $dbCurrency->Symbol;
            $currency->conversion = $dbCurrency->Umrechnungsfaktor;
            $currency->ISOcode = $dbCurrency->ISOCode;
            $currency->description_lang = (!empty($translate['CURRENCY'][$currency->ISOcode])) ? $translate['CURRENCY'][$currency->ISOcode] : $currency->description;
        }
        $module = new Module();
        $dbCarGroup = new DBCarGroup();

        //debug($orders);
        $js_array = array( // 'https://code.jquery.com/jquery-1.11.1.min.js',
            // 'https://code.jquery.com/ui/1.10.3/jquery-ui.min.js',
            'System.js',
            'CX9Contract.js',
            'Profil.js',
        );
        // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
        $show_login = $module->isEnabled('ORM_LOGIN');
        // Wenn das Historie oder Storno erlaubt sind, muss Login auch sichtbar sein
        if ($module->isEnabled('ORM_HISTORIE') || $module->isEnabled('ORM_STORNO')) {
            $show_login = true;
        }

        if (isset($buchungsstatus)) {
            if ($buchungsstatus == 'aktiv') {
                $this->template->assign('BUCHUNGSSTATUS', 1);
            } else {
                $this->template->assign('BUCHUNGSSTATUS', 0);
            }
        }

        $this->template->assign('LOGIN', 1);
        $this->template->assign('CUSTOMER', $customer);
        $this->template->assign('TITLE', isset($translate['BUCHUNGSLISTE']['SITETITLE']) ? $translate['BUCHUNGSLISTE']['SITETITLE'] : 'BUCHUNGSLISTE.SITETITLE');
        $this->template->assign('CURRENCY', $currency->Symbol);
        $this->template->assign('TRANSLATE', $translate);
        $this->template->assign('JS_FILES', $js_array);
        $this->template->assign('LANG', $this->registry->lang);

        $this->template->assign('ORM_STORNO', isset($this->registry->module['ORM_STORNO']) && $this->registry->module['ORM_STORNO']['enabled'] == 'J');

        $tmp_orders = array();
        foreach ($orders as $order) {
            $order->orderDate = $dateTimeFormat->getDateTime($order->orderDate);
            $order->departureDate = $dateTimeFormat->getDate($order->departureDate);
            $order->arrivalDate = $dateTimeFormat->getDate($order->arrivalDate);
            $order->departureTime = $dateTimeFormat->getTime($order->departureTime);
            $order->arrivalTime = $dateTimeFormat->getTime($order->arrivalTime);

            $order->realArrivalDate = $dateTimeFormat->getDate($order->realArrivalDate);
            $order->realArrivalTime = $dateTimeFormat->getTime($order->realArrivalTime);
            $order->is_canceled = $dbResevation->is_canceled($order->id) == 'S' ? true : false;

            $order->depatureStation->street = $order->depatureStation->strasse;
            $order->depatureStation->zipcode = $order->depatureStation->plz;
            $order->depatureStation->city = $order->depatureStation->ort;
            $order->depatureStation->Telefon = $order->depatureStation->Telefon;

            $order->arrivalStation->street = $order->arrivalStation->strasse;

            $order->arrivalStation->zipcode = $order->arrivalStation->plz;
            $order->arrivalStation->city = $order->arrivalStation->ort;

            $order->parkplatz = (isset($order->auto->MVANUMMER)) ? $dbCarGroup->getPartkplatz($order->auto->MVANUMMER) : null;
            $order->fzg_gruppe = new CarsGroup($order->fzg_gruppe->gruppe);
            $tmp_orders[] = $order;
        }
        $orders = $tmp_orders;

        $_SESSION['NAVI_STEP'] = 'B';
        $this->template->assign('ORDERS', $orders);
        $this->template->assign('BUCHUNGSLISTE', 1);
        $this->template->assign('SHOW_LOGIN', 1);
        $this->template->display('global_template.html');
    }

    public function getInvoice()
    {
        if (!empty($this->registry->args[0])) {
            $order = $this->getOrder($this->registry->args[0]);
            $filename = $order->invoice . '.pdf';

            $dbResevation = new DBReservation();
            $invoice_data = $dbResevation->getInvoice($order->invoice);

            if ($invoice_data == null) {
                $pdf = new Pdfprint();
                $pdf->setFilename($fileName);
                $pdf->setJasperTemplate('rechnung.jasper');
                $pdf->addParam('reno', $order->invoice);
                $pdf->printPDF();
            } else {
                header('Content-Type: application/pdf; charset=UTF-8');
                header('Content-Length: ' . strlen($invoice_data));
                header('Content-Disposition: attachment; filename="' . $filename . '"');
                header('Content-Transfer-Encoding: binary');
                header('Cache-Control: must-revalidate');
                header('Pragma: no-cache');
                header('Expires: 0');
                echo $invoice_data;
                exit;
            }
        }
    }

    public function getReservationConfirm()
    {
        if (!empty($this->registry->args[0])) {
            $order = $this->getOrder($this->registry->args[0]);
            $fileName = 'Reservierung' . (int) $order->id . '.pdf';

            $pdf = new Pdfprint();
            $pdf->setFilename($fileName);
            $pdf->setJasperTemplate('reservierung.jasper');
            $pdf->addParam('resno', $order->id);
            $pdf->printPDF();
        }
    }

    public function isCustomerExist()
    {
        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) && !empty($_REQUEST['email'])) {
            $email = $_REQUEST['email'];

            $customer = Customer::getByEmail($email);
            if (empty($customer)) {
                $customer = new Customer();
            }
            echo json_encode([
                'customer_exist' => ($customer->id > 0 ? 1 : 0),
            ]);
        }
    }

    /*
     * nur wenn Customer eingelogt ist
     */
    private function getOrder($order_id)
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'ERROR' => $dbTranslate->loadTranslations('ERROR', $this->registry->lang),
        );
        if (empty($_SESSION['DATA']['customer']) || !is_a(unserialize($_SESSION['DATA']['customer']), 'Customer')) {
            $this->error[] = $translate['ERROR']['ERROR_CUSTOMER_DATA'];
            goError($this->error);
        }

        $customer = unserialize($_SESSION['DATA']['customer']);
        $dbResevation = new DBReservation();
        $user_id = !empty($customer->id) ? $customer->id : $customer->tmp_num;
        $order = $dbResevation->getByCustomer($user_id, $order_id, '');
        if (empty($order[0])) {
            $this->error[] = $translate['ERROR']['ERROR_MIETVERTRAGSNUMMER'];
            goError($this->error);
        }

        return $order[0];
    }

    public function cancelOrder()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'ERROR' => $dbTranslate->loadTranslations('RENTAL'),
        );
        $db_result = array();
        if (defined('FORCE_CUSTOMER_LOGIN') && FORCE_CUSTOMER_LOGIN == 1 && !isset($_SESSION['DATA']['login']['isLoggedIn']) && !isset($_SESSION['DATA']['customer'])) {
            $db_result = array(
                'error_messages' => empty($translate['ERROR']['LOGIN.LOGOUTMESSAGE']) ? 'RENTAL.RENTAL' : $translate['ERROR']['LOGIN.LOGOUTMESSAGE'],
                'error_code' => -1,
            );
        } else {
            // make the query
            $procedure_name = 'dbo.IND_KM_ORM_CANCEL_RESERVATION';
            $client = unserialize($_SESSION['DATA']['customer']);
            $_POST['username'] = $client->id;
            // $this->send_confirm_mail_cancelation($_POST['contract_id']);
            // exit;
            if (isset($_POST['contract_id'])) {
                $this->process_request($_POST, $procedure_name, 'CX9_', array(
                    'field_prefix',
                    'hash',
                ), array(), function ($data) {
                    if ($data['result'][0]['error_code'] === '2') {
                        // send the e-mail if reservation was canceled
                        // print_r($data);
                        $this->send_confirm_mail_cancelation($_POST['contract_id']);
                    }
                    return $data;
                });
                exit();
            }
        }
        $this->json_headers();
        $loginStatus['STATUS'] = 'LOGIN';
        $loginStatus['MESSAGE'] = '';
        $loginStatus['print_reachability'] = '0';
        echo json_encode(array(
            'loginStatus' => $loginStatus,
            'result' => [
                $db_result,
            ],
        ));
        exit();
    }

    // TODO controller email schreiben
    protected function send_confirm_mail_cancelation($reservation_number = 0)
    {
        $dbStation = new DBStation();
        $code = $dbStation->getStationscodeByVertragsnummer($reservation_number);
        $station = $dbStation->getStationByCode($code);
        Session::setStartStation($station);
        $mail = new Mail();
        $user = unserialize($_SESSION['DATA']['customer']);
        $subject = "";
        if (is_a($user, 'Customer')) {
            $dbTranslate = new DBTranslate();
            $translate = array(
                'EMAILCONFIRM' => $dbTranslate->loadTranslations('MESSAGE.EMAILCONFIRM', $this->registry->lang),
            );
            $subject = $translate['EMAILCONFIRM']['SUBJECT'];
            $template = $this->template;
            $dbText = new DBText();
            $dbStation = new DBStation();

            $station_id = $dbStation->getStationscodeByReservierungsnummer($reservation_number);
            $storno_text = $dbText->getTextByStation($station_id, 'INET_RES_STORNO');
            $user_greeting = $dbText->getTextByStation($station_id, 'INET_RES_STORNO_GREETING');

            $storno_text = str_replace(array('###RESERVIERUNGSNUMMER###'), array($reservation_number), $storno_text->mem);
            $storno_text = !empty($storno_text) ? $storno_text : 'Ihre Reservierung wurde storniert. (Dies ist ein Testtext, da in den Texten ein Text fehlt für den Parameter "INET_RES_STORNO")';
            $dbMandant = new DBMandant();

            $user_greeting = str_replace(array('###GREETING###', '###ANREDE###', '###LASTNAME###', '###FIRSTNAME###'), array($user->greeting, /*$user->anrede*/'', $user->lastname, $user->firstname), $user_greeting->mem);
            $user_greeting = !empty($user_greeting) ? $user_greeting : 'Sehr geehrte Damen und Herren, (Dies ist ein Testtext, da in den Texten ein Text fehlt für den Parameter "INET_RES_STORNO_GREETING")';

            $template->assign('TRANSLATE', $translate);
            $template->assign('USER', $user);
            $template->assign('TITLE_RES_BEST', $subject);
            $template->assign('RES_NO', $reservation_number);
            $template->assign('CONFIRMATION', 1);
            $template->assign('RESERVATION_WAS_CANCELED_TITLE', $user_greeting);
            $template->assign('RESERVATION_WAS_CANCELED_TEXT', $storno_text);
            $template->assign('COMPANY_FULL_NAME', $dbMandant->getInfo()->MandantName);
            $body = $template->fetch('email_reservation_cancelation.html');

            if ($mail->Send($user->email, $subject, $body)) {
                $this->email_error_log($mail->getLog() . "Status: E-Mail erfolgreich gesendet.");
            } else {
                $this->email_error_log($mail->getLog() . "Status: Fehler beim Senden der E-Mail: " . $mail->ErrorInfo());
            }
        }
    }
}
