<?php
class ControllerPayprocess extends ControllerBase
{
    public function index()
    {
        $process_ok = true;
        // AK 24.05.2018 Aufgabe 97803: Datenschutzbestimmungen müssen ebenfalls akzeptiert werden ansonsten Fehler auswerfen und zurück zu Step 5
        DataCheck::checkStep5();

        # KR: dieser Fehlercheck eher in step5, da die zahlungsart in step4 gewählt wird
        $customer = Session::getCustomer();
        $dbPayart = new DBPayart();
        $pay = $dbPayart->getArtById($customer->paymentID);

        if (empty($pay->Zahlungsart)) {
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit();
        }

        # KR: dieser Fehlercheck eher in step4, da die extras in step3 gewählt werden
        $rate = unserialize($_SESSION['DATA']['rates']['primary']);
        if (empty($rate) || !is_a($rate[0], 'Rate')) {
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit;
        }

        $station = Session::getStartStation();
        $ItemName = 'Reservierung bei ' . $station->name;
        $ItemDesc = $rate[0]->description;
        $ItemPrice = $_SESSION['DATA']['total_price'];

        if (Module::isEnabled('PayPalPlus') && (strtolower($pay->Zahlungsart) == strtolower($this->params->getvALUE('PAYPAL_NAME')))) {
            $PayPalPlus = new PayPalPlus();

            if (!empty($PayPalPlus->apiPassword) and !empty($PayPalPlus->apiSignature)) {
                $accessToken = $PayPalPlus->getAuthToken();
                if ($accessToken) {
                    $returnUrl = SITEURL . 'payprocess/paypalplus&PHPSESSID=' . session_id();
                    $cancelUrl = SITEURL . 'step5&PHPSESSID=' . session_id();
                    $description = $ItemName . "\n" . $ItemDesc;
                    $paymentToken = $PayPalPlus->createPayment($accessToken, $returnUrl, $cancelUrl, $ItemPrice, $_SESSION['CONFIG']['CURRENCY'], $description);

                    if ($paymentToken) {
                        $payPalUrl = 'https://www' . $PayPalPlus->payPalMode . '.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=' . $paymentToken;
                        // debug($payPalUrl,0);
                        header('location: ' . $payPalUrl);
                        exit;
                    } else {
                        $this->error = 'PayPalPlus Error';
                        $process_ok = false;
                    }
                } else {
                    $this->error = 'PayPalPlus Error';
                    $process_ok = false;
                }
            } else {
                $this->error = 'PayPalPlus Error';
                $process_ok = false;
            }
        } # entweder 'PayPalPlus' oder 'PayPal', keine parallele Verwendung!
        elseif (Module::isEnabled('PayPal') && (strtolower($pay->Zahlungsart) == strtolower($this->params->getvALUE('PAYPAL_NAME')))) {
            $paypal = new PayPal();
            if (!empty($paypal->api_user) && !empty($paypal->api_password) && !empty($paypal->api_signature)) {
                $logo = Params::getValue('PAYPAL_LOGO');
                if (empty($logo)) {
                    if (file_exists($this->template->template_dir . 'images/LOGO.png')) {
                        $logo = TEMPLATE_URL . 'images/LOGO.png';
                    } else {
                        $logo = '';
                    }
                }

                //$padata = '&METHOD=SetExpressCheckout'.
                $data = '&RETURNURL=' . urlencode(SITEURL . 'payprocess/paypal&PHPSESSID=' . session_id()) .
                '&CANCELURL=' . urlencode(SITEURL . 'step5&PHPSESSID=' . session_id()) .
                '&PAYMENTREQUEST_0_PAYMENTACTION=' . urlencode("SALE") .
                '&L_PAYMENTREQUEST_0_NAME0=' . urlencode($ItemName) .
                '&L_PAYMENTREQUEST_0_DESC0=' . urlencode($ItemDesc) .
                '&L_PAYMENTREQUEST_0_AMT0=' . urlencode($ItemPrice) .
                '&PAYMENTREQUEST_0_AMT=' . urlencode($ItemPrice) .

                '&NOSHIPPING=0' . //set 1 to hide buyer's shipping address, in-case products that does not require shipping

                '&PAYMENTREQUEST_0_CURRENCYCODE=' . urlencode($_SESSION['CONFIG']['CURRENCY']) .
                '&LOCALECODE=DE' . //PayPal pages to match the language on your website.
                //'&PAGESTYLE=CRLA'.//Name of the Custom Payment Page Style for payment pages
                '&LOGOIMG=' . urlencode($logo) . //site logo
                '&CARTBORDERCOLOR=FFFFFF' . //border color of cart
                '&SOLUTIONTYPE=Sole' . //allow guest payments
                '&ALLOWNOTE=1';
                ############# set session variable we need later for "DoExpressCheckoutPayment" #######
                $_SESSION['DATA']['paypal']['ItemName'] = $ItemName; //Item Name
                $_SESSION['DATA']['paypal']['ItemPrice'] = $ItemPrice; //Item Price
                $_SESSION['DATA']['paypal']['ItemDesc'] = $ItemDesc; //Item Number

                $response = $paypal->SendRquest('SetExpressCheckout', $data);
                paypallog($response, 'RESPONSE');
                //debug($data,0);
                //debug($paypal->getLastResponse());
                if (strtoupper($response['ACK']) == 'SUCCESS' || strtoupper($response['ACK']) == 'SUCCESSWITHWARNING') {
                    //Redirect user to PayPal store with Token received.
                    $paypalurl = 'https://www' . ($paypal->mode == 0 ? '.sandbox' : '') . '.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=' . $response['TOKEN'] . '';
                    header('Location: ' . $paypalurl);
                    exit;
                } else {
                    $this->error = 'PayPal Error';
                    $process_ok = false;
                }
            } else {
                $this->error = 'PayPal Error';
                $process_ok = false;
            }
        } // end PayPal
        elseif (Module::isEnabled('ConCardis') && (strtolower($pay->Zahlungsart) == strtolower($this->params->getvALUE('CONCARDIS_NAME')))) {
            $station = Session::getStartStation();
            // $customer = new Consumer();  # evtl. nicht nötig?
            $customer = unserialize($_SESSION['DATA']['customer']);

            $lang = Session::getLang();
            $concardis = new ConCardis();
            $concardis->ORDERID = $station->code . '-' . microtime();
            $concardis->AMOUNT = round(floatval($_SESSION['DATA']['total_price']) * 100);
            $concardis->CURRENCY = $_SESSION['CONFIG']['CURRENCY'];
            $concardis->LANGUAGE = strtolower($lang) . '_' . strtoupper($lang);
            $concardis->TITLE = $station->name;
            $concardis->CN = $customer->firstname . ' ' . $customer->lastname;
            $concardis->EMAIL = $customer->email;
            $concardis->OWNERZIP = $customer->zipcode;
            $concardis->OWNERADDRESS = $customer->street;
            $concardis->OWNERTOWN = $customer->city;
            $concardis->OWNERCTY = 'Germany'; // TODO Counry von Benutzer
            $concardis->OWNERTELNO = $customer->phone;
            $concardis->HOMEURL = !empty($station->url) ? $station->url : SITEURL;

            if (!$concardis->sendRequest()) {
                $this->error = 'ConCardis Error';
                $process_ok = false;
            }
        } // end ConCardis

        if ($process_ok) {
            $_SESSION['DATA']['reservate'] = 1;
            header('location: ' . SITEURL . 'reservate&PHPSESSID=' . session_id());
            exit;
        } else {
            # Im Fehlerfall ggf. anderes Weiterleitungsziel
            $_SESSION['error'] = $this->error;
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit;
        }
    } // index()

    public function paypalplus()
    {
        $DbTranslate = new DBTranslate();
        $translate = [];
        $translate['PAYPAL'] = $DbTranslate->loadTranslations('PAYPAL');

        $pay_transaction_id = '';
        if ($_GET['paymentId'] and $_GET['PayerID']) {
            $PayPalPlus = new PayPalPlus();
            $accessToken = $PayPalPlus->getAuthToken();
            $pay_transaction_id = $PayPalPlus->executePayment($accessToken, $_GET['paymentId'], $_GET['PayerID']);
        } else {
            $this->error = 'PayPalPlus Error';
            paypallog($PayPalPlus->getErrorStatus($accessToken, $_GET['paymentId']), 'RESPONSE');
        }

        if (!empty($this->error)) {
            $_SESSION['error'] = $this->error;
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit;
        } else {
            $_SESSION['DATA']['reservate'] = 1;
            if ($pay_transaction_id != '') {
                $_SESSION['DATA']['PAYID'] = $pay_transaction_id;
            }
            header('location: ' . SITEURL . 'reservate&PHPSESSID=' . session_id());
            exit;
        }
    }

    public function paypal()
    {
        $dbTranslate = new DBTranslate();
        $translate = [];
        $translate['PAYPAL'] = $dbTranslate->loadTranslations('PAYPAL');

        $pay_transaction_id = '';
        if (isset($_GET['token']) && isset($_GET['PayerID'])) {
            $token = $_GET['token'];
            $payer_id = $_GET['PayerID'];

            $ItemName = $_SESSION['DATA']['paypal']['ItemName']; //Item Name
            $ItemPrice = $_SESSION['DATA']['paypal']['ItemPrice']; //Item Price
            $ItemDesc = $_SESSION['DATA']['paypal']['ItemDesc']; //Item Number

            $data = '&TOKEN=' . urlencode($token) .
            '&PAYERID=' . urlencode($payer_id) .
            '&PAYMENTREQUEST_0_PAYMENTACTION=' . urlencode('SALE') .
            '&L_PAYMENTREQUEST_0_NAME0=' . urlencode($ItemName) .
            '&L_PAYMENTREQUEST_0_DESC0=' . urlencode($ItemDesc) .
            '&L_PAYMENTREQUEST_0_AMT0=' . urlencode($ItemPrice) .
            '&PAYMENTREQUEST_0_AMT=' . urlencode($ItemPrice) .
            '&PAYMENTREQUEST_0_CURRENCYCODE=' . urlencode($_SESSION['CONFIG']['CURRENCY']);

            // We need to execute the "DoExpressCheckoutPayment" at this point to Receive payment from user.
            $paypal_log = array();

            $paypal = new PayPal();
            $response = $paypal->SendRquest('DoExpressCheckoutPayment', $data);
            paypallog($response, 'RESPONSE');
            foreach ($response as &$val) {
                $val = urldecode($val);
            }
            unset($val);
            $response['METHOD'] = 'DoExpressCheckoutPayment';
            $paypal_log[] = $response;

            $status = $response['PAYMENTINFO_0_PAYMENTSTATUS'];
            if ($status == 'Completed' || $status == 'Processed' || $status == 'Pending' || $status == 'Completed-Funds-Held') {
                $pay_transaction_id = $response['PAYMENTINFO_0_TRANSACTIONID'];
                $data = '&TOKEN=' . urlencode($token);
                $paypal = new PayPal();
                $response = $paypal->SendRquest('GetExpressCheckoutDetails', $data);
                paypallog($response, 'RESPONSE');
                foreach ($response as &$val) {
                    $val = urldecode($val);
                }
                unset($val);
                $response['METHOD'] = 'GetExpressCheckoutDetails';
                $paypal_log[] = $response;
                if ($status != 'Completed') {
                    $_SESSION['MESSAGES'][] = $translate['PAYPAL']['STATUS_CX9_PROCESSED'];
                    $_SESSION['PAY_PENDING'] = 1;
                }
            } else {
                $error_status = $response["PAYMENTINFO_0_PAYMENTSTATUS"];
                $error_status = 'STATUS_' . strtoupper(str_replace('-', '_', $error_status));
                $this->error = $translate['PAYPAL'][$error_status];
            }
        } else {
            $this->error = 'PayPal Error';
        }

        if (!empty($this->error)) {
            $_SESSION['error'] = $this->error;
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit;
        } else {
            $_SESSION['DATA']['reservate'] = 1;
            if ($pay_transaction_id != '') {
                $_SESSION['DATA']['PAYID'] = $pay_transaction_id;
            }
            header('location: ' . SITEURL . 'reservate&PHPSESSID=' . session_id());
            exit;
        }
    } // paypal()

    public function concardis()
    {
        $params = new Params();
        $concardis_sha = $params->getValue('CONCARDIS_SIGNATUR_OUT');
        $sha_array = array();

        foreach ($_GET as $key => $val) {
            $sha_array[strtoupper($key)] = $val;
        }
        ksort($sha_array);

        $sha_str = '';
        foreach ($sha_array as $key => $val) {
            if ($key != 'SHASIGN' && $key != 'ROUTE') {
                $sha_str .= strtoupper($key) . '=' . $val . $concardis_sha;
            }
        }

        if (strtoupper(sha1($sha_str)) != strtoupper($sha_array['SHASIGN'])) {
            $this->error = 'ConCardis Error';
        }

        if (!empty($this->error)) {
            $_SESSION['error'] = $this->error;
            header('location: ' . SITEURL . 'step5&PHPSESSID=' . session_id());
            exit;
        } else {
            $_SESSION['DATA']['reservate'] = 1;
            $_SESSION['DATA']['PAYID'] = $_GET['PAYID'];
            header('location: ' . SITEURL . 'reservate&PHPSESSID=' . session_id());
            exit;
        }
    } // concardis()
} // Class ControllerPayprocess
