<?php
class ControllerPrices extends ControllerBase
{
    private $main_rate = array();
    private $sub_rate_options = array();

    public function index()
    {
        if ($_GET['useOffer'] == 0) {
            unset($_SESSION['ANGEBOTPK']);
            $_SESSION['ANGEBOTPK'] = '';
        }

        $this->checkLogin();

        $car_group = null;
        $date_dep = null;
        $date_arr = null;
        $time_dep = null;
        $time_arr = null;
        $station_dep = null;
        $station_arr = null;
        $dateTimeFormat = new DateTimeFormat();

        $car_group = Session::getCarGroup();
        if (!empty($_GET['car_group']) && (empty($car_group) || $car_group->code != $_GET['car_group'])) {
            $car_group = new CarsGroup($_GET['car_group']);
            Session::setCarGroup($car_group);
        }
        DataCheck::checkStep3();

        $_SESSION['NAVI_MAX_STEP'] = 3;
        $_SESSION['STEP'] = 3;

        $rental_hash = Session::getRentalHash();
        $session_hash = Session::getSessionRentalHash();
        $new_rate_calculate = $rental_hash != $session_hash;

        $station_dep = Session::getStartStation();
        $station_arr = Session::getEndStation();
        $start_date_time = new DateTime;
        $start_date_time->setTimestamp(Session::getStartDateTime());
        $end_date_time = new DateTime;
        $end_date_time->setTimestamp(Session::getEndDateTime());

        $translate = $this->loadTranslations(array('MESSAGE', 'RATE', 'Einheiten', 'RENTAL', 'NAVI', 'FZG', 'GLOBAL', 'LOGIN_BAR',
            'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'STEP3', 'CAR_GROUP', 'TARIF', 'EXTRAS', 'RABATT', 'NEW_PASSWORD', 'STATION_SELECT', 'STATION', 'STATION_BLOCK', 'Wochentage', 'Wochentage_kurz', 'Monate_kurz', 'Feiertage', 'EinheitEinzahl'));
        $this->registry->translate = $translate;

        $dbRate = new DBRate();

        $this->registry->dbRate = $dbRate;

        $currency = new Currency();
        $dbCurrency = new DBCurrency();
        $dbCurrencyObj = $dbCurrency->getCurrency();

        $currency->description = $dbCurrencyObj->Beschreibung;
        $currency->symbol = $dbCurrencyObj->Symbol;
        $currency->conversion = $dbCurrencyObj->Umrechnungsfaktor;
        $currency->ISOcode = $dbCurrencyObj->ISOCode;

        $customer = Session::getCustomer();
        $is_login = false;
        if (isset($_SESSION['DATA']['login']['isLoggedIn'])) {
            $is_login = true;
        }
        $total_price = 0;
        $summ_or_percent_rabat = 0;
        $fix_rabat = 0;

        if ($new_rate_calculate) {
            Session::delAllRates();
            Session::delDiscount();
            // Berechnung des Angebots
            if (!empty($_SESSION['ANGEBOTPK'])) {
                $dbRates = $dbRate->RateCalcAufruf(
                    $_SESSION['ANGEBOTPK'],
                    $car_group->cargroupid,
                    $start_date_time->format('d.m.Y H:i'),
                    $end_date_time->format('d.m.Y H:i'),
                    $station_dep->code,
                    $station_arr->code,
                    Session::getAddKm()
                );

                $tmp_rate = $dbRates[0];
                // Angebot nicht gültig -> Berechung der Bestprice-Funktion
                // if (empty($dbRates)) { -------AK 07.12.2016 Aufgabe 85026 : Prüfung umgestellt, sodass diese mit der Prüfung in Step 2 identisch ist und korrekt arbeitet
                if (($tmp_rate == null) || (intval($tmp_rate->Anzahl) == 0)) {
                    $dbRates = $dbRate->getRate(
                        $start_date_time->format('d.m.Y H:i'),
                        $end_date_time->format('d.m.Y H:i'),
                        $station_dep->code,
                        $station_arr->code,
                        $car_group->cargroupid,
                        Session::getAddKm(),
                        '',
                        0,
                        $summ_or_percent_rabat,
                        $fix_rabat
                    );
                }
            } // Berechung der Bestprice-Funktion
            else {
                $dbRates = $dbRate->getRate(
                    $start_date_time->format('d.m.Y H:i'),
                    $end_date_time->format('d.m.Y H:i'),
                    $station_dep->code,
                    $station_arr->code,
                    $car_group->cargroupid,
                    Session::getAddKm(),
                    '',
                    0,
                    $summ_or_percent_rabat,
                    $fix_rabat
                );
            }

            foreach ($dbRates as $dbRateValue) {
                $tmpRate = new Rate();
                $tmpRate->decodeFromDb($dbRateValue);
                $this->main_rate[] = $tmpRate;
            }

            $dbZusRates = $dbRate->getZusRate($start_date_time->format('d.m.Y H:i'), $end_date_time->format('d.m.Y H:i'), $station_dep->code, $station_arr->code, $car_group->cargroupid, 0, '', $this->main_rate[0]);
            foreach ($dbZusRates as $dbRateValue) {
                $tmpSubRate = new Rate();
                $tmpSubRate->decodeFromDb($dbRateValue);
                // AK 22.05.2018 Aufgabe 94622: Anzeige der Einzelpreise mit entsprechendem Text "pro $EINHEIT"
                $tmpSubRate->per_single_unit_text = str_replace('$EINHEIT', isset($translate['EinheitEinzahl'][$tmpSubRate->unit]) ? $translate['EinheitEinzahl'][$tmpSubRate->unit] : (isset($translate['Einheiten'][$tmpSubRate->unit]) ? $translate['Einheiten'][$tmpSubRate->unit] : $tmpSubRate->unit), (isset($translate['STEP3']['PRICE_PER']) ? $translate['STEP3']['PRICE_PER'] : 'Preis pro $EINHEIT'));
                $tmpSubRate->per_single_extra_unit_text = str_replace('$EINHEIT', isset($translate['EinheitEinzahl'][$tmpSubRate->extra_unit]) ? $translate['EinheitEinzahl'][$tmpSubRate->extra_unit] : (isset($translate['Einheiten'][$tmpSubRate->extra_unit]) ? $translate['Einheiten'][$tmpSubRate->extra_unit] : $tmpSubRate->extra_unit), (isset($translate['STEP3']['PRICE_PER_ZUS']) ? $translate['STEP3']['PRICE_PER_ZUS'] : 'Preis pro Zusatz$EINHEIT'));
                $this->sub_rate_options[] = $tmpSubRate;
            }

            usort($this->sub_rate_options, function ($a, $b) {
                if (strtoupper($a->description) == strtoupper($b->description)) {
                    return 0;
                }
                return (strtoupper($a->description) < strtoupper($b->description)) ? -1 : 1;
            });

            Session::setPrimaryRates($this->main_rate);
            Session::setSubRates($this->sub_rate_options);
        } else {
            $this->main_rate = Session::getPrimaryRate();
            $this->sub_rate_options = Session::getSubRates();
        }
        // Auslesen des Gutscheincodes
        $discount = Session::getDiscount();
        if (!empty($discount)) {
            if (!empty($discount['persent'])) {
                $summ_or_percent_rabat = $discount['persent'];
                $fix_rabat = 0;
            } elseif (!empty($discount['summe'])) {
                $summ_or_percent_rabat = $discount['summe'];
                $fix_rabat = 1;
            }
        }

        $firstrates = $this->params->getValue('FIRSTRATES');
        $firstrates = explode(';', $firstrates);
        $firstrates_list = array();
        foreach ($this->sub_rate_options as $key => $val) {
            if (in_array($val->rate, $firstrates)) {
                $firstrates_list[] = $val;
                unset($this->sub_rate_options[$key]);
            }
        }

        if (defined('FIRSTRATES_SORTING_ASC') and FIRSTRATES_SORTING_ASC or defined('FIRSTRATES_SORTING_DESC') and FIRSTRATES_SORTING_DESC) {
            if (defined('FIRSTRATES_SORTING_DESC') and FIRSTRATES_SORTING_DESC) {
                array_multisort($firstratesSortTmp, SORT_DESC, SORT_NUMERIC, $firstrates_list);
            } else {
                array_multisort($firstratesSortTmp, SORT_ASC, SORT_NUMERIC, $firstrates_list);
            }
        }

        $subratesByCategory = array();
        foreach ($this->sub_rate_options as $val) {
            // CW 24.01.2020: Aufgabe 1111648 - Zusatzeinheiten bei Zusatzraten nicht anzeigen
            if (substr($val->rate, -3) === 'ZUS') {
                continue;
            }
            $subratesByCategory[$val->category]['category_lang'] = (isset($translate['RATE']['CATEGORY'][$val->category_lang]) && $translate['RATE']['CATEGORY'][$val->category_lang] !== '') ? $translate['RATE']['CATEGORY'][$val->category_lang] : $val->category_lang;
            $subratesByCategory[$val->category]['objects'][] = $val;
        }

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $text_footer = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP3');
        $text_footer->mem = isset($text_footer->mem) ? $text_footer->mem : 'INET_ZUS_TEXT_STEP3';

        $js_array = array(
            'System.js', 'Libs.js', 'Rates.js', 'iframeResizer.contentWindow.js', 'CX9Contract.js');
        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        if (count($this->error) > 0) {
            goError($this->error);
        }

        $template = $this->template;
        $template->assign('JS_FILES', $js_array);

        $date = array('date_dep' => $start_date_time->format($dateTimeFormat->getDateFormat()),
            'date_arr' => $end_date_time->format($dateTimeFormat->getDateFormat()),
            'time_dep' => $start_date_time->format($dateTimeFormat->getTimeFormat()),
            'time_arr' => $end_date_time->format($dateTimeFormat->getTimeFormat()),
        );

        $password_reset_text = $dbText->getTextByStation($station->code, 'PASSWORD_RESET_TEXT');
        $password_reset_text->mem = isset($password_reset_text->mem) ? $password_reset_text->mem : 'PASSWORD_RESET_TEXT';

        $stations_dep = Station::getStationListFromCache('departure');
        $stations_arr = Station::getStationListFromCache('arrival');
        $module = new Module();

        $template->assign('STATIONS_DEP', $stations_dep);
        $template->assign('STATIONS_ARR', $stations_arr);

        $template->assign('DATE', $date);

        $template->assign('STATION_DEP', $station_dep);
        $template->assign('STATION_ARR', $station_arr);

        $template->assign('NAVI_STEP', $_SESSION['STEP']);
        $template->assign('NAVI_MAX_STEP', $_SESSION['NAVI_MAX_STEP']);

        $template->assign('TITLE', isset($translate['STEP3']['SITETITLE']) ? $translate['STEP3']['SITETITLE'] : 'STEP3.SITETITLE');
        $template->assign('ERROR', $this->error);
        $template->assign('TRANSLATE', $translate);

        $template->assign('CARGROUP', $car_group);
        $template->assign('RATES', $this->main_rate);

        $template->assign('SUBRATES_CATEGORIZED', $subratesByCategory);
        $template->assign('FIRST_SUBRATES', $firstrates_list);

        $template->assign('CURRENCY', $currency);
        $template->assign('TOTAL_PRISE', $this->getTotalPrice() * $currency->conversion);
        $template->assign('SUBPRICE_RATES', $this->getSubPriceRates() * $currency->conversion);
        $template->assign('SUBPRICE_EXTRAS', $this->getSubPriceExtras() * $currency->conversion);

        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $template->assign('TOTAL_PRISE_NETTO', $this->getTotalPriceNetto() * $currency->conversion);
        $template->assign('ADDKM', isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : '');
        $template->assign('SID', session_id());
        $template->assign('DISCOUNT', !empty($discount['code']) ? $discount : '');

        $template->assign('CUSTOMER', $customer);
        $template->assign('LOGIN', $is_login);

        $template->assign('SHOW_KM', 1);
        $template->assign('SHOW_VOUCHER', Params::getValue('BWEB_PERCENTBASED_VOUCHER'));
        $template->assign('SHOW_ZUSRATES_OPEN', Params::getValue('BINET_SHOW_ZUSRATES_OPEN'));

        $template->assign('INET_ZUS_TEXT', $text_footer->mem);
        $template->assign('PASSWORD_RESET_TEXT', $password_reset_text->mem);

        $template->assign('LANG', Session::getLang());
        $template->assign('SHOW_SUBDESCRIPTION_AS_TOOLTIP', (defined('SHOW_SUBDESCRIPTION_AS_TOOLTIP') and SHOW_SUBDESCRIPTION_AS_TOOLTIP ? 1 : 0));

        // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
        $show_login = Module::isEnabled('ORM_LOGIN');
        // Wenn das Historie oder Storno erlaubt sind, muss Login auch sichtbar sein
        if (Module::isEnabled('ORM_HISTORIE') || Module::isEnabled('ORM_STORNO')) {
            $show_login = true;
        }
        $template->assign('SHOW_LOGIN', $show_login);

        $dbError = new DBError();
        $errors = $dbError->checkErrors(3, $start_date_time, $end_date_time, $station_dep, $station_arr, $car_group->code);

        if (!empty($errors[0])) {
            goError($errors);
        }

        Session::setSessionRentalHash();
        $template->display('global_template.html');
    }

    public function update()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $currency = new Currency();
            $dbCurrency = new DBCurrency();
            $dbCurrencyObj = $dbCurrency->getCurrency();

            $currency->decodeFromDb($dbCurrencyObj);

            if (!empty($_GET['option'])) {
                $option_code = str_replace('rate_', '', trim($_GET['option']));
                $zus_option_code = $option_code . 'ZUS';

                $rate = null;

                $cached_rates = Session::getSubRates();

                foreach ($cached_rates as $cached_rate) {
                    if ($cached_rate->rate === $option_code) {
                        $rate = $cached_rate;
                        $rate->selected = !$rate->selected;
                        // AK 01.03.2016 - $rate->count darf nur bei Stückraten auf 0 gesetzt werden, da sonst die Anzeige in Step 4 nicht mehr korrekt ist
                        if ($rate->is_stuk) {
                            if (!$rate->selected) {
                                $rate->count = 0;
                            } else {
                                $rate->count = $rate->count > 1 ? $rate->count : ($rate->minCount > 1 ? $rate->minCount : 1);
                            }
                        }
                        break;
                    }
                }
                // CW 24.01.2020: Aufgabe 1111648 - Zusatzeinheiten bei Zusatzraten berechnen (anhaken)
                foreach ($cached_rates as $cached_rate) {
                    if ($cached_rate->rate === $zus_option_code) {
                        $cached_rate->selected = !$cached_rate->selected;
                        // AK 01.03.2016 - $cached_rate->count darf nur bei Stückraten auf 0 gesetzt werden, da sonst die Anzeige in Step 4 nicht mehr korrekt ist
                        if ($cached_rate->is_stuk) {
                            if (!$cached_rate->selected) {
                                $cached_rate->count = 0;
                            } else {
                                $cached_rate->count = $cached_rate->count > 1 ? $cached_rate->count : ($cached_rate->minCount > 1 ? $cached_rate->minCount : 1);
                            }
                        }
                        break;
                    }
                }
                if ($rate !== null) {
                    if ($rate->cdw) {
                        foreach ($cached_rates as &$cached_rate) {
                            if ($cached_rate->cdw && $cached_rate->rate !== $rate->rate) {
                                $cached_rate->selected = false;
                            }
                        }
                    }

                    Session::setSubRates($cached_rates);
                } else {
                    echo "Error. Rate im Cache nicht gefunden";
                    exit();
                }
            } elseif (isset($_GET['total_price'])) {
                // nothing
            } else {
                echo "Error: Falscher Ratentyp";
                exit();
            }

            $total_price = $this->getTotalPrice();

            // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
            $total_price_netto = $this->getTotalPriceNetto();
            $total_price *= $currency->conversion;

            // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
            $total_price_netto *= $currency->conversion;
            // YM ..... BITTE IMMER PÜFEN OB OBJEKT EXESTIERT!!!!!

            $subprice_rates = $this->getSubPriceRates();
            $subprice_extras = $this->getSubPriceExtras();
            if (empty($rate)) {
                $rate = new Rate;
            }

            $Format = new Format();
            echo json_encode(array(
                'total_price' => round($total_price, 2),
                'total_price_formatted' => $Format->currencyFormat($total_price, true, false),
                'total_price_netto' => round($total_price_netto, 2),
                'total_price_netto_formatted' => $Format->currencyFormat($total_price_netto, true, false),
                'subprice_rates' => round($subprice_rates, 2),
                'subprice_rates_formatted' => $Format->currencyFormat($subprice_rates, true, false),
                'subprice_extras' => round($subprice_extras, 2),
                'subprice_extras_formatted' => $Format->currencyFormat($subprice_extras, true, false),
                'autobuch' => (!empty($rate->autobuch) ? 1 : 0),
                'count' => $rate->count,
                'break' => 0,
                'cdw' => $rate->cdw ? 1 : 0));
        } else {
            error404();
        }
    }

    public function addkm()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $error_msg = '';
            $html_out = '';
            $html_km_out = '';
            $html_overlay_out = '';

            if (isset($_GET['addkm']) && intval($_GET['addkm']) >= 0) {
                $start_date_time = new DateTime;
                $start_date_time->setTimestamp(Session::getStartDateTime());
                $end_date_time = new DateTime;
                $end_date_time->setTimestamp(Session::getEndDateTime());
                $start_station = Session::getStartStation();
                $end_station = Session::getEndStation();
                $group = Session::getCarGroup();

                $translations = $this->loadTranslations(array('MESSAGE', 'RATE', 'Einheiten', 'RENTAL', 'NAVI', 'FZG', 'GLOBAL', 'LOGIN_BAR',
                    'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'STEP3', 'CAR_GROUP', 'TARIF', 'EXTRAS', 'RABATT', 'NEW_PASSWORD', 'EinheitEinzahl'));

                // $discount = ! empty(Session::getDiscount()) ? Session::getDiscount() : array('persent' => 0, 'summe' => 0);  #funktioniert nicht in PHP 5.4
                $testVar = Session::getDiscount();
                $discount = !empty($testVar) ?Session::getDiscount() : array('persent' => 0, 'summe' => 0);

                $summ_or_percent_rabat = $discount['persent'] > 0 ? $discount['persent'] : ($discount['summe'] > 0 ? $discount['summe'] : 0);
                $fix_rabat = $discount['summe'] > 0 ? 1 : 0;

                Session::setAddKm($_GET['addkm']);

                $dbRate = new DBRate();
                $this->registry->dbRate = $dbRate;

                if (!empty($_SESSION['ANGEBOTPK'])) {
                    $dbRates = $dbRate->RateCalcAufruf(
                        $_SESSION['ANGEBOTPK'],
                        $group->code,
                        $start_date_time->format('d.m.Y H:i'),
                        $end_date_time->format('d.m.Y H:i'),
                        $start_station->code,
                        $end_station->code,
                        Session::getAddKm()
                    );

                    $offerTotalPrice = 0;

                    foreach ($dbRates as $rate) {
                        $offerTotalPrice += $rate->gesamtpreisbrutto;
                    }
                    $dbRatesOffer = $dbRates;
                    $tmp_rate = $dbRates[0];
                    // Angebot nicht gültig -> Berechung der Bestprice-Funktion
                    if (($tmp_rate == null) || (intval($tmp_rate->Anzahl) == 0)) {
                        $dbRates = $dbRate->getRate($start_date_time->format('d.m.Y H:i'), $end_date_time->format('d.m.Y H:i'), $start_station->code, $end_station->code, $group->code, Session::getAddKm(), '', 0, $summ_or_percent_rabat, $fix_rabat);
                    } else {
                        // Angebot gültig -> Nach günstigerem BestPrice suchen
                        $offerRate = $tmp_rate;

                        $dbRatesNoOffer = $dbRate->getRate($start_date_time->format('d.m.Y H:i'), $end_date_time->format('d.m.Y H:i'), $start_station->code, $end_station->code, $group->code, Session::getAddKm(), '', 0, $summ_or_percent_rabat, $fix_rabat);

                        $totalPrice = 0;

                        foreach ($dbRatesNoOffer as $rate) {
                            $totalPrice += $rate->gesamtpreisbrutto;
                        }

                        $tmp_rate = $dbRatesNoOffer[0];

                        if (($tmp_rate !== null) || (intval($tmp_rate->Anzahl) > 0)) {
                            if ($offerTotalPrice < $totalPrice) {
                                $tmp_rate = $offerRate;
                                $dbRates = $dbRatesOffer;
                            } else {
                                $noOfferRates = [];
                                $offerRates = [];

                                foreach ($dbRatesNoOffer as $dbRateValue) {
                                    $tmpRate = new Rate();
                                    $tmpRate->decodeFromDb($dbRateValue);
                                    if ($tmpRate->count == 1) {
                                        $tmpRate->unit = isset($translations['EinheitEinzahl'][$tmpRate->unit]) ? $translations['EinheitEinzahl'][$tmpRate->unit] : (isset($translations['Einheiten'][$tmpRate->unit]) ? $translations['Einheiten'][$tmpRate->unit] : $tmpRate->unit);
                                    }

                                    $noOfferRates[] = $tmpRate;
                                }

                                foreach ($dbRatesOffer as $dbRateValue) {
                                    $tmpRate = new Rate();
                                    $tmpRate->decodeFromDb($dbRateValue);
                                    if ($tmpRate->count == 1) {
                                        $tmpRate->unit = isset($translations['EinheitEinzahl'][$tmpRate->unit]) ? $translations['EinheitEinzahl'][$tmpRate->unit] : (isset($translations['Einheiten'][$tmpRate->unit]) ? $translations['Einheiten'][$tmpRate->unit] : $tmpRate->unit);
                                    }

                                    $offerRates[] = $tmpRate;
                                }

                                $this->template->assign('BESTRATES', $noOfferRates);
                                $this->template->assign('BESTRATES_TOTAL', $totalPrice);
                                $this->template->assign('OFFERRATES', $offerRates);
                                $this->template->assign('OFFERRATES_TOTAL', $offerTotalPrice);
                                $this->template->assign('TRANSLATE', $translations);
                                $this->template->assign('NAVI_STEP', $_SESSION['STEP']);
                                $html_overlay_out = $this->template->fetch('particals/_lower_price_overlay.html');
                            }
                        }
                    }
                } // Berechung der Bestprice-Funktion
                else {
                    $dbRates = $dbRate->getRate(
                        $start_date_time->format('d.m.Y H:i'),
                        $end_date_time->format('d.m.Y H:i'),
                        $start_station->code,
                        $end_station->code,
                        $group->code,
                        Session::getAddKm(),
                        '',
                        0,
                        $summ_or_percent_rabat,
                        $fix_rabat
                    );
                }

                foreach ($dbRates as $dbRateValue) {
                    $tmpRate = new Rate();
                    $tmpRate->decodeFromDb($dbRateValue);
                    $this->main_rate[] = $tmpRate;
                }

                if (count($this->main_rate) > 0 && is_a($this->main_rate[0], 'Rate')) {
                    $km = $this->main_rate[0]->km_free;
                    $km_price = $this->main_rate[0]->sub_km_price;

                    // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
                    $km_price_netto = $this->main_rate[0]->sub_km_price_netto;

                    Session::setPrimaryRates($this->main_rate);
                }
                $dbZusRates = $dbRate->getZusRate(
                    $start_date_time->format('d.m.Y H:i'),
                    $end_date_time->format('d.m.Y H:i'),
                    $start_station->code,
                    $end_station->code,
                    $group->code,
                    Session::getAddKm(),
                    '',
                    $this->main_rate[0]
                );

                foreach ($dbZusRates as $dbRateValue) {
                    $tmpSubRate = new Rate();
                    $tmpSubRate->decodeFromDb($dbRateValue);
                    // AK 22.05.2018 Aufgabe 94622: Anzeige der Einzelpreise mit entsprechendem Text "pro $EINHEIT"
                    $tmpSubRate->per_single_unit_text = str_replace('$EINHEIT', isset($translate['EinheitEinzahl'][$tmpSubRate->unit]) ? $translate['EinheitEinzahl'][$tmpSubRate->unit] : (isset($translate['Einheiten'][$tmpSubRate->unit]) ? $translate['Einheiten'][$tmpSubRate->unit] : $tmpSubRate->unit), (isset($translate['STEP3']['PRICE_PER']) ? $translate['STEP3']['PRICE_PER'] : 'Preis pro $EINHEIT'));
                    $tmpSubRate->per_single_extra_unit_text = str_replace('$EINHEIT', isset($translate['EinheitEinzahl'][$tmpSubRate->extra_unit]) ? $translate['EinheitEinzahl'][$tmpSubRate->extra_unit] : (isset($translate['Einheiten'][$tmpSubRate->extra_unit]) ? $translate['Einheiten'][$tmpSubRate->extra_unit] : $tmpSubRate->extra_unit), (isset($translate['STEP3']['PRICE_PER_ZUS']) ? $translate['STEP3']['PRICE_PER_ZUS'] : 'Preis pro Zusatz$EINHEIT'));
                    $this->sub_rate_options[] = $tmpSubRate;
                }

                usort($this->sub_rate_options, function ($a, $b) {
                    if (strtoupper($a->description) == strtoupper($b->description)) {
                        return 0;
                    }
                    return (strtoupper($a->description) < strtoupper($b->description)) ? -1 : 1;
                });

                // AK 07.05.2018 Aufgabe 94158: bei Berechnung der KM müssen vorher ausgewählte Zusatzraten beachtet werden
                $option_rates = Session::getSubRates();
                if (!empty($option_rates)) {
                    foreach ($option_rates as $key => $val) {
                        $this->sub_rate_options[$key]->selected = $val->selected;
                        if ($val->is_stuk) {
                            $this->sub_rate_options[$key]->count = $val->count;
                        }
                    }
                }
                Session::setSubRates($this->sub_rate_options);

                $firstrates = $this->params->getValue('FIRSTRATES');
                $firstrates = explode(';', $firstrates);
                $firstrates_list = array();
                foreach ($this->sub_rate_options as $key => $val) {
                    if (in_array($val->rate, $firstrates)) {
                        $firstrates_list[] = $val;
                        unset($this->sub_rate_options[$key]);
                    }
                }

                $subratesByCategory = array();
                foreach ($this->sub_rate_options as $val) {
                    // CW 24.01.2020: Aufgabe 1111648 - Zusatzeinheiten bei Zusatzraten nicht anzeigen
                    if (substr($val->rate, -3) === 'ZUS') {
                        continue;
                    }
                    $subratesByCategory[$val->category]['category_lang'] = (isset($translate['RATE']['CATEGORY'][$val->category_lang]) && $translate['RATE']['CATEGORY'][$val->category_lang] !== '') ? $translate['RATE']['CATEGORY'][$val->category_lang] : $val->category_lang;
                    $subratesByCategory[$val->category]['objects'][] = $val;
                }

                $currency = new Currency();
                $dbCurrency = new DBCurrency();
                $dbCurrencyObj = $dbCurrency->getCurrency();

                $currency->decodeFromDb($dbCurrencyObj);

                $this->template->assign('NAVI_STEP', $_SESSION['STEP']);
                $this->template->assign('SHOW_KM', 1);

                $this->template->assign('RATES', $this->main_rate);
                $this->template->assign('TRANSLATE', $translations);
                $this->template->assign('CURRENCY', $currency);
                $this->template->assign('ADDKM', isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : '');

                $html_out = $this->template->fetch('tarif_details.html');

                $this->template->assign('SUBRATES_CATEGORIZED', $subratesByCategory);
                $this->template->assign('FIRST_SUBRATES', $firstrates_list);

                $this->template->assign('SHOW_ZUSRATES_OPEN', Params::getValue('BINET_SHOW_ZUSRATES_OPEN'));

                $html_zusrates_out = $this->template->fetch('extras_form.html');

                // TODO this is a part of view!!! not controller!!! -> Auslagerung in eingenes template
                $Format = new Format();
                $html_km_out = '<span class="test">' . $translations['RATE']['KMFREI'] . ': <span id="free_km" class="free_km">' . $km . '</span> - ' . $translations['RATE']['KMPREIS'] . ': ' . $Format->currencyFormat($km_price) . '</span>';
            } else {
                $error_msg = 'Falscher Eingabewert!';
            }

            $out_array = array('error' => $error_msg, 'html' => $html_out, 'html_km' => $html_km_out, 'html_zusrates' => $html_zusrates_out, 'subprice_rates' => $this->getSubPriceRates(), 'subprice_extras' => $this->getSubPriceExtras(), 'html_overlay' => $html_overlay_out);

            echo json_encode($out_array);
        } else {
            error404();
        }
        Session::setSessionRentalHash();
    }
    // addkm()

    public function discount()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $discount_disable = false;
            $sleep = 1;
            if (empty($_SESSION['DATA']['discount']['disable'])) {
                $_SESSION['DATA']['discount']['disable']['last_time'] = time();
                $_SESSION['DATA']['discount']['disable']['try'] = 1;
            } else {
                $count = ++$_SESSION['DATA']['discount']['disable']['try'];
                if ($count > 3 && $count <= 5) {
                    $sleep = 3;
                } elseif ($count > 5 && $count <= 10) {
                    $sleep = 10;
                } elseif ($count > 10) {
                    $sleep = 3600;
                }

                $def_time = time() - $_SESSION['DATA']['discount']['disable']['last_time'];
                $_SESSION['DATA']['discount']['disable']['last_time'] = time();
                if (($count <= 3 && $def_time < 1) || ($count > 3 && $count <= 5 && $def_time < 3) || ($count > 5 && $count <= 10 && $def_time < 10) || ($count > 10 && $def_time < 3600)) {
                    $discount_disable = true;
                }

                if ($def_time > 3600) {
                    $_SESSION['DATA']['discount']['disable'] = array();
                    unset($_SESSION['DATA']['discount']['disable']);
                }
            }

            $error_msg = '';
            $html_out = '';
            $code_str = '';
            $summ_or_percent_rabat = 0;
            $fix_rabat = 0;

            $Format = new Format();
            if (!$discount_disable && isset($_GET['discount_code']) && trim($_GET['discount_code']) != '') {
                $start_date_time = new DateTime;
                $start_date_time->setTimestamp(Session::getStartDateTime());
                $end_date_time = new DateTime;
                $end_date_time->setTimestamp(Session::getEndDateTime());
                $start_station = Session::getStartStation();
                $end_station = Session::getEndStation();
                $cargroup = Session::getCarGroup();
                $car_group_code = $cargroup->code;
                $addkm = isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : 0;
                $discount_code = trim($_GET['discount_code']);
                $translate = $this->loadTranslations(array('MESSAGE', 'RATE', 'Einheiten', 'RENTAL', 'NAVI', 'FZG', 'GLOBAL', 'LOGIN_BAR',
                    'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'STEP3', 'CAR_GROUP', 'TARIF', 'EXTRAS', 'RABATT', 'TARIF', 'EinheitEinzahl'));

                $rates = unserialize($_SESSION['DATA']['rates']['primary']);
                $rate = new Rate();
                foreach ($rates as $objRate) {
                    $rate = $objRate;
                    if ($objRate->basic == 'J') {
                        break;
                    }
                }

                $dbDiscount = new DBDiscount();

                if (!$dbDiscount->isRateDiscountable($rate, $car_group_code)) {
                    $error_msg = $translate['MESSAGE']['ERROR_RATE_NONDISCOUNTABLE'];
                }

                $discount_details = $dbDiscount->DiscountDetails($discount_code, $start_date_time, $end_date_time);

                if (count($discount_details) == 0) {
                    $error_msg = $translate['MESSAGE']['ERROR_WRONG_CODE'];
                } else {
                    $currency = new Currency();
                    $dbCurrency = new DBCurrency();
                    $dbCurrencyObj = $dbCurrency->getCurrency();

                    $currency->decodeFromDb($dbCurrencyObj);

                    if (isset($discount_details['persent']) && $discount_details['persent'] != '') {
                        $code_str = round($discount_details['persent'], 2) . '% ' . $translate['RATE']['RABATT'];
                        $summ_or_percent_rabat = $discount_details['persent'];
                        $fix_rabat = 0;
                    } elseif (isset($discount_details['summe']) && $discount_details['summe'] != '') {
                        $code_str = number_format(round($discount_details['summe'] * $currency->conversion, 2), 2) . ' ' . $currency->symbol . ' ' . $translate['RATE']['RABATT'];
                        $summ_or_percent_rabat = $discount_details['summe'];
                        $fix_rabat = 1;
                    }

                    $discount_details['text'] = $code_str;

                    $dbRate = new DBRate();
                    $dbRatesObj = $dbRate->getRate($start_date_time->format('d.m.Y H:i'), $end_date_time->format('d.m.Y H:i'), $start_station->code, $end_station->code, $car_group_code, $addkm, '', 0, $summ_or_percent_rabat, $fix_rabat);
                    $Rates = array();

                    foreach ($dbRatesObj as $dbRateObj) {
                        $tmpRate = new Rate();
                        $tmpRate->decodeFromDb($dbRateObj);
                        $Rates[] = $tmpRate;
                    }

                    Session::setPrimaryRates($Rates);
                    if ($error_msg === '') {
                        $_SESSION['DATA']['discount'] = $discount_details;
                    } else {
                        unset($_SESSION['DATA']['discount']);
                    }

                    $template = $this->template;
                    $template->assign('RATES', $Rates);
                    $dbTranslate = new DBTranslate();

                    $template->assign('NAVI_STEP', $_SESSION['STEP']);
                    $template->assign('SHOW_KM', 1);
                    $template->assign('CURRENCY', $currency);
                    $template->assign('TRANSLATE', $translate);

                    $html_out = $template->fetch('tarif_details.html');
                }
            } else {
                $error_msg = 'Ungültiger Gutscheincode!';
            }

            $total_price = $this->getTotalPrice() * (!empty($currency->conversion) ? $currency->conversion : 1);

            $subprice_rates = $this->getSubPriceRates() * $currency->conversion;
            $subprice_extras = $this->getSubPriceExtras() * $currency->conversion;

            $out_array = array('error' => $error_msg, 'html' => $html_out, 'code_str' => $code_str, 'total_price' => $total_price, 'total_price_formatted' => $Format->currencyFormat($total_price, true, false), 'subprice_rates' => $subprice_rates, 'subprice_rates_formatted' => $Format->currencyFormat($subprice_rates, true, false), 'subprice_extras' => $subprice_extras, 'subprice_extras_formatted' => $Format->currencyFormat($subprice_extras, true, false));
            echo json_encode($out_array);
        } else {
            error404();
        }
        Session::setSessionRentalHash();
    }
    // discount()

    public function discountdelete()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $start_date_time = new DateTime;
            $start_date_time->setTimestamp(Session::getStartDateTime());
            $end_date_time = new DateTime;
            $end_date_time->setTimestamp(Session::getEndDateTime());
            $start_station = Session::getStartStation();
            $end_station = Session::getEndStation();
            $group = Session::getCarGroup();
            $car_group_code = $group->code;
            $addkm = isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : 0;
            $html_out = '';

            $dbRate = new DBRate();
            $dbRatesObj = $dbRate->getRate($start_date_time->format('d.m.Y H:i'), $end_date_time->format('d.m.Y H:i'), $start_station->code, $end_station->code, $car_group_code, $addkm);
            $Rates = array();

            $translate = $this->loadTranslations(array('MESSAGE', 'RATE', 'Einheiten', 'RENTAL', 'NAVI', 'FZG', 'GLOBAL', 'LOGIN_BAR',
                'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'STEP3', 'CAR_GROUP', 'TARIF', 'EXTRAS', 'RABATT', 'TARIF', 'EinheitEinzahl'));

            foreach ($dbRatesObj as $dbRateObj) {
                $tmpRate = new Rate();
                $tmpRate->decodeFromDb($dbRateObj);
                $Rates[] = $tmpRate;
            }

            Session::setPrimaryRates($Rates);
            unset($_SESSION['DATA']['discount']);

            $template = $this->template;
            $template->assign('RATES', $Rates);

            $template->assign('TRANSLATE', $translate);

            $cacheCurrency = Cache::getCurrency();
            $currency = new Currency();
            $currency->decodeFromDb($cacheCurrency);

            $template->assign('CURRENCY', $currency);

            $template->assign('NAVI_STEP', $_SESSION['STEP']);
            $template->assign('SHOW_KM', 1);

            $html_out = $template->fetch('tarif_details.html');

            $Format = new Format();
            $total_price = $this->getTotalPrice() * $currency->conversion;
            // $total_price = $Format->currencyFormat($total_price, TRUE, FALSE);
            $subprice_rates = $this->getSubPriceRates() * $currency->conversion;
            $subprice_extras = $this->getSubPriceExtras() * $currency->conversion;

            $out_array = array('html' => $html_out, 'total_price' => $total_price, 'total_price_formatted' => $Format->currencyFormat($total_price, true, false), 'subprice_rates' => $subprice_rates, 'subprice_rates_formatted' => $Format->currencyFormat($subprice_rates, true, false), 'subprice_extras' => $subprice_extras, 'subprice_extras_formatted' => $Format->currencyFormat($subprice_extras, true, false));
            echo json_encode($out_array);
        } else {
            error404();
        }
        Session::setSessionRentalHash();
    }

    private function getSubPriceRates()
    {
        $price = 0;
        foreach ($this->main_rate as $rate) {
            $price += $rate->total_price;
        }
        return $price;
    }

    private function getSubPriceExtras()
    {
        $price = 0;
        // echo "<pre>";
        // print_r($this->sub_rate_options);
        foreach ($this->sub_rate_options as $rate) {
            if ($rate->selected) {
                if ($rate->is_stuk) {
                    $price += $rate->basic_price * $rate->count;
                } else {
                    $price += $rate->total_price;
                }
            }
        }
        return $price;
    }

    private function getTotalPrice()
    {
        $price = 0;

        $this->main_rate = Session::getPrimaryRate();
        $this->sub_rate_options = Session::getSubRates();

        foreach ($this->main_rate as $rate) {
            $price += $rate->total_price;
        }

        // AK 07.05.2018 Aufgabe 94158: bei Berechnung der KM müssen vorher ausgewählte Zusatzraten beachtet werden. Bei Stückraten muss die Anzahl beachtet werden.
        foreach ($this->sub_rate_options as $rate) {
            if ($rate->selected) {
                if ($rate->is_stuk) {
                    $price += $rate->basic_price * $rate->count;
                } else {
                    $price += $rate->total_price;
                }
            }
        }

        $_SESSION['DATA']['total_price'] = $price;
        return $price;
    }

    // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
    private function getTotalPriceNetto()
    {
        $price = 0;

        $this->main_rate = Session::getPrimaryRate();
        $this->sub_rate_options = Session::getSubRates();

        foreach ($this->main_rate as $rate) {
            $price += $rate->total_price_netto;
        }

        foreach ($this->sub_rate_options as $rate) {
            if ($rate->selected) {
                $price += $rate->total_price_netto;
            }
        }

        $_SESSION['DATA']['total_price_netto'] = $price;
        return $price;
    }

    public function subrateCountChange()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $currency = new Currency();
            $dbCurrency = new DBCurrency();
            $dbCurrencyObj = $dbCurrency->getCurrency();

            $currency->decodeFromDb($dbCurrencyObj);

            if (isset($_GET['option']) && trim($_GET['option']) != '') {
                $option_code = trim($_GET['option']);

                $rate = null;
                $idx_rate = null;
                $option_rates = Session::getSubRates();

                foreach ($option_rates as $idx => $cache_rate) {
                    if ($cache_rate->rate == $option_code) {
                        $rate = $cache_rate;
                        $idx_rate = $idx;
                        break;
                    }
                }

                if ($rate !== null) {
                    if (!$rate->autobuch) {
                        if ($rate->is_stuk) {
                            if (isset($_GET['count']) && intval($_GET['count']) > 0) {
                                $rate->count = intval($_GET['count']);
                                if (intval($_GET['count']) < $rate->minCount) {
                                    $rate->count = $rate->minCount;
                                }

                                if (intval($_GET['count']) > $rate->maxCount) {
                                    $rate->count = $rate->maxCount;
                                }
                            } else {
                                $rate->count = 0;
                                $rate->selected = false;
                            }

                            $rate->selected = $rate->count > 0;

                            $rate->total_price = $rate->count * $rate->basic_price;
                            $rate->total_price_netto = $rate->count * $rate->basic_price_netto;
                            // AK 12.02.2016 - Aufgabe 76288: für Stückraten muss der currency_price auf den Einzelpreis berechnet werden
                            $rate->currency_price_single = $rate->basic_price * $currency->conversion;
                            $rate->currency_price_single_netto = $rate->basic_price_netto * $currency->conversion;

                            $rate->currency_price = $rate->total_price * $currency->conversion;
                            $rate->currency_price_netto = $rate->total_price_netto * $currency->conversion;
                        }
                    }
                    $option_rates[$idx_rate] = $rate;
                    Session::setSubRates($option_rates);
                } else {
                    echo "Error. Rate im Cache nicht gefunden";
                    exit();
                }
            } else {
                echo "Error: Falscher Ratentyp";
                exit();
            }

            $total_price = $this->getTotalPrice() * $currency->conversion;
            $total_price_netto = $this->getTotalPriceNetto() * $currency->conversion;
            $subprice_extras = $this->getSubPriceExtras();

            $Format = new Format();
            echo json_encode(array(
                'total_price' => round($total_price, 2),
                'total_price_netto' => round($total_price_netto, 2),
                'subprice_extras' => round($subprice_extras, 2),
                'total_price_formatted' => $Format->currencyFormat($total_price, true, false),
                'total_price_netto_formatted' => $Format->currencyFormat($total_price_netto, true, false),
                'subprice_extras_formatted' => $Format->currencyFormat($subprice_extras, true, false),
                'autobuch' => (!empty($rate->autobuch) ? 1 : 0),
                'count' => $rate->count));
        } else {
            error404();
        }
    }
    // subrateCountChange()
}
// Class ControllerPrices
