<?php
class ControllerReservate extends ControllerBase
{

    public function index()
    {
        if (isset($_SESSION['DATA'])) {

            // AK 26.01.21: hier muss die Zahlungsart aus der DB geladen werden, da dies sonst nicht funktioniert
            $user = Session::getCustomer();
            $dbPay = new DBPayart();
            $pay = new PayArts();
            $pay->decodeFromDb($dbPay->getArtById($user->paymentID));
            // AK 28.08.19 Aufgabe 1105413: Datenvalidierung optimieren
            // CW 06.02.20 Aufgabe 1111808: Validierung AGBs / DS misslingt nach Bezahlungsvorgang, daher deaktivieren
            if ((strtolower($pay->web_name) == strtolower(Params::getValue('CONCARDIS_NAME')) && Module::isEnabled('ConCardis')) ||
                (strtolower($pay->web_name) == strtolower(Params::getValue('PAYPAL_NAME')) && (Module::isEnabled('PayPal') || Module::isEnabled('PayPalPlus'))) ||
                (strtolower($pay->web_name) == strtolower(Params::getValue('PAYPAL_NAME')) && Module::isEnabled('PayPalPlus'))) {
                // skip check
            } else {
                DataCheck::checkStep5();
            }

            $mandant = $this->registry->mandant;
            $main_rates = isset($_SESSION['DATA']['rates']['primary']) ? unserialize($_SESSION['DATA']['rates']['primary']) : '';
            $subrates_options = isset($_SESSION['DATA']['rates']['subrates']['options']) ? unserialize($_SESSION['DATA']['rates']['subrates']['options']) : '';

            $car_group = Session::getCarGroup();
            $start_date_time = new DateTime;
            $start_date_time->setTimestamp(Session::getStartDateTime());
            $end_date_time = new DateTime;
            $end_date_time->setTimestamp(Session::getEndDateTime());
            $customer = Session::getCustomer();
            $station_dep = Session::getStartStation();
            $station_arr = Session::getEndStation();

            $tmp = array();
            foreach ($subrates_options as $subrate) {
                if ($subrate->selected || $subrate->autobuch) {
                    if ($subrate->count == 0) {
                        $subrate->count = 1;
                    }

                    $tmp[] = $subrate;
                }
            }
            $subrates_options = $tmp;
            $_SESSION['DATA']['rates']['subrates']['options'] = serialize($subrates_options);

            if (!isset($main_rates[0]) || !is_a($main_rates[0], 'Rate')) {
                $this->error[] = 'Wrong session data Main Rate';
            }

            if (count($this->error) == 0) {
                if ((defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY) || Module::isEnabled('ORM_AVAILABILITY_PLAN')) {
                    $dbCarGroups = new DBCarGroup();
                    if (!$dbCarGroups->isGroupAvailable(
                        $start_date_time->format('d.m.Y'),
                        $end_date_time->format('d.m.Y'),
                        $start_date_time->format('H:i'),
                        $end_date_time->format('H:i'),
                        $station_dep->code,
                        $car_group->code
                    )) {
                        $dbTranslate = new DBTranslate();
                        $translate = array('FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang));

                        goError($translate['FZG']['ZWISCHENZEIT_GEBUCHT']);
                    }
                }
                $this->registry->rates = array('primary' => $main_rates, 'subrates' => $subrates_options);

                $rates_pk = array_merge(
                    $this->extract_rates_pks($main_rates, false),
                    $this->extract_rates_pks($subrates_options, true)
                );

                $user = Session::getCustomer();

                $anreden = unserialize($_SESSION['CACHE']['anreden']);

                $anrede = $anreden[$user->anredeID];

                $user->isCompany = ($anrede->isCompany == 1);

                $sboima_name1 = Params::getValue('SBONIMA_NAME1');
                if (empty($sboima_name1)) {
                    $sboima_name1 = '$VORNAME $NACHNAME';
                }
                if ($user->lastname != '' && $user->firstname != '') {
                    $user->name_template = str_replace(
                        array('$NACHNAME', '$VORNAME'),
                        array($user->lastname, $user->firstname),
                        $sboima_name1
                    );
                } elseif ($user->lastname != '' && $user->firstname == '') {
                    $user->name_template = $user->lastname;
                } elseif ($user->lastname == '' && $user->firstname != '') {
                    $user->name_template = $user->firstname;
                } else {
                    $user->name_template = null;
                }

                Session::setCustomer($user);
                $dbPay = new DBPayart();
                $pay = new PayArts();
                $pay->decodeFromDb($dbPay->getArtById($user->paymentID));

                //Kreditkartennummer und Gültigkeit ebenfalls speichern
                $pay->credit_card_number = $user->kknummer;
                $pay->credit_card_date = $user->kkmonth . "/" . substr($user->kkyear, 2, 2);

                $params = array();
                $params['user'] = $user;
                $params['rates_pk'] = $rates_pk;
                $params['startstation'] = $station_dep->code;
                $params['endstation'] = $station_arr->code;
                $params['startdate'] = $start_date_time->format('d.m.Y');
                $params['starttime'] = $start_date_time->format('H:i');
                $params['enddate'] = $end_date_time->format('d.m.Y');
                $params['endtime'] = $end_date_time->format('H:i');
                $params['group_code'] = $car_group->code;
                $params['km_add'] = (isset($_SESSION['DATA']['addkm']) && is_numeric($_SESSION['DATA']['addkm'])) ? $_SESSION['DATA']['addkm'] : 0;
                $params['pay'] = $pay;
                $params['comment'] = $_SESSION['DATA']['comment'];
                $params['main_rate_code'] = $main_rates[0]->rate;
                $params['promocode'] = isset($_SESSION['DATA']['promocode']) ? $_SESSION['DATA']['promocode'] : '';
                $params['discount'] = isset($_SESSION['DATA']['discount']) ? $_SESSION['DATA']['discount'] : array();
                $params['INET_STATUS'] = (defined('INET_STATUS') && INET_STATUS == 1) ? 'U' : 'B';
                $params['accept_agb'] = 1;

                $this->indParams($params); #KR: Was macht diese Zeile? Nix?

                $dbReservation = new DBReservation();
                // echo "<pre>";
                // print_r($params);die;
                $reserv_num = $dbReservation->Save($params);
                if ($reserv_num > 0) {
                    Session::setCustomer($user);
                    $_SESSION['DATA']['pay'] = serialize($pay);
                    $_SESSION['DATA']['reservnummer'] = $reserv_num;
                    $this->send_confirm_mail();

                    if (isset($_SESSION['DATA']['new_customer']) && $_SESSION['DATA']['new_customer'] == 1) {
                        $this->send_new_customer_email();
                    }

                    header('location: ' . SITEURL . 'confirm&PHPSESSID=' . session_id());
                    exit;
                } else {
                    $this->error = 'Error creating reservation';
                    die($this->error);
                }
            } else {
                # Ggf. anderes Weiterleitungsziel
                $_SESSION['ERROR'] = $this->error;
                header('location: ' . SITEURL . 'summary&PHPSESSID=' . session_id());
                exit;
            }
        }
    } // index()

    protected function extract_rates_pks($rates, $only_selected)
    {
        $pk_array = array();
        foreach ($rates as $rate) {
            if (!$only_selected || ($only_selected && $rate->selected == 1)) {
                $pk_array[] = array('db_id' => $rate->db_id, 'count' => $rate->count);
            }
        }

        return $pk_array;
    } // extract_rates_pks()

    // TODO controller email schreiben
    protected function send_confirm_mail()
    {
        if (isset($_SESSION['DATA']['confirm_email'])) {
            return false;
        }

        $mandant = $this->registry->mandant;

        $mail = new Mail();

        $user = Session::getCustomer();

        $dbAnrede = new DBAnrede();
        $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

        $anreden = array();
        foreach ($dbAnredenObj as $dbObj) {
            $anrede = new Anrede();

            $anrede->decodeFromDb($dbObj);
            $anreden[$anrede->anrede] = $anrede;
        }

        if (!empty($user)) {
            $user->greeting = str_replace('$NAME1,', '', $anreden[$user->anrede]->greeting);
            // $user->greeting = str_replace('$NAME1', '', $anreden[$user->anrede]->greeting);

            $translate = $this->loadTranslations(array('RENTAL', 'CONFIRM', 'RESERVATE', 'RATE', 'WEBEMAIL', 'FZG', 'Einheiten', 'Wochentage', 'GLOBAL', 'TITLE', 'INTRO', 'USERDATA', 'EMAIL', 'STATION_BLOCK', 'STATION', 'TARIF', 'EXTRAS'));

            $startstation = Session::getStartStation();
            $endstation = Session::getEndStation();
            $group = Session::getCarGroup();
            $start_date_time = new DateTime;
            $start_date_time->setTimestamp(Session::getStartDateTime());
            $end_date_time = new DateTime;
            $end_date_time->setTimestamp(Session::getEndDateTime());

            $dbText = new DBText();
            $station = Station::hasStationCode(Session::getStartStation());
            $res_text = $dbText->getTextByStation($station->code, 'INET_RES_BEST');
            $greeting_text = $dbText->getTextByStation($station->code, 'INET_RES_BEST_GREETING');

            $res_text->mem = isset($res_text->mem) ? $res_text->mem : 'INET_RES_BEST';
            $greeting_text->mem = isset($greeting_text->mem) ? $greeting_text->mem : 'INET_RES_BEST_GREETING';

            $currency = unserialize($_SESSION['CACHE']['CURRENCY']['OBJ']);

            $rates_descriptions = '';
            foreach ($this->registry->rates['primary'] as $rate) {
                if ($rate->rate == 'KM') {
                    $rates_descriptions .= $rate->count . ' ' . $rate->unit . ' - ' . $rate->description_lang . '<br>';
                } else {
                    $rates_descriptions .= $rate->description_lang . '<br>';
                }
            }

            foreach ($this->registry->rates['subrates'] as $rate) {
                if ($rate->selected == 1) {
                    $rates_descriptions .= ($rate->cdw ? $rate->days : $rate->count) . ' ' . $rate->unit . ' - ' . $rate->description_lang . '<br>';
                }
            }

            $dateTimeFormat = new DateTimeFormat();
            $template = $this->template;

            foreach ($startstation->shedules as &$val) {
                $val->btime = $dateTimeFormat->getTime($val->btime);
                $val->etime = $dateTimeFormat->getTime($val->etime);
                $val->mbtime = $dateTimeFormat->getTime($val->mbtime);
                $val->metime = $dateTimeFormat->getTime($val->metime);
            }
            unset($val);

            $extras = array();
            $subrates = Session::getSubRates();
            foreach ($subrates as $subrate) {
                if ($subrate->selected == 1) {
                    $extras[] = $subrate;
                }
            }

            $total_price = $_SESSION['DATA']['total_price'];
            $total_price_format = Format::CurrencyFormat($total_price, true);

            $template->assign('TRANSLATE', $translate);
            $template->assign('USER', $user);
            $template->assign('STARTSTATION', $startstation);
            $template->assign('ENDSTATION', $endstation);
            $template->assign('ANZTAGE', round(($end_date_time->getTimestamp() - $start_date_time->getTimestamp()) / 86400));
            $template->assign('STARTDATE', $start_date_time->format($dateTimeFormat->getDateFormat()));
            $template->assign('STARTTIME', $start_date_time->format($dateTimeFormat->getTimeFormat()));
            $template->assign('ENDDATE', $end_date_time->format($dateTimeFormat->getDateFormat()));
            $template->assign('ENDTIME', $end_date_time->format($dateTimeFormat->getTimeFormat()));
            $template->assign('GES_PRICE', $total_price_format);
            $template->assign('CURRENCY', $currency);
            $template->assign('GRUPPE', trim($group->title_lang));
            $template->assign('GRUPPE_KEY', $group->code);
            $template->assign('CAR_IMAGE', $group->groupImageHardlink);
            $template->assign('KMGEPL', isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : '');
            $template->assign('LOGO', SITEURL . 'images/logo');

            $dbText = new DBText();
            $station = Station::hasStationCode(Session::getStartStation());
            $lang_greeting = $dbText->getTextByStation($station->code, 'INET_RES_BEST_GREETING');
            $lang_greeting->mem = isset($lang_greeting->mem) ? $lang_greeting->mem : 'INET_RES_BEST_GREETING';
            $template->assign('LANG_GREETING', $lang_greeting->mem);

            $template->assign('PROMCODE', isset($_SESSION['DATA']['discount']['code']) ? $_SESSION['DATA']['discount']['code'] : '');

            $template->assign('RATES', Session::getPrimaryRate());
            $template->assign('EXTRAS', $extras);

            $template->assign('RES_BEST_INFO_TEXT', $res_text->mem);
            $template->assign('RES_NO', $_SESSION['DATA']['reservnummer']);
            $template->assign('RES_ON', $dateTimeFormat->getDateTime(date('d.m.Y H:i')));
            $template->assign('WEBSITE', !empty($startstation->url) ? $startstation->url : (defined('FIRST_PAGE') ? FIRST_PAGE : ''));
            $template->assign('BEMERKUNG', !empty($_SESSION['DATA']['comment']) ? $_SESSION['DATA']['comment'] : '');
            $template->assign('SHOW_KK_INPUTS', defined('CONFIG_SHOW_KK_INPUTS') ? CONFIG_SHOW_KK_INPUTS : 0);

            $dbText = new DBText();
            $inet_suz_text = $dbText->getTextByStation($station->code, 'INET_RES_BEST');
            $inet_suz_text->mem = isset($inet_suz_text->mem) ? $inet_suz_text->mem : 'INET_RES_BEST';
            $template->assign('INET_ZUS_TEXT', $inet_suz_text->mem);

            // Nachbearbeitung eMail-Betreff (Marker ersetzen):
            if (isset($translate['EMAIL']['EMAIL_SUBJECT_CONFIRMATION'])) {
                $subject = str_replace(array('###MANDANTNAME###', '###STATIONNAME###', '###STATIONSTREET###', '###STATIONZIPCODE###', '###STATIONCITY###'), array($this->registry->mandant->name, $startstation->name, $startstation->street, $startstation->zipcode, $startstation->city), $translate['EMAIL']['EMAIL_SUBJECT_CONFIRMATION']);
            } else {
                // Dieser Teil kann in zukünftigen Versionen entfernt werden
                $subject = $translate['CONFIRM']['SUBJECT_RESERV'] . ' ' . $this->registry->mandant->name;
            }

            $template->assign('TITLE_RES_BEST', $subject);

            if (Params::getValue('BINET_MAIL_SEND_PDF_CONFIRM') == 1) {
                $pdf = new Pdfprint();
                $pdf->setFilename('confirm.pdf');
                $pdf->setJasperTemplate('reservierung.jasper');
                $pdf->addParam('reno', $_SESSION['DATA']['reservnummer']);
                $pdf_confirm = $pdf->getPDFtoString();
                $mail->addStringAttachment($pdf_confirm, 'Reservierungsbestaetigung.pdf', $encoding = 'base64', $type = 'application/octet-stream');
            }

            $template->assign('CONFIRMATION', 1);
            $body = $template->fetch('email_template.html');

            $this->indConfirmMailSend($mail); # DIESE ZEILE MACHT NIX!

            // Bestätigungsemail versenden
            $reservierungsnummer = 0; //Zugehörige E-mailaddresse könnte auch über die Reservierungsnummer ermittelt werden
            if ($mail->Send($user->email, $subject, $body)) {
                $_SESSION['DATA']['confirm_email'] = 1;
                $mail_status = 'E-Mail erfolgreich gesendet';
            } else {
                $mail_status = 'Fehler beim Senden der E-Mail: ' . $mail->ErrorInfo();
            }
            $this->email_error_log($mail->getLog() . 'Status: ' . $mail_status);
            $mail->log2db($mail_status, $_SESSION['DATA']['reservnummer']);
        }
    }

    public function send_share_mail()
    {
        /*if(    (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) &&
        isset($_REQUEST['email']) && trim($_REQUEST['email']) != ''
        )
        {*/
        $dbMandant = new DBMandant();
        $mandant = new Mandant();
        $mandant->decodeFromDb($dbMandant->getInfo());

        $this->registry->mandant = $mandant;

        $main_rates = isset($_SESSION['DATA']['rates']['primary']) ? unserialize($_SESSION['DATA']['rates']['primary']) : '';
        $subrates_options = isset($_SESSION['DATA']['rates']['subrates']['options']) ? unserialize($_SESSION['DATA']['rates']['subrates']['options']) : '';
        $email = trim($_REQUEST['email']);
        $mail = new Mail();

        $dbTranslate = new DBTranslate();
        $translate = array('RENTAL' => $dbTranslate->loadTranslations('RENTAL', $this->registry->lang),
            'CONFIRM' => $dbTranslate->loadTranslations('CONFIRM', $this->registry->lang),
            'RESERVATE' => $dbTranslate->loadTranslations('RESERVATE', $this->registry->lang),
            'RATE' => $dbTranslate->loadTranslations('RATE', $this->registry->lang),
            'WEBEMAIL' => $dbTranslate->loadTranslations('WEBEMAIL', $this->registry->lang),
            'FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang),
            'Einheiten' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang),
            'Wochentage' => $dbTranslate->loadTranslations('Wochentage', $this->registry->lang),
        );

        $startstation = unserialize($_SESSION['DATA']['startstation_obj']);
        $endstation = unserialize($_SESSION['DATA']['endstation_obj']);
        $group = unserialize($_SESSION['DATA']['car_group_obj']);

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $mailtotext = $dbText->getTextByStation($station->code, 'INET_MAILTO_TEXT');
        $share_link = $dbText->getTextByStation($station->code, 'INET_MAILTO_LINK');
        $res_text = $dbText->getTextByStation($station->code, 'RES_BEST');

        $mailtotext->mem = isset($mailtotext->mem) ? $mailtotext->mem : 'INET_MAILTO_TEXT';
        $share_link->mem = isset($share_link->mem) ? $share_link->mem : 'INET_MAILTO_LINK';
        $res_text->mem = isset($res_text->mem) ? $res_text->mem : 'RES_BEST';

        $currency = unserialize($_SESSION['CACHE']['CURRENCY']['OBJ']);

        $rates_descriptions = '';
        foreach ($main_rates as $rate) {
            if ($rate->rate == 'KM') {
                $rates_descriptions .= $rate->count . " " . $rate->unit . " - " . $rate->description . "   " . $rate->currency_price . " " . $currency->symbol . "<br>";
            } else {
                $rates_descriptions .= $rate->description . "<br>";
            }
        }

        foreach ($subrates_options as $rate) {
            if ($rate->selected == 1) {
                $rates_descriptions .= "- " . $rate->description . (($rate->is_stuk) ? " x " . $rate->count : "") . "<br>";
            }
        }

        $template = $this->template;
        $dateTimeFormat = new DateTimeFormat();

        $template->assign('TRANSLATE', $translate);
        $template->assign('STARTSTATION', $startstation);
        $template->assign('ENDSTATION', $endstation);
        $template->assign('ANZTAGE', (strtotime($_SESSION['DATA']['enddate']) - strtotime($_SESSION['DATA']['startdate'])) / 86400);
        //$template->assign('ECITY', $endstation->city);
        $template->assign('ENDDATE', $dateTimeFormat->getDate($_SESSION['DATA']['enddate']));
        $template->assign('ENDTIME', $dateTimeFormat->getTime($_SESSION['DATA']['endtime']));
        $template->assign('GES_PRICE', $_SESSION['DATA']['total_price'] . "&nbsp;" . $currency->Symbol);
        $template->assign('GRUPPE', substr($group->title, 0, 14));
        $template->assign('KMGEPL', isset($_SESSION['DATA']['addkm']) ? $_SESSION['DATA']['addkm'] : '');
        $template->assign('LOGO', SITEURL . 'images/logo');
        // $res_text->mem
        $template->assign('LANG_GREETING', str_replace("\$MANDANTNAME", $this->registry->mandant->name, $mailtotext->mem));
        $template->assign('PROMCODE', isset($_SESSION['DATA']['discount']['code']) ? $_SESSION['DATA']['discount']['code'] : '');
        $template->assign('RATES', $rates_descriptions);
        // evtl Text mit Link auf Step 3
        $template->assign('RES_BEST_INFO_TEXT', $res_text->mem);
        $template->assign('SHARE_LINK_TEXT', $share_link->mem);
        $template->assign('STARTDATE', $dateTimeFormat->getDate($_SESSION['DATA']['startdate']));
        $template->assign('STARTTIME', $dateTimeFormat->getTime($_SESSION['DATA']['starttime']));

        /*prices
        &startstation=002&endstation=002&startdate=22.10.2014&starttime=08:00&enddate=23.10.2014&endtime=08:00&gruppe=A&km=150
         */
        $template->assign('LINK', SITEURL . "prices?startstation=" . $startstation->code . "&endstation=" . $endstation->code . "&startdate=" . $_SESSION['DATA']['startdate'] . "&starttime=" . $_SESSION['DATA']['starttime'] . "&enddate=" . $_SESSION['DATA']['enddate'] . "&endtime=" . $_SESSION['DATA']['endtime'] . "&car_group=" . $group->code . (isset($_SESSION['DATA']['addkm']) ? "&km=" . $_SESSION['DATA']['addkm'] : ""));

        // hier Betrefftext
        $subject = $translate['WEBEMAIL']['SHARESUBJECT'] . " " . $this->registry->mandant->name;
        $body = $template->fetch('email_share.html');

        if ($mail->Send($email, $subject, $body)) {
            $this->email_error_log($mail->getLog() . "Status: E-Mail erfolgreich gesendet.");
            echo json_encode(array('msg' => 'Angebot geteilt.'));
        } else {
            $this->email_error_log($mail->getLog() . "Status: Fehler beim Senden der E-Mail: " . $mail->ErrorInfo());
        }
        /*}else{
    echo json_encode(array('error' =>'Fehler beim Versenden der Email.'));
    }*/
    }

    // doppelt in controller_customer
    // doppelt in controller_mobile (deprecated)
    // TODO controller email schreiben
    private function send_new_customer_email()
    {
        $dbMandant = new DBMandant();
        $mandant = new Mandant();
        $mandant->decodeFromDb($dbMandant->getInfo());

        $this->registry->mandant = $mandant;

        $dbAnrede = new DBAnrede();
        $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

        $anreden = array();
        foreach ($dbAnredenObj as $dbObj) {
            $anrede = new Anrede();

            $anrede->decodeFromDb($dbObj);
            $anreden[$anrede->anrede] = $anrede;
        }

        $translate = $this->loadTranslations(array(
            'RENTAL',
            'RESERVATE',
            'EMail',
            'WEBEMAIL',
            'EMAIL',
        ));

        // Nachbearbeitung eMail-Betreff (Marker ersetzen):
        $subject = str_replace('###MANDANTNAME###', $this->registry->mandant->name, $translate['EMAIL']['EMAIL_SUBJECT_CUSTOMER_LOGIN_DATA']);
        $translate['EMAIL']['EMAIL_SUBJECT_CUSTOMER_LOGIN_DATA'] = $subject;

        $mail = new Mail();
        $mail->is_bcc = false;

        $user = Session::getCustomer();

        if (is_a($user, 'Customer')) {
            $user->greeting = str_replace('$NAME1,', '', $anreden[$user->anrede]->greeting);

            $startstation = Session::getStartStation();
            $user->password = $this->registry->inet_password;

            $dbCustomer = new DBCustomer();
            $token = $dbCustomer->createToken($user);

            $dbText = new DBText();
            $text1 = $dbText->getTextByStation($startstation->code, 'INET_NEW_CUSTOMER_GREETING');
            $text1->mem = isset($text1->mem) ? $text1->mem : 'INET_NEW_CUSTOMER_GREETING';

            $template = $this->template;
            $template->assign('TRANSLATE', $translate);
            $template->assign('STARTSTATION', $startstation);
            $template->assign('TEXT_OBEN', $text1->mem);
            $template->assign('USER', $user);
            $template->assign('TOKEN', $token);

            $template->assign('CONFIRMATION', 0);
            $template->assign('NEW_PASSWORD', 1);

            $body = $template->fetch('email_template.html');
            if ($mail->Send($user->email, $subject, $body)) {
                $mail_status = 'E-Mail erfolgreich gesendet.';
            } else {
                $mail_status = 'Fehler beim Senden der E-Mail: ' . $mail->ErrorInfo();
            }
            $this->email_error_log($mail->getLog() . 'Status: ' . $mail_status);
            $mail->log2db($mail_status);
        }
    }

    protected function indParams()
    {
    }
    protected function indConfirmMailSend($mail)
    {
    }
} //Class ControllerReservate
