<?php

class ControllerStations extends ControllerBase
{
    public function index()
    {
    }

    public function getAll()
    {
        $stations = Station::getAll();
        $js_array = array();

        $template = $this->template;
        $template->assign('JS_FILES', $js_array);
        $template->assign('MOBILE', true);
        $template->assign('STATIONS', $stations);

        $template->display('mobile/stations_list.html');
    } // getAll()

    public function map()
    {
        Station::updatePosition();

        $stations = Station::getAll();
        $central = Station::getZentrale();

        $js_array = array('System.js', 'Stations.js');
        $lat = null;
        $long = null;
        if (isset($_GET['lat']) && is_numeric($_GET['lat']) && isset($_GET['long']) && is_numeric($_GET['long'])) {
            $lat = (float) $_GET['lat'];
            $long = (float) $_GET['long'];
        }

        $_SESSION['DATA']['stations_info'] = serialize($stations);

        $template = $this->template;
        $template->assign('MARKER_PATH', 'images/maps_marker.png');
        $template->assign('JS_FILES', $js_array);
        $template->assign('MOBILE', true);
        $template->assign('STATIONS', $stations);
        $template->assign('CENTRAL', $central);
        $template->assign('LAT', is_null($lat) ? 'null' : $lat);
        $template->assign('LONG', is_null($long) ? 'null' : $long);

        $template->display('mobile/stations_map.html');
    } // map()

    public function getInfoBlock()
    {
        $code = $this->registry->args[0];
        $dbTranslate = new DBTranslate();
        $translate = array('RENTAL' => $dbTranslate->loadTranslations('RENTAL', $this->registry->lang));
        $station = Session::getStation($code);
        if (empty($station)) {
            $station = new Station($code);
            Session::setStation($code);
        }

        $this->template->assign('TRANSLATE', $translate);
        $this->template->assign('STATION', $station);
        $this->template->display('station_details.html');
    } //getInfoBlock()

    public function getOpenTimes()
    {
        $shedule = array('ERROR' => true, 'MESSAGE' => '400 - Bad Request', 'MIN_DATE' => 0, 'MIN_TIME' => '00:00', 'MIN_OPENINGS' => array(), 'SHEDULE' => array());
        if (isset($this->registry->args[0]) && !empty($this->registry->args[1]) && in_array($this->registry->args[1], ['start', 'end'])) {
            $code = $this->registry->args[0];
            $station = Session::getStation($code);
            if (empty($station)) {
                $station = new Station($code);
                Session::setStation($station);
            }
            if (!empty($station->code)) {
                $direction = $this->registry->args[1];
                $shedule = array_merge(array('ERROR' => false, 'MESSAGE' => '200 - OK'), $station->getOpenTime($direction));
                unset($shedule['RAW']);
            } else {
                $shedule['MESSAGE'] = '404 - Not Found';
            }
        }
        header('Content-type: text/json; charset=utf-8');
        header('Content-type: application/json');
        echo json_encode($shedule);
    }
} // Class ControllerStations
