<?php
class ControllerStep5 extends ControllerBase
{
    public function index()
    {

        $this->checkLogin();

        if (empty($_SESSION['NAVI_MAX_STEP']) || $_SESSION['NAVI_MAX_STEP'] < 4) {
            $_SESSION['NAVI_MAX_STEP'] = 4;
        }

        $_SESSION['STEP'] = 5;

        $js_array = array('Summary.js', 'iframeResizer.contentWindow.js');

        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        $translate = $this->loadTranslations(array('ANMIETDATEN_BUTTON', 'BUCHUNGSFILTER', 'BUCHUNGSFILTER', 'CAR_GROUP', 'CAR_GROUP', 'CURRENCY',
            'Einheiten', 'ERROR', 'EXTRAS', 'Feiertage', 'FILTER', 'FZG', 'GLOBAL', 'GRUPPE', 'KATEGORIE', 'LOGIN_BAR', 'LOGIN', 'MESSAGE', 'Monate_kurz',
            'NAVI', 'RABATT', 'RATE', 'RENTAL', 'RESERVATE', 'SIDEBAR', 'STATION_BLOCK', 'STATION_SELECT', 'STATION_DETAILS', 'STATION', 'STEP_MENU', 'STEP5', 'TARIF',
            'TOP_LINK', 'USERDATA', 'WEBEMAIL', 'Wochentage_kurz', 'Wochentage', 'NEW_PASSWORD'));

        $_SESSION['DATA']['comment'] = (isset($_SESSION['POST']['text-comment']) and strlen(trim($_SESSION['POST']['text-comment'])))
        ? htmlentities(trim($_SESSION['POST']['text-comment']))
        : (isset($_SESSION['DATA']['comment']) ? $_SESSION['DATA']['comment'] : '');
        $_SESSION['DATA']['new_customer'] = (isset($_SESSION['POST']['checkbox_KKt']) && $_SESSION['POST']['checkbox_KKt'] == 'on') ? 1 : (isset($_SESSION['DATA']['new_customer']) ? $_SESSION['DATA']['new_customer'] : 0);

        $customer = Session::getCustomer();
        // $is_login = ! empty($customer->id);
        $is_login = false;

        if (empty($customer)) {
            $customer = new Customer;
        }

        if (!empty($_SESSION['POST'])) {
            $this->saveCustomerPostData($customer, $_SESSION['POST']);

            $anrede = new Anrede($customer->anredeID);
            $customer->isCompany = $anrede->isCompany;
            Session::setCustomer($customer);
        }

        if (isset($_SESSION['DATA']['login']['isLoggedIn'])) {
            $is_login = true;
        }

        if (!empty($_SESSION['POST'])) {
            $this->saveCustomerPostData($customer, $_SESSION['POST']);
        }
        $car_group = Session::getCarGroup();

        if (empty($_SESSION['ERROR_LIST'])) {
            DataCheck::checkStep4();
        }

        $start_date_time = new DateTime;
        $start_date_time->setTimestamp(Session::getStartDateTime());
        $end_date_time = new DateTime;
        $end_date_time->setTimestamp(Session::getEndDateTime());
        $dateTimeFormat = new DateTimeFormat;
        $date = array(
            'date_dep' => $start_date_time->format($dateTimeFormat->getDateFormat()),
            'date_arr' => $end_date_time->format($dateTimeFormat->getDateFormat()),
            'time_dep' => $start_date_time->format($dateTimeFormat->getTimeFormat()),
            'time_arr' => $end_date_time->format($dateTimeFormat->getTimeFormat()),
        );

        $currency = new Currency();
        $dbCurrency = new DBCurrency();
        $dbCurrencyObj = $dbCurrency->getCurrency();

        $currency->decodeFromDb($dbCurrencyObj);

        $extras = array();
        $subrates = Session::getSubRates();
        foreach ($subrates as $subrate) {
            if ($subrate->selected == 1) {
                $extras[] = $subrate;
            }
        }
        $station = Station::hasStationCode(Session::getStartStation());

        $dbText = new DBText();
        $agbText = $dbText->getTextByStation($station->code, 'INET_AGB_LINK');
        $agbText->mem = isset($agbText->mem) ? $agbText->mem : 'INET_AGB_LINK';

        $dsText = $dbText->getTextByStation($station->code, 'INET_DS_LINK');
        $dsText->mem = isset($dsText->mem) ? $dsText->mem : 'INET_DS_LINK';

        $mandant = $this->registry->mandant;
        $agbText->mem = str_replace('###AGB_LINK###', $mandant->agb, $agbText->mem);

        $zus_text = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP5');
        $zus_text->mem = isset($zus_text->mem) ? $zus_text->mem : 'INET_ZUS_TEXT_STEP5';

        $discount = !empty($_SESSION['DATA']['discount']) ? $_SESSION['DATA']['discount'] : '';
        $module = new Module();

        $template = $this->template;

        $template->assign('pPAYMENTDISPLAY', (($customer->kknummer) ? '' : 'invisible'));
        $template->assign('SID', session_id());
        $template->assign('JS_FILES', $js_array);
        $template->assign('NAVI_STEP', 5);
        $template->assign('NAVI_MAX_STEP', $_SESSION['NAVI_MAX_STEP']);
        $template->assign('TRANSLATE', $translate);
        $template->assign('CUSTOMER', $customer);
        $template->assign('CARGROUP', $car_group);
        $template->assign('DATE', $date);
        $template->assign('CURRENCY', $currency);
        $template->assign('RATES', unserialize($_SESSION['DATA']['rates']['primary']));
        $template->assign('EXTRAS', $extras);
        $template->assign('INET_ZUS_TEXT', $zus_text->mem);
        $template->assign('TITLE', isset($translate['STEP5']['SITETITLE']) ? $translate['STEP5']['SITETITLE'] : 'STEP5.SITETITLE');
        $template->assign('AGB_TEXT', $agbText->mem);
        $template->assign('DS_TEXT', $dsText->mem);
        $template->assign('DISCOUNT', $discount);
        $template->assign('TOTAL_PRISE', $_SESSION['DATA']['total_price']);
        $template->assign('MANDANT', $mandant);
        $template->assign('COMMENT', $_SESSION['DATA']['comment']);
        $template->assign('NEW_CUSTOMER_CHECKED', (($_SESSION['DATA']['new_customer'] == 1) ? 'checked' : ''));
        $template->assign('ZIP_CODE_SEARCH', defined('ZIP_CODE_SEARCH') ? ZIP_CODE_SEARCH : 0);

        $template->assign('LANG', $this->registry->lang);
        $template->assign('LOGIN', $is_login);

        // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
        $show_login = Module::isEnabled('ORM_LOGIN');
        // Wenn das Historie oder Storno erlaubt sind, muss Login auch sichtbar sein
        if (Module::isEnabled('ORM_HISTORIE') || Module::isEnabled('ORM_STORNO')) {
            $show_login = true;
        }
        $template->assign('SHOW_LOGIN', $show_login);

        $template->assign('SHOW_KK_INPUTS', defined('CONFIG_SHOW_KK_INPUTS') && CONFIG_SHOW_KK_INPUTS == 1 ? true : false);

        ###################################################
        # Handling-Daten für PayPalPlus
        $dbPayart = new DBPayart();
        $pay = $dbPayart->getArtById($customer->paymentID);

        if (Module::isEnabled('PayPalPlus') && strtolower($pay->Zahlungsart) == strtolower($this->params->getvALUE('PAYPAL_NAME'))) {
            $PayPalPlus = new PayPalPlus();
            $payPalPlusData = array(
                'SHOW' => false,
                'LINK' => '',
                'MODE' => str_replace('.', '', $PayPalPlus->payPalMode),
            );

            if (!empty($PayPalPlus->apiPassword) and !empty($PayPalPlus->apiSignature)) {
                $payPalPlusData['SHOW'] = true;

                $station = Station::hasStationCode(Session::getStartStation());
                $ItemName = 'Reservierung bei ' . $station->name;
                $rate = unserialize($_SESSION['DATA']['rates']['primary']);
                $ItemDesc = $rate[0]->description;
                $ItemPrice = $_SESSION['DATA']['total_price'];

                $accessToken = $PayPalPlus->getAuthToken();
                if ($accessToken) {
                    $returnUrl = SITEURL . 'payprocess/paypalplus&PHPSESSID=' . session_id();
                    $cancelUrl = SITEURL . 'step5&PHPSESSID=' . session_id();
                    $description = $ItemName . "\n" . $ItemDesc;
                    $paymentToken = $PayPalPlus->createPayment($accessToken, $returnUrl, $cancelUrl, $ItemPrice, $_SESSION['CONFIG']['CURRENCY'], $description);
                    $payPalPlusData['LINK'] = $paymentToken;
                }
            }
            $template->assign('PAYPALPLUS', $payPalPlusData);
        }
        # Ende Handling-Daten fÃ¼rs PayPalPlus
        ###################################################

        $this->loadRentForm();

        if (isset($_SESSION['ERROR_FLAGS'])) {
            $template->assign('ERROR_FLAGS', $_SESSION['ERROR_FLAGS']);
            unset($_SESSION['ERROR_FLAGS']);
        }

        if (!empty($_SESSION['ERROR_LIST'])) {
            $template->assign('ERRORS_INLINE', $_SESSION['ERROR_LIST']);
            unset($_SESSION['ERROR_LIST']);
        }

        unset($_SESSION['POST']);

        $this->afterTemplate();

        $template->display('global_template.html');
    }

    public function saveCustomerPostData(&$CUSTOMEROBJECT, $POSTDATA)
    {
        if (!is_array($POSTDATA) or count($POSTDATA) == 0) {
            return false;
        }

        $didSomethingFlag = false;

        foreach ($POSTDATA as $key => $value) {
            $safeKey = htmlentities(trim($key));
            $keyAlias = null;
            switch ($safeKey) {
                case 'input-company':
                    $keyAlias = 'firma';
                    break;
                case 'input-firstname':
                    $keyAlias = 'firstname';
                    break;
                case 'input-lastname':
                    $keyAlias = 'lastname';
                    break;
                case 'input-email':
                    $keyAlias = 'email';
                    break;
                case 'input-street':
                    $keyAlias = 'street';
                    break;
                case 'input-city':
                    $keyAlias = 'city';
                    break;
                case 'input-postcode':
                    $keyAlias = 'zipcode';
                    break;
                case 'input-telefon':
                    $keyAlias = 'phone';
                    break;
                case 'input-anrede':
                    $keyAlias = 'anredeID'; # im Objekt soll beides vorhanden sein: anrede in wortlaut und ihre id
                    break;
                case 'input-zahlungsart':
                    $keyAlias = 'paymentID'; # im Objekt soll beides vorhanden sein: zahlungsart in wortlaut und ihre id
                    break;
                case 'input-kknummer':
                    $keyAlias = 'kknummer'; # im Objekt soll beides vorhanden sein: zahlungsart in wortlaut und ihre id
                    break;
                case 'input-kkyear':
                    $keyAlias = 'kkyear'; # im Objekt soll beides vorhanden sein: zahlungsart in wortlaut und ihre id
                    break;
                case 'input-kkmonth':
                    $keyAlias = 'kkmonth'; # im Objekt soll beides vorhanden sein: zahlungsart in wortlaut und ihre id
                    break;
                default:
                    # IGNORE INPUT
                    break;
            }
            if (isset($keyAlias) and $keyAlias) {
                $CUSTOMEROBJECT->$keyAlias = htmlentities(trim($value));
                $didSomethingFlag = true;
            }
        }

        # sonderbehandlung anrede + zahlungsart:
        if (isset($CUSTOMEROBJECT->anredeID)) {
            $dbAnrede = new DBAnrede();
            $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

            $anreden = array();

            foreach ($dbAnredenObj as $dbObj) {
                $anrede = new Anrede();
                $anrede->decodeFromDb($dbObj);
                $anreden[$anrede->id] = $anrede;
            }
            $CUSTOMEROBJECT->anrede = (array_key_exists($CUSTOMEROBJECT->anredeID, $anreden)) ? $anreden[$CUSTOMEROBJECT->anredeID]->anrede : false;
        }
        if (isset($CUSTOMEROBJECT->paymentID)) {
            $dbPayArt = new DBPayart();
            $CarGroup = Session::getCarGroup();
            $dbPayArtsObj = $dbPayArt->getAll($CarGroup->cargroupid);
            $payArtsArr = array();

            foreach ($dbPayArtsObj as $dbObj) {
                $payArt = new PayArts();
                $payArt->decodeFromDb($dbObj);
                if (empty($payArt->web_name_lang) || strtoupper($payArt->web_name_lang) == 'NULL') {
                    $payArt->web_name_lang = $payArt->web_name;
                }
                $payArtsArr[$payArt->id] = $payArt;
            }
            $CUSTOMEROBJECT->payment = (array_key_exists($CUSTOMEROBJECT->paymentID, $payArtsArr)) ? $payArtsArr[$CUSTOMEROBJECT->paymentID]->web_name : false;
        }
        if ($didSomethingFlag) {
            Session::setCustomer($CUSTOMEROBJECT);
        }
    }

    protected function afterTemplate()
    {
    }
} //Class ControllerStep5
