var CX9_Data = {
    startstation    : null,
    endstation      : null,
    startdate       : null,
    starttime       : null,
    enddate         : null,
    endtime         : null,
    startdatetime: null,
    enddatetime: null
};


var CX9_Flags = {
    isStartDateSelect : false,
    isStartTimeSelect : false,
    isEndtDateSelect  : false,
    isEndTimeSelect   : false,
}


var stationGlobalDayIdentifier='startdate', stationDisabledDates = {'startdate':{},'enddate':{}}, initial_timepicker_config = {'forceRoundTime': true, 'disableTextInput':true}; 
var stationDisabledDateReasons = {'startdate':{},'enddate':{}};
var orm_data_retriever = new CX9_ORM_RD_Dataretriever();
var datetimepicker = new CX9DateTimePickerData();
var CX9RentalOpenTimes = {
    request: function(sendingParams, localStorageTarget, onAjaxSuccessFunction) {//loadingCOCIPage();
        orm_data_retriever.CX9Request(CX9SITEURL + 'libs/systemControlOpenningTimes&PHPSESSID=' + SID,  sendingParams, localStorageTarget, onAjaxSuccessFunction);
    },
    setStationDisabledDates : function (identifier,dates){
        if(typeof dates === 'object'){
            stationDisabledDates[identifier] = {};
            $.each(dates, function(key, value){
                if(key.length === 19 )
                stationDisabledDates[identifier][new_Date(key)] = new_Date(value);
                else stationDisabledDateReasons[identifier][new_Date(key.substring(0,19))+key.substring(19,key.length)] = (value);
            });
        }
    },
    getXMLDOMObjectValue: function(xmlData, findingElement, convertingObjectKeys, resultObjectKey, fieldAttribute) {
        if (xml !== undefined || xml !== '') {
            var xml = jQuery.parseXML(xmlData);
            var object = {};
            if(typeof resultObjectKey === 'undefined') resultObjectKey = 'none';
            if(typeof fieldAttribute === 'undefined') fieldAttribute = 'none';
            $(xml).find(findingElement).each(function(index, element) {
                var field = $(element);
                if(typeof (convertingObjectKeys) ==='object' && typeof (convertingObjectKeys[element.nodeName]) !== 'undefined' && resultObjectKey === 'none'){
                        object[element.nodeName] = CX9RentalOpenTimes.CX9ParseResult(field.text(), convertingObjectKeys[element.nodeName]);
                }
                else  
                    if (resultObjectKey !== 'none' && element.nodeName === resultObjectKey) {
                        object[field.text()] = field.text();                        
                        var attr = field.attr(fieldAttribute); 
                        if (typeof attr !== 'undefined' && attr !== false) {
                            object[field.text()+fieldAttribute] = attr;
                        }                        
                    }
                    else object[element.nodeName] = field.text();
            });
            return object;
        } else return object;
    },    
    CX9ParseResult : function (value, type){
        switch (type){
            case 'int':
                value = parseInt(value);
            break; 
            case 'float':
                value = parseFloat(value);
            break;     
            case 'arrayInArray': 
                value =  [value.toString().split(',')];
            break;
        }
        return value;
    },
    CX9ServerResult : function (data){
        if(typeof data === 'object') return data.result[0];
        else return {};
    }, 
    CX9ApplyTimepickerSettings : function (selector, object){
        if(typeof object === 'object' && $(selector).size()===1)
            $.each(object, function(key,value){
                $(selector).timepicker(key, value);
            });
    },
    CX9ApplyDatepickerSettings : function (selector, object){
        if(typeof object === 'object' && $(selector).size()===1)
            $.each(object, function(key,value){
                if(key === 'setDate') value = new_Date(value);
                $(selector).datepicker(key, value);
            });
    },    
    setDateTimePicker : function(object_data){
        console.log('CX9RentalOpenTimes.setDateTimePicker() ...');
        // console.log( CX9_Data );
        if(typeof object_data === 'object'){            
            //restore jquery time selectors//console.log(object_data);
            var starttime_selector = $(object_data['starttime_selector']).size() > 0 ? object_data['starttime_selector'] : '';
            var endtime_selector = $(object_data['endtime_selector']).size() > 0 ? object_data['endtime_selector'] : '';
            var object_starttime_selector = typeof object_data['object_starttime_selector'] === 'object' ? object_data['object_starttime_selector'] : {};
            var object_endtime_selector = typeof object_data['object_endtime_selector'] === 'object' ? object_data['object_endtime_selector'] : {};
            var startdate_selector = $(object_data['startdate_selector']).size() > 0 ? object_data['startdate_selector'] : '';
            var enddate_selector = $(object_data['enddate_selector']).size() > 0 ? object_data['enddate_selector'] : '';
            var object_startdate = typeof object_data['object_startdate'] === 'object' ? object_data['object_startdate'] : {};
            var object_enddate = typeof object_data['object_enddate'] === 'object' ? object_data['object_enddate'] : {};             
            //set starting time on selector with config
            if (typeof object_starttime_selector.config === 'object'){                
                $(starttime_selector).timepicker('remove');//remove timepicker object
                $(starttime_selector).timepicker(object_starttime_selector.config);                                  
            }            
            CX9RentalOpenTimes.CX9ApplyTimepickerSettings(starttime_selector, object_starttime_selector.settings);  //apply setting to timepicker start time selector                                           
            if (typeof object_endtime_selector.config === 'object'){                                
                $(endtime_selector).timepicker('remove');//remove timepicker object
                $(endtime_selector).timepicker(object_endtime_selector.config);                                   
            }
            CX9RentalOpenTimes.CX9ApplyTimepickerSettings(endtime_selector, object_endtime_selector.settings);  //apply setting to timepicker start time selector                                             
            if (typeof object_startdate.config === 'object' ){ 
                if($(startdate_selector).hasClass('hasDatepicker')) $(startdate_selector).datepicker('destroy');  //remove selector if handled 
                $(startdate_selector).datepicker(object_startdate.config);               
            }
            CX9RentalOpenTimes.CX9ApplyDatepickerSettings(startdate_selector, object_startdate.settings);  //apply setting to timepicker start time selector                                
            if (typeof object_enddate.config === 'object'){              
                if($(enddate_selector).hasClass('hasDatepicker')) $(enddate_selector).datepicker('destroy');  //remove selector if handled               
                $(enddate_selector).datepicker(object_enddate.config);                
            } 
            CX9RentalOpenTimes.CX9ApplyDatepickerSettings(enddate_selector, object_enddate.settings);  //apply setting to timepicker start time selector                    
        }
    },
    getSetOpenTimes : function(params , callback){
        console.log('CX9RentalOpenTimes.getSetOpenTimes() ...');
        
        if(typeof params === 'undefined') {
            return false;
        }
        
        params += '&time=' + Date.now();
            console.log(params);
        this.request(params,'config', function(data){
            console.log( params );
            console.log( data );
            var result = CX9RentalOpenTimes.CX9ServerResult(data);
            if(typeof result.station_usage !== 'undefined' && result.station_usage === '0'){
                $('.btnAction:first').prop('disabled',true);//disable button submit
                if(typeof result.error_msg !== 'undefined' && result.error_msg !== '') alert(result.error_msg); // if there is an error then give it out                
                return false;
            }
            else if (typeof result.station_usage !== 'undefined' && result.station_usage === '1') {
                $('.btnAction:first').prop('disabled',false);
            }
            if (typeof result.time_config === 'undefined') {
                return false; //do nothing if time config is not comming
            }
            var object_starttime = CX9RentalOpenTimes.getXMLDOMObjectValue(result.time_config, 'time[id="starttime"] > * ',{'step':'int','disableTimeRanges':'arrayInArray'});  
            var object_endtime = CX9RentalOpenTimes.getXMLDOMObjectValue(result.time_config, 'time[id="endtime"] > * ',{'step':'int','disableTimeRanges':'arrayInArray'});
            
            //console.log(result);
            CX9_Data.startdate = new_Date(result.selected_start_date);
            CX9_Data.enddate = new_Date(result.selected_end_date);
            CX9Contract.setDateTimeValues();

            var starttime_initial_config = $.extend(object_starttime,initial_timepicker_config);  
            var endtime_initial_config = $.extend(object_endtime,initial_timepicker_config); 
            var object_startdate = {'minDate': new_Date(result.min_start_date),'maxDate': new_Date(result.max_start_date), 'dateFormat': result.date_Format};
            var object_enddate = {'minDate': new_Date(result.min_end_date),'maxDate': new_Date(result.max_end_date), 'dateFormat': result.date_Format}; 
                object_startdate = $.extend(object_startdate, datepicker_default_params);
                object_enddate = $.extend(object_enddate, datepicker_default_params);
            var data_object = {'starttime_selector':'#abholZeit', 'endtime_selector':'#abgabeZeit',
                'object_starttime_selector':{'config':starttime_initial_config, 'settings':CX9RentalOpenTimes.getXMLDOMObjectValue(result.time_config, 'time[id="starttime"] > setTime ')},
                'object_endtime_selector':{'config':endtime_initial_config, 'settings':CX9RentalOpenTimes.getXMLDOMObjectValue(result.time_config, 'time[id="endtime"] > setTime ')},
                'startdate_selector':'#abholDatum', 'enddate_selector':'#abgabeDatum',
                'object_startdate':{'config':object_startdate, 'settings':{'setDate':result.selected_start_date}},
                'object_enddate':{'config':object_enddate, 'settings':{'setDate':result.selected_end_date}}            
            };
            
            if(typeof result.closed_days !== 'undefined'){// disable closed days if they were provided
                var closed_days_startdate = CX9RentalOpenTimes.getXMLDOMObjectValue(result.closed_days, 'day[forCalender*="startdate"] > date', {}, 'date','reason');
                var closed_days_enddate = CX9RentalOpenTimes.getXMLDOMObjectValue(result.closed_days, 'day[forCalender*="enddate"] > date', {}, 'date','reason');
                CX9RentalOpenTimes.setStationDisabledDates('startdate',closed_days_startdate); 
                CX9RentalOpenTimes.setStationDisabledDates('enddate',closed_days_enddate); 
            }
            CX9RentalOpenTimes.setDateTimePicker(data_object);
            if(typeof result.error_msg !== 'undefined' && result.error_msg !== '') alert(result.error_msg); // if there is an error then give it out
            CX9RentalOpenTimes.listenWhenStationChanged();
            CX9RentalOpenTimes.listenStartdateEvent();// listen event when startdate end date was changed
            
            if ( typeof(callback) === 'function' ) {
                callback();
            }
        });

    },
    listenWhenStationChanged : function (){
    },
    getDateTime : function(identifier){
        if(typeof identifier === 'undefined' || $.inArray(identifier,['startdate','enddate','now','session']) === -1) {
            return 'NULL';
        }
        if(identifier === 'now') {
            return moment().format().substring(0,19);
        }
        if(identifier === 'session') {
            clientStartDate = moment().format().substring(0,19);
            selectedStartDate =  moment(parseInt($('#startdatetime').val())).format().substring(0,19);
            selectedEndDate =  moment(parseInt($('#enddatetime').val())).format().substring(0,19);
            startStation = $('#startstation').val();
            endStation = $('#endstation').val();
            station_url_part = '';
            if(startStation !== 'undefined' && startStation !== ''){
                station_url_part = '&station_code='+startStation;
            }if(endStation !== 'undefined' && endStation !== ''){
                station_url_part += '&station_end_code='+endStation;
            }
            return '&clientDateStartingPoint='+clientStartDate+'&selectedStartDateTime='+selectedStartDate+'&selectedEndDateTime='+selectedEndDate+station_url_part;
        }
        var date_selector = '#abholDatum', time_selector = '#abholZeit';
        if(identifier === 'enddate') {
            date_selector = '#abgabeDatum', time_selector = '#abgabeZeit';
        }
        var time = $(time_selector).val() !== '' ? $(time_selector).val() : '00:00';
        var date = moment($(date_selector).datepicker('getDate').toISOString()).format().substring(0,11);
        return date+time+':00';
    },
    getURLMainParams : function (){
        var set_startdate = CX9RentalOpenTimes.getDateTime('startdate'), set_enddate = CX9RentalOpenTimes.getDateTime('enddate'), from_date = CX9RentalOpenTimes.getDateTime('now');
        var station = $('#startstation').val(), action = 'getInitialValues', station_url_part = '';
        console.log('getURLMainParams...');
        var station_end = $('#endstation').val();
        if(station !== 'undefined' && station !== ''){
            station_url_part = '&station_code='+station;
            action = 'getStationData';
        }if(station_end !== 'undefined' && station_end !== ''){
            station_url_part += '&station_end_code='+station_end;
        }
        return 'aktion='+action+'&clientDateStartingPoint='+from_date+'&selectedStartDateTime='+set_startdate+'&selectedEndDateTime='+set_enddate+station_url_part;
    },
    listenStartdateEvent : function(){
        $('#abholDatum,#abgabeDatum').datepicker().on('change', function(e){e.preventDefault(); e.stopPropagation(); e.stopImmediatePropagation();                
            CX9RentalOpenTimes.getSetOpenTimes(CX9RentalOpenTimes.getURLMainParams());
        });
        $('#abholZeit,#abgabeZeit').on('change',function(e){e.preventDefault(); e.stopPropagation(); e.stopImmediatePropagation();                
            CX9RentalOpenTimes.getSetOpenTimes(CX9RentalOpenTimes.getURLMainParams());
        });
    },
    getStationInfo : function (station_code){
        if(typeof station_code !== 'undefined'){ //then make the request 
           CX9RentalOpenTimes.getSetOpenTimes(CX9RentalOpenTimes.getURLMainParams());
        }
    },
    beforeShowDay : function(date) {
        var isDisabled = stationDisabledDates[stationGlobalDayIdentifier][date]; 
        if (isDisabled){ 
           return [false, '', stationDisabledDateReasons[stationGlobalDayIdentifier][date+'reason']]; 
        }
        else return [true, '', ''];
    }
};

var month = translation.Monate_kurz, week = translation.Wochentage_kurz;
var datepicker_default_params = {
    changeMonth: false,
    changeYear: false,//altField:         new_Date('2016-04-10T00:00:00'),    
    beforeShow: function(input, inst) { stationGlobalDayIdentifier = ($(input).attr('data-dayidentifier') === 'undefined')? 'startdate': $(input).attr('data-dayidentifier') ;
      setTimeout(function() {
          inst.dpDiv.find('a.ui-state-highlight').removeClass('ui-state-highlight');
      }, 100);
    },
    beforeShowDay:    CX9RentalOpenTimes.beforeShowDay,
    dayNamesMin:      [week.Sonntag,week.Montag,week.Dienstag,week.Mittwoch,week.Donnerstag,week.Freitag,week.Samstag],
    monthNamesShort:  [month.Januar,month.Februar,month.Maerz,month.April,month.Mai,month.Juni,month.Juli,month.August,month.September,month.Oktober,month.November,month.Dezember],
    monthNames:  [month.Januar,month.Februar,month.Maerz,month.April,month.Mai,month.Juni,month.Juli,month.August,month.September,month.Oktober,month.November,month.Dezember],
    firstDay:         1,
    altFormat:        '@'
};

var CX9Contract = {
    submitForm : function() {
        this.setDateTimeValues();

        switch(CX9VARS['NaviStep']) {
            case 1:
                if ( typeof CONFIG.EXTERN_STEP2 == 'undefined' || CONFIG.EXTERN_STEP2.length == 0 ) {
                    $('#contract_form').submit();
                    return true;
                } else {
                    params = '?startstation=' + CX9_Data.startstation.code +
                        '&endstation=' + CX9_Data.endstation.code +
                        '&startdatetime=' + CX9_Data.startdatetime.getTime() +
                        '&enddatetime=' + CX9_Data.enddatetime.getTime() +
                        '&PHPSESSID=' + SID;
                    
                    var category = $('#kategorie-select').val() == undefined ? -1 : $('#kategorie-select').val();
                    if ( category != -1 ) {
                        params += '&category=' + category;
                    }
                    
                    window.parent.parent.location.href = CONFIG.EXTERN_STEP2 + params;
                    return true;
                }
            case 5:
                $('#contract_form').submit();
                return true;
            case 2:
                var url     = CX9SITEURL + 'cars/setRentData';
                var data    = 'startdatetime=' + CX9_Data.startdatetime.getTime() +
                    '&enddatetime=' + CX9_Data.enddatetime.getTime() +
                    '&startstation=' + CX9_Data.startstation.code +
                    '&endstation=' + CX9_Data.endstation.code;
                CX9ajaxQuery(url, 'get', 'json', data, 'CX9Contract:ReservationButtonClick SetRentData', function(data){
                    if(data.err_msg == '') {
                        if(typeof(Cars) == 'object') {
                            Cars.updateCarGroupsByJSONAJAX('all');
                        } else {
                            console.log('Cars undefined');
                        }
                    } else {
                        console.log(data.err_msg);
                    }
                });

                return false;
        }

        return false;
    },

    setStartDateTimeGlobal : function(timestamp) {
    },
    
    setDateTimeValues: function() {
        CX9_Data.startdatetime = new Date(CX9_Data.startdate.getTime());
        CX9_Data.startdatetime.setHours(CX9_Data.startdate.getHours());
        CX9_Data.startdatetime.setMinutes(CX9_Data.startdate.getMinutes());

        CX9_Data.enddatetime = new Date(CX9_Data.enddate.getTime());
        CX9_Data.enddatetime.setHours(CX9_Data.enddate.getHours());
        CX9_Data.enddatetime.setMinutes(CX9_Data.enddate.getMinutes());

        $('#startdatetime').val(CX9_Data.startdatetime.getTime());
        $('#enddatetime').val(CX9_Data.enddatetime.getTime());
        if ( CX9_Data.startstation != null ) {
            $('#startstation').val(CX9_Data.startstation.code);
        }
        if ( CX9_Data.endstation != null ) {
            $('#endstation').val(CX9_Data.endstation.code);
        }

        var table = {
            'startstation':$('#startstation').val(),
            'endstation':$('#endstation').val(),
            'startdatetime': new Date(parseInt($('#startdatetime').val())),
            'enddatetime': new Date(parseInt($('#enddatetime').val()))
        };
    }
}


/***********/


// Class Station Start
CX9_Station = function(code, direction) {
    if(typeof(code) == 'string' && code.trim() != '' && typeof(CX9VARS.stations[code]) == 'object') {
        var data = CX9VARS.stations[code];
        this.code = data.code;
        this.name = data.name;
        this.country = data.country;
        this.stat = data.stat;
        this.street = data.street;
        this.city = data.city;
        this.zipcode = data.zipcode;
        this.phone = data.phone;
        this.fax = data.fax;
        this.email = data.email;
        this.url = data.url;
        this.shedules = data.shedules;
        this.min_vorlauf = data.min_vorlauf;
        this.direction = typeof(direction) != 'undefined' && direction == 'end' ? 'end' : 'start';
        
    }
} // Class CX9_Station End

var CX9_DateTime = {
    TIMESTAMP_CONSTS : {
      SECOND:1000,
      MINUTE:60000,
      HOUR:3600000,
      DAY:86400000
    },

    date_format : typeof(DATE_FORMAT) != 'undefined' && typeof(DATE_FORMAT.date) != 'undefined' ? DATE_FORMAT.date : 'd.m.Y',

    setZeroLeadingValue : function(val) {
      if (val < 10) { val = '0' + val; }
      return val;
    },

    getTimestampFromFormattedDate : function(formatted_date, format) {
        if (typeof format == 'undefined') {
            var format = typeof(DATE_FORMAT) != 'undefined' && typeof(DATE_FORMAT.date) != 'undefined' ? DATE_FORMAT.date : 'd.m.Y';
        }
        format = format.replace('d','dd').replace('m','mm').replace('Y','YYYY');

        var d = formatted_date.substr( format.indexOf('d'), 2);
        var m = formatted_date.substr( format.indexOf('m'), 2);
        var Y = formatted_date.substr( format.indexOf('Y'), 4);
        var t = new Date(m + '/' + d + '/' +Y);
        return t.valueOf();
    },

    getFormattedTimeFromTimestamp : function(timestamp, format) {
      if (typeof format == 'undefined') {
        var format = typeof(DATE_FORMAT) != 'undefined' && typeof(DATE_FORMAT.time) != 'undefined' ? DATE_FORMAT.time : 'H:i';
      }

      var d = new Date(timestamp);
      var h = this.setZeroLeadingValue(d.getHours());
      var m = this.setZeroLeadingValue(d.getMinutes());
      var ft = h + ':' + m;
      if(format != 'H:i') {
          ft = this.time24to12(ft);
      }
      return ft;
    },


    getWeekDay : function(date) {
      var d = new Date();
      if(typeof(date) == 'string') {
        d.setTime(this.getTimestampFromFormattedDate(date, this.date_format));
      } else {
          d.setTime(date);
      }

      var weekday = d.getDay() - 1;
      weekday = (weekday == -1) ? 6 : weekday;
      return weekday;
    },

    time24to12 : function (time) {
        var time_array = Libs.explode(':', time);

        if(parseInt(time_array[0]) > 23 || parseInt(time_array[1]) > 59) return undefined;

        if(parseInt(time_array[0]) == 0)
            return '12' + ':' + time_array[1] + ' am';
        else if(parseInt(time_array[0]) < 12 )
            return time_array[0] + ':' + time_array[1] + ' am';
        else if(parseInt(time_array[0]) == 12 )
            return '12:' + time_array[1] + ' pm';
        else {
            var time_int = parseInt(time_array[0]) - 12;
            return (time_int > 9 ? time_int : '0' + time_int) + ':' + time_array[1] + ' pm';
        }
    }, // time24to12()

    shiftToTimeInterval : function(timestamp) {
        var d = new Date(timestamp);
        d.setSeconds(0);
        d.setMilliseconds(0);
        if(d.getMinutes() > 0  && d.getMinutes() < 30 ) {
            d.setMinutes(30);
        } else if(d.getMinutes() > 30) {
            d.setHours(d.getHours() + 1);
            d.setMinutes(0);
        }

        return d.getTime();
    },

  isToday : function() {
    var now = new Date();
    return CX9_Data.startdate.getTime() == CX9_Datepicker.roundDate(now).getTime();
  }


} // Class CX9_DateTime END


CX9_Init = function() {
    console.log('CX9_Init...');
    //AK 26.02.19 Aufgabe 1103126: wenn eine Station vorbelegt ist muss direkt der stationsabhängige Aufruf gemacht werden
    if ( CX9VARS.NaviStep > 1 || $('#startstation').val()) {
        var params = 'aktion=getStationData'+CX9RentalOpenTimes.getDateTime('session');
    } else {
        if($('#startdatetime').val() != '' || $('#enddatetime').val() != ''){        
            var params = 'aktion=getInitialValues'+CX9RentalOpenTimes.getDateTime('session');
        } else {
            var params = 'aktion=getInitialValues&clientDateStartingPoint='+CX9RentalOpenTimes.getDateTime('now');
        }
        
    }
    if ( CX9VARS.NaviStep == 1 || CX9VARS.NaviStep == 2 || CX9VARS.NaviStep == 5 ) {
        CX9RentalOpenTimes.getSetOpenTimes(params);
    }

    var start_datetime = $('#startdatetime').val();
    if (start_datetime != '') {
      var startdatetime = new Date(parseInt(start_datetime));
      var startdate = startdatetime;
      startdate.setHours(0);
      startdate.setMinutes(0);
      startdate.setSeconds(0);
      startdate.setMilliseconds(0);
      var starttime = new Date(parseInt(start_datetime));
      starttime = new Date(1970,0,1, starttime.getHours(), starttime.getMinutes());
      CX9_Data.startdate = startdate;
      CX9_Data.starttime = starttime;
      CX9_Data.startdatetime = startdatetime;
    } else {
        console.log("$('#startdatetime').val() undefined!!!");
    }

    var end_datetime = $('#enddatetime').val();
    if (end_datetime != '') {
      var enddatetime = new Date(parseInt(end_datetime));
      var enddate = enddatetime;
      enddate.setHours(0);
      enddate.setMinutes(0);
      enddate.setSeconds(0);
      enddate.setMilliseconds(0);
      var endtime = new Date(parseInt(end_datetime));
      endtime = new Date(1970,0,1, endtime.getHours(), endtime.getMinutes());
      CX9_Data.enddate = enddate;
      CX9_Data.endtime = endtime;
      CX9_Data.enddatetime = enddatetime;
    } else {
        console.log("$('#enddatetime').val() undefined!!!");
    }

    code = $('#endstation').val();
    if(code != '') {
        CX9_Data.endstation = new CX9_Station(code);
        CX9_Widget.setWidgetEndStationData();
        CX9_Triger.changeEndStationTriger();
    }

    var code = $('#startstation').val();
    if(code != '') {
        $('#checkVisT').prop('disabled', false);
        CX9_Data.startstation = new CX9_Station(code);
        CX9_Widget.setWidgetStartStationData();
        CX9_Triger.changeStartStationTriger();
    }
}

var CX9_Events = {
    // 1 StartStation
    onStartStationClick : function(el) {
        console.log('CX9_Events.onStartStationClick...');
        
        jQuery('.btn-group').removeClass('open');
        
        var code = $(el).data('station').toString();
        CX9_Data.startstation = new CX9_Station(code);
        CX9_Widget.setWidgetStartStationData();
        CX9_Triger.changeStartStationTriger();

        $('#checkVisT').prop('disabled', false);
        if(CONFIG.BINET_ALLOW_ONEWAY == 1 && code != '') {
            $('.checkVisT').css('opacity', '1');
            if(!$('#checkVisT').prop('checked')) {
                CX9_Data.endstation = new CX9_Station(code);
                CX9_Widget.setWidgetEndStationData();
                CX9_Triger.changeEndStationTriger();
            }
        }
        else {
            CX9_Data.endstation = new CX9_Station(code);
            CX9_Widget.setWidgetEndStationData();
            CX9_Triger.changeEndStationTriger();
        }
        CX9RentalOpenTimes.getStationInfo(code);
    },

    // 2 StartDatum
    onStartDayClick : function() {
        console.log('CX9_Events.onStartDayClick...');
        CX9_Flags.isStartDateSelect = true;
        CX9_Data.startdate = $('#abholDatum').datepicker('getDate');
        CX9_Triger.changeStartDayTriger();
        CX9Contract.setDateTimeValues();
    },

    // 3 StartTime
    onStartTimepickerSelect : function() {
        console.log('CX9_Events.onStartTimepickerSelect...');
        CX9_Flags.isStartTimeSelect = true;
        CX9_Data.starttime = $('#abholZeit').timepicker('getTime');
        CX9_Triger.changeStartTimeTriger();
    },

    // 4 EndStation
    onEndStationClick : function(el) {
        console.log('CX9_Events.onEndStationClick...');
        
        jQuery('.btn-group').removeClass('open');
        
        var code = $(el).data('station').toString();
        CX9_Data.endstation = new CX9_Station(code);
        CX9_Widget.setWidgetEndStationData();
        CX9_Triger.changeEndStationTriger();
        
        CX9RentalOpenTimes.getStationInfo(code);
    },

    // 5 EndDatum
    onEndDayClick : function() {
        console.log('CX9_Events.onEndDayClick...');
        CX9_Flags.isEndtDateSelect = true;
        CX9_Data.enddate = $('#abgabeDatum').datepicker('getDate');
        CX9_Triger.changeEndDayTriger();
    },

    // 6 EndTime
    onEndTimepickerSelect : function() {
        console.log('CX9_Events.onEndTimepickerSelect...');
        CX9_Flags.isEndTimeSelect = true;
        CX9_Data.endtime = $('#abgabeZeit').timepicker('getTime');
    },
    
    reservierenBtnClick1: function() {
        if ( jQuery('#checkbox_AGB').prop('checked') && jQuery('#checkbox_DS').prop('checked') ) {
            $('#form_reserve').submit();
        }
    },
    
    reservierenBtnClick2: function() {
        if ( jQuery('#checkbox_AGB').prop('checked') && jQuery('#checkbox_DS').prop('checked') ) {
            PAYPAL.apps.PPP.doCheckout();
        }
    },
    
    onSearchStationInputKeyup: function(element , direction) {
        if ( direction == 'departure' ) {
            identifier = '#departureList li.ddLi';
        }
        else if ( direction == 'arrival' ) {
            identifier = '#arrivalList li.ddLi';
        }
        else {
            return false;
        }
        
        jQuery(identifier).show(); // reset
        jQuery(identifier).each(function(i,el){
            checkString = jQuery(el).attr('data-sn').toLowerCase();
            if ( !checkString.match(jQuery(element).val().toLowerCase()) ) {
                $(el).hide();
            }
        });
        
    },

    filterOptionClick: function(element) {
        categoryUid = jQuery(element).attr('category-id');
        jQuery('#kategorie-select').val(categoryUid);
    }
}
function initMap(map_order_id, x, y) {
    console.log(x);
    console.log(y);
        var uluru = {lat: x, lng: y};
        var map = new google.maps.Map(document.getElementById(map_order_id), {
          zoom: 12,
          center: uluru
        });
        var marker = new google.maps.Marker({
          position: uluru,
          map: map
        });
} 
var CX9_Triger = {
    changeStartStationTriger : function() {
        console.log('CX9_Triger.changeStartStationTriger...');
        var flagChangeEndStationTrigerRun = false;
        var station = CX9_Data.startstation;

        $('#startstation-error').hide();
        
        if(CX9_Data.endstation == null) {
            CX9_Data.endstation = CX9_Data.startstation;
            flagChangeEndStationTrigerRun = true;
        }

        this.changeStartDayTriger();
        this.changeStartTimeTriger();

        $('#startstation').val(station.code);
        $('#startstation').data('stat', station.stat);
        jQuery( '#departureStationName' ).attr('data-station' , station.code);

        var no_station_in_list = true;
        var code = CX9_Data.startstation.code;
        var return_code = CX9_Data.endstation != null ? CX9_Data.endstation.code : '';
        var return_codes = CX9VARS['ReturnStationCodes'][code];
        var $this = this;   //KR: Kann das weg?
        
        $.each(return_codes, function(idx, el){
            if(el == return_code) {
                no_station_in_list = false;
                return;
            }
        });
        
        if( no_station_in_list) {
            CX9_Data.endstation = new CX9_Station(code);
            CX9_Widget.setWidgetEndStationData();
            flagChangeEndStationTrigerRun = true;
        }

        if(flagChangeEndStationTrigerRun) {
            this.changeEndStationTriger();
        }
        
        CX9_Widget.setWidgetEndStationData();
        CX9_Widget.setWidgetEndStationListe();
    },

    changeEndStationTriger : function() {
        console.log('CX9_Triger.changeEndStationTriger...');
        var station = CX9_Data.endstation;
        $('#endstation').val(station.code);
        $('#endstation').data('stat', station.stat);
        jQuery( '#arrivalStationName' ).attr('data-station' , station.code);
    },

    changeStartDayTriger : function() {
    },

    changeStartTimeTriger : function() {
    },

    changeEndDayTriger : function() {
    },
}

var CX9_Widget = {
    setWidgetStartStationData : function() {
        var station = CX9_Data.startstation;
        $('#departure_info_link').show();
        $('#departureStationInvite').hide();
        $('#departureStationName').data('station',station.code);
        $('#departureInnerBtnDest').text(station.name);
        $('#departureStationName').show();
        jQuery('#startstationSelectList').hide();
    },

    setWidgetEndStationData : function() {
        var station = CX9_Data.endstation;
        $('#arrival_info_link').show();
        $('#arrivalStationInvite').hide();
        $('#arrivalStationName').data('station',station.code);
        $('#arrivalInnerBtnDest').text(station.name);
        $('#arrivalStationName').show();
        jQuery('#endstationSelectList').hide();
    },

    setWidgetEndStationListe : function() {
        if(CX9_Data.endstation == null) {
            CX9_Data.endstation = CX9_Data.startstation;
        }
        var start_station_code = CX9_Data.startstation.code;
        var end_station_code = CX9_Data.endstation.code;
        var available_codes = CX9VARS.ReturnStationCodes[start_station_code];

        $('#arrivalList li').show();
        $('#arrivalList li').each(function(){
            var station_code = $(this).find('div.ddBtnDest').data('station').toString();
            var visible = false;
            for (var i in available_codes) {
                if (available_codes[i] == station_code) {
                    visible = true;
                }
            }
            if (visible) {
                $(this).show();
            } else {
                $(this).hide();
            }
        });
    },

    setWidgetStartMinDate : function(date) {
    },

    setWidgetStartDate : function() {
    },

    setWidgetEndMinDate : function(date) {
    },

    setWidgetEndDate : function() {
    },

    setWidgetStarTtime : function() {
    },

    setWidgetStarMinTtime : function(time) {
    },

    setWidgetStarMaxTtime : function(time) {
    },

    setWidgetStarRangeDisabe : function(interval) {
    },


    setWidgetEndTtime : function() {
    },

    setWidgetEndMinTtime : function(time) {
    },

    setWidgetEndMaxTtime : function(time) {
    },

    setWidgetEndRangeDisabe : function(interval) {
    },
}

var ind_acl_programming = { 
        request: function(sendingParams, localStorageTarget, onAjaxSuccessFunction) {//loadingCOCIPage();
            orm_data_retriever.CX9Request(CX9SITEURL + 'libs/IND_ACL_RENTAL_TESTS&PHPSESSID=' + SID,  sendingParams, localStorageTarget, onAjaxSuccessFunction);        
        },
        getRequestData: function(identifier) {
            return orm_data_retriever.request.getRequestData(identifier);
        },
        send_rental_form : function(callback){
            var lang = ($('html').attr('lang') !== 'undefined' ) ? $('html').attr('lang') : 'DE' ;
            var params = '&AWDNo='+$('#AWDNo').val()//+'&lang='+lang;
            ind_acl_programming.request(params, 'rental_acl', function(){
                var data = ind_acl_programming.getRequestData(CX9SITEURL + 'libs/IND_ACL_RENTAL_TESTS&PHPSESSID=' + SID);
                //console.log(data.result);
                if(typeof callback === 'function') return callback();
                var errors = "", msg = "", warnings = "", output_code = "", instruction = "";
                $.each(data.result, function(k, v) {
                        //console.log(v);
                        if (v.code === 'error') errors += v.MSG + "\n";
                        if (v.code === 'warning') warnings += v.MSG + "\n";
                        if (v.code === 'msg') msg += v.MSG + "\n";
                        if (v.code === 'output') output_code += v.MSG;
                        if (v.code === 'instruction') instruction += v.MSG;
                 });
                 if (errors !== '') alert(errors);
                 if (warnings !== '') {
                        if (!confirm(warnings)) {
                            return false;
                        }
                    }               
                  return CX9Contract.submitForm();
            });
            //return false; 
        }    
};
