var Cars = {
    Cache: new Array(),
    getParams: false,
    datepicker_jump: true,

    filterOptionClick: function(element) {
        var categoryUid = $(element).attr('category-id'),
            $categoryDivs = $('div[category-id]');
        $categoryDivs.removeClass('hidden').each(function(idx,el){
            if(typeof($(el).attr('category-id')) != 'undefined' && $(el).attr('category-id').indexOf('&'+categoryUid) == -1) {
                $(el).addClass('hidden');
            }
        });
        rightHeight.init();
        this.categoryChange(categoryUid);
    },
    insertDivider: function() {
        var $lastFirstGroup = $('.group[data-firstgroup="1"]').last();
        var $lastOffer = $('.group[data-offer="1"]').last(),
            $divider = $('.divider');

        if($lastOffer.length > 0) {
            $lastOffer.after($divider);
            $divider.removeClass('hidden');
        }

        if($lastFirstGroup.length > 0) {

            $firstGroups = $('.group[data-firstgroup="1"]');
            $('.group[data-firstgroup="1"]').remove();
            $('#car_form').prepend($firstGroups);

            $lastFirstGroup.after($divider);
            $divider.removeClass('hidden');
        }
    },
    editSinglePrice: function() {
        System.Loading();
        $.ajax({
            type: "get",
            async: false,
            url: CX9SITEURL + 'cars/prices',
            data: 'cur=' + $('#currency_selection_select_box').val() + '&PHPSESSID=' + SID,
            dataType: "json",
            error: function() {
                console.log('Cars:editSinglePrice Ajax Error');
            },
            success: function(data) {
                if (data != 'Error') {
                    for (var i = 0; i < data.prices.length; i++) {
                        $('.price_single_' + data.prices[i].group).text(data.prices[i].single_price);
                        $('.price_total_' + data.prices[i].group).text(data.prices[i].total_price);
                    }
                    $('.price_symbol').text(data.symbol);
                    Cars.updateCarGroupsByJSONAJAX();
                } else {
                    console.log('Cars:editSinglePrice Ajax:success Error');
                }
            }
        });
        System.Ready();
    },
    GroupsUpdate: function() {
        $('#error_block').hide();
        System.Loading();
        $.ajax({
            type: "get",
            async: true,
            url: CX9SITEURL + 'cars/index/update',
            data: 'startstation=' + $('#startstation').val() + '&endstation=' + $('#endstation').val() + '&startdate=' + $('#startdate').val() + '&enddate=' + $('#enddate').val() + '&starttime=' + $('#starttime').val() + '&endtime=' + $('#endtime').val() + '&PHPSESSID=' + SID,
            dataType: "html",
            error: function() {
                console.log('Cars:GroupsUpdate Ajax Error');
            },
            success: function(data) {
                if (data != 'Data Error') {
                    $('#Kategorien').tabs('destroy');
                    $('#Kategorien').html(data);
                    $('#Kategorien').tabs();
                    Cars.updateCarGroupsByJSONAJAX();
                } else {
                    console.log('Cars:GroupsUpdate Ajax:success Error');
                }
            }
        });
        System.Ready();
        $('#Kategorien').tabs();
    },
    updateCarGroupsByJSONAJAX: function( loadAlgorithm ) {
        if ( typeof(loadAlgorithm) !== 'undefined' ) {
            loadAlgorithm = 'ALL';
        } else {
            loadAlgorithm = false;
        }

        jQuery('.group_preisblock').hide();
        jQuery('.preisblock_load').show();
        rightHeight.init();
        
        if ( loadAlgorithm) {
            groupIDs = new Array();
            groupsIdStandard = new Array();
            jQuery('.group').each(function(index,carObj){

                if($(carObj).data('offer')) {
                    groupIDs.push( jQuery(carObj).data('group') );
                }
                else {
                    groupsIdStandard.push( jQuery(carObj).data('group') );
                }
            });
            
            var url = CX9SITEURL + 'cars/updateAllCarGroups';
            var params = 'carGroups=' + groupIDs.join(',') +
                '&carGroupsStandard=' + groupsIdStandard.join(',') +
                '&startStation=' + jQuery('#startstation').val() +
                '&endStation=' + jQuery('#endstation').val() +
                '&startDatetime=' + jQuery('#startdatetime').val() +
                '&endDatetime=' + jQuery('#enddatetime').val();

            CX9ajaxQuery(url , 'get' , 'json' , params , 'Cars:updateCarGroupsByJSONAJAX' , function(data) {
                for (index in data) {
                    curGrpData = data[index];

                    var $dom = null

                    if(curGrpData.offer) {
                        $dom = $('.group[data-group="' + curGrpData.group + '"][data-offer="1"]');
                    }
                    else {
                        $dom = $('.group[data-group="' + curGrpData.group + '"][data-offer=""]');
                    }

                    if ( curGrpData.no_rate != 1 ) {
                        $dom.children().find('#availability-plan_'+curGrpData.group).html(curGrpData.html);
                        $dom.children().find('.group_no_price').hide();
            
                        var rate = curGrpData.rate;
                        $dom.children().find('.priceTag_'+curGrpData.group).html(rate.total_price_single_formatted);
                        $dom.children().find('.totalPrice_'+curGrpData.group).html(rate.gesamtpreisbrutto_formatted);
                        $dom.children().find('.einheit_text_'+curGrpData.group).text(rate.Einheit_text);
                        if(rate.is_angebot) {
                            $dom.children().find('#aktion_'+curGrpData.group).removeClass('hidden');
                        }
                        else {
                            $dom.children().find('#aktion_'+curGrpData.group).addClass('hidden');
                        }
                        if(curGrpData.available) {
                            $dom.children().children().find('.group_unavailable').hide();
                            $dom.children().find('.submit_button_'+curGrpData.group).show();
                        }
                        else {
                            $dom.children().find('.group_unavailable').show();
                            $dom.children().find('.submit_button_'+curGrpData.group).hide();
                        }
                        $dom.children().find('.preisblock_' + curGrpData.group).show();
                        rightHeight.init();
                    } else {
                        $dom.children().find('.submit_button_'+curGrpData.group).hide();
                        $dom.children().children().find('.group_no_price').show();
                        console.log('Cars:updateCarGroupsByJSONAJAX NO RATE');
                    }
                    $dom.children().find('.load_' + curGrpData['group']).hide();
                }
            });
        } else {
            $('.group').each(function(idx, car){
                var url = CX9SITEURL + 'cars/updateCarGroups';
                var groupID = $(car).data('group');
                
                console.log('Cars.updateCarGroupsByJSONAJAX() groupID:' + groupID);
                
                var data =  'car_group_id=' + groupID +
                            '&startstation=' + $('#startstation').val() +
                            '&endstation=' + $('#endstation').val() +
                            '&startdatetime=' + $('#startdatetime').val() +
                            '&enddatetime=' + $('#enddatetime').val();
                CX9ajaxQuery(url, 'get', 'json', data, 'Cars:updateCarGroupsByJSONAJAX', function(data) {
                    if(data.no_rate != 1) {
                        $('#availability-plan_'+groupID).html(data.html);
                        $(car).children().find('.group_no_price').hide();

                        var rate = data.rate;
                        $('.priceTag_'+groupID).text(rate.total_price_single);
                        $('.totalPrice_'+groupID).text(rate.gesamtpreisbrutto);
                        $('.einheit_text_'+groupID).text(rate.Einheit_text);
                        if(rate.is_angebot) {
                            $('#aktion_'+groupID).removeClass('hidden');
                        } else {
                            $('#aktion_'+groupID).addClass('hidden');
                        }
                        if(data.available) {
                            $(car).children().find('.group_unavailable').hide();
                            $('.submit_button_'+groupID).show();
                        } else {
                            $(car).children().find('.group_unavailable').show();
                            $('.submit_button_'+groupID).hide();
                        }
                        $('.preisblock_' + groupID).show();
                        rightHeight.init();
                    } else {
                        $('.submit_button_'+groupID).hide();
                        $(car).children().find('.group_no_price').show();
                        console.log('Cars:updateCarGroupsByJSONAJAX NO RATE');
                    }
                    $('.load_' + groupID).hide();
                });
            });
        }
        $('#close-button').click();
    },
    StartEndStationClick: function(startend) {
        var url = Libs.parseURL();
        var region = '';
        var startstation = $('#startstation').val();
        if (typeof url.region !== 'undefined') {
            region = url.region;
        }
        var block = '#blockSelStartStation';
        var stations_typ = 'dep';
        if (startend == 'end') {
            block = '#blockSelEndStation';
            stations_typ = 'arr';
        }
        if (!Cars.getParams) {
            $('#backgroundFilter').show();
        }
        if (Cars.Cache[block] == undefined || startend == 'end') {
            var data = 'stations_typ=' + stations_typ;
            if (region != '') {
                data += '&region=' + region;
            }
            if (stations_typ == 'arr') {
                data += '&startstation=' + startstation;
            }
            $.ajax({
                type: "get",
                async: false,
                url: CX9SITEURL + 'rental/getstationsblock',
                data: data,
                dataType: "html",
                error: function() {
                    console.log('Cars:StartEndStationClick Ajax Error');
                },
                success: function(data) {
                    if (data != 'Data Error') {
                        Cars.Cache[block] = true;
                        $(block).replaceWith(data);
                    } else {
                        console.log('Cars:StartEndStationClick Ajax:success Error');
                    }
                }
            });
        }
        var block_error_height = 0;
        if ($('#error_block').height() != null) {
            var margin_bottom = $('#error_block').css('margin-bottom');
            margin_bottom = parseInt(margin_bottom.replace('px', ''));
            block_error_height += $('#error_block').height() + margin_bottom;
        }
        var offset = 150;
        if (startend == 'end') {
            offset += 30;
        }
        $(block).css('top', (offset + block_error_height) + 'px');
        $(block).css('left', '910px');
        if (!this.getParams) {
            $(block).show();
        }
        this.date_cache_save();
    },
    BackgroundFilterClick: function() {
        $('#backgroundFilter').hide();
        $('#blockSelStartStation').hide();
        $('#blockSelEndStation').hide();
        $('#pDateTimeTop').hide();
        $('#pDateTimeBottom').hide();
        $('#subrate_container').hide();
        if (!this.is_date_cache_equal()) {
            Rental.GetDateTime();
            Rental.DateTimeClose();
        }
    },
    BtnSubmit: function(group_code, offer) { // Es wird nochmal �berpr�ft, ob das Auto in der Zeit, der Auswahl von jmd. anderen reserviert wurde.
        if (CONFIG['CONFIG_CHECK_AVAILABILITY'] || CONFIG['CONFIG_SHOW_AVAILABILITY_PLAN']){ 
            var selected_start_date = orm_data_retriever.request.getRequestData(CX9SITEURL + 'libs/systemControlOpenningTimes&PHPSESSID=' + SID).result[0]['selected_start_date'];
            var selected_end_date = orm_data_retriever.request.getRequestData(CX9SITEURL + 'libs/systemControlOpenningTimes&PHPSESSID=' + SID).result[0]['selected_end_date'];
            var url = CX9SITEURL + 'cars/belegungsStatus';
            var data = '&data=' + group_code +
                        '&selected_start_date=' + selected_start_date +
                        '&selected_end_date=' + selected_end_date;                     
            orm_data_retriever.CX9Request(url,  data, 'server_response', function(server_response){
                if (server_response.result===true) {

                    $('#useOffer').val(offer);
                    $('#car_group').val(group_code);
                    $('#car_form').submit(); 
                    return true;
                }
                else{
                     $('#errornocar_'+group_code).show();
                     return false;
                }
            });
        }else{
            $('#car_group').val(group_code);
            $('#useOffer').val(offer);
            $('#car_form').submit(); 
        }
    },
    DateTimeClick: function() {
        var block_error_height = 0;
        if ($('#error_block').height() != null) {
            var margin_bottom = $('#error_block').css('margin-bottom');
            margin_bottom = parseInt(margin_bottom.replace('px', ''));
            block_error_height += $('#error_block').height() + margin_bottom;
        }
        $('#pDateTimeTop').css('top', (235 + block_error_height) + 'px');
        $('#pDateTimeTop').css('left', '460px');
        $('#pDateTimeBottom').css('top', (235 + block_error_height) + 'px');
        $('#pDateTimeBottom').css('left', '950px');
        //			$('#pDateTimeTop').css('background', 'url("templates/images/bg_white_kfz_date_time.png") no-repeat scroll 0px 0px transparent');
        //			$('#pDateTimeBottom').css('background', 'url("templates/images/bg_white_kfz_date_time.png") no-repeat scroll 0px 0px transparent');
        $('#backgroundFilter').show();
        $('#pDateTimeTop').show();
        $('#pDateTimeBottom').show();
        System.datepicker_jump = false;
        this.date_cache_save();
    },
    BtnAlternative: function(date_time_start, date_time_end) {
        $('#startdate').val(date_time_start.substr(0, 10));
        $('#starttime').val(date_time_start.substr(11, 6));
        $('#enddate').val(date_time_end.substr(0, 10));
        $('#endtime').val(date_time_end.substr(11, 6));
        this.GroupsUpdate();
        //date_time.substr(0,10)
        //date_time.substr(11,6)
        return false;
    },
    categoryChange: function(category) {
        $.get(CX9SITEURL + 'cars/categoryChange/?category=' + encodeURIComponent(category));
    }, // categoryChange()
    date_cache_save: function() {
        this.Cache['startdate'] = $('#startdate').val();
        this.Cache['enddate'] = $('#enddate').val();
        this.Cache['starttime'] = $('#starttime').val();
        this.Cache['endtime'] = $('#endtime').val();
        this.Cache['startstation'] = $('#startstation').val();
        this.Cache['endstation'] = $('#endstation').val();
    }, // date_cache_save
    is_date_cache_equal: function() {
            var a = this.Cache['startdate'] == $('#startdate').val() && this.Cache['enddate'] == $('#enddate').val() && this.Cache['starttime'] == $('#starttime').val() && this.Cache['endtime'] == $('#endtime').val() && this.Cache['startstation'] == $('#startstation').val() && this.Cache['endstation'] == $('#endstation').val();
            return a;
        }, // is_date_cache_equal
    //FW 17.01.18
    sendContactFormClick: function(){
        $.ajax({
                type: "post",
                async: false,
                url: CX9SITEURL + 'cars/sendContactFormMail',
                data: $('#form-contact').serialize(),
                dataType: "json",
                error: function() {
                    console.log('Cars:sendContactFormClick Ajax Error');
                },
                success: function(data) {
              
                    if (data.mail == true) {
                        $('#KLModalContact').modal("hide");
                        $('#KLModalMailSuccess').modal();
                        $('.modal-backdrop').appendTo('.KLModal-content');
                    } else {
                        console.log('Cars:sendContactFormClick Ajax:success Error');
                    }
                }
            });
    }        

};
